#########################
#
# dbengine_action.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken �ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Local Library for executing special standardactions und starting the
# executing of all other actions
#
########################

#use strict;

my $rparms;
my $rconfigs;
my $qu;

sub action_init {
        ($rconfigs,$rparms,$qu) = @_;
}

#
# This routine evaluates the given action or report
#
sub action_doAction {
        local *parms   = $rparms;
        local *configs = $rconfigs;

        #
        # First lets open the databases: the defining and the ordered
        #
        &db_db_conn(1);

        # Now getting the action from the database dbinfo
        #
        &dbprint_hash(9,"action_doAction: rparms=|$rparms|, params",\%parms);
        my $actionname = $parms{'actionname'};
        my ($db_owner, $sch_owner) = &db_db_get_owner;

        my %std_actions;
        &dbprint_hash(9,"doAction: configs",$rconfigs);
        my $std_actions = $configs{'std_actions'};
        $std_actions = "" unless $std_actions;
        foreach my $userlist ( split(/;/,$std_actions) ) {
                my ($s_user,$s_actions) = split(/:/,$userlist);
                my @a_actions           = split(/,/,$s_actions);
                foreach my $a_action (@a_actions) {
                        $a_action = $1 if ($a_action =~ /^s+([^\s].*)$/);
                        $a_action = $1 if ($a_action =~ /^(.*[^\s])\s+$/)
                        &dbprint(7,"action_doAction: actionname=|$actionname|, a_action=|$a_action|, s_user=|$s_user|");
                        if ($a_action eq 'ALL' || $actionname =~ /^$a_action$/) {
                                $std_actions{$actionname} .= ",$s_user";
                        }
                }
#                $std_actions{$s_actions} = $s_user;
        }
        &dbprint_hash(7,"action_doAction:std_actions",\%std_actions);
        my $comm   = qq{SELECT * FROM Action WHERE actionname = '$actionname' } .
                     qq{AND (dbasename = '} . $parms{'dbasen'} . q{' OR dbasename = '__ALL')};
        &dbprint_hash(9,"action_doAction: parms",$rparms);
        &dbprint(7,"action_doAction: actionname=|$actionname|, comm=|$comm|");
        my $result = &db_db_get('dbdesc', $comm);
        my $retval;
        my $everr   = 1;        # Error setting by default
        my $border  = 3;
        my $spacing = 10;
        my $ext_result;
        my $dispn;
        my $report;

        my $rarray;
        unless ($rarray = &db_db_hashref($result)) {
#                dbError(&gtext('noaction',"'$actionname'"));
                $retval = &gtext('noaction',$actionname,$parms{'dbasen'});
        } else {

                my $actiontext = $$rarray{'actiontext'};
#                $actiontext    =~ tr/\r/ /;
                my $user       = $$rarray{'usernames'};
                $user         .= ",$std_actions{$actionname}" if ($std_actions{$actionname});
                dbprint(7,"action_doAction: userliste=|$user|");
                $report        = $$rarray{'report'};
                $ext_result    = $$rarray{'ext_result'};
                $dispn         = $$rarray{'displayname'};
                $report        = 0 unless $report;
                $result->finish;                        # Ending the fetchcycle

                unless ( &db_check_usernames($user,$db_owner,$sch_owner) ) {
                        $retval = &gtext('actionforbidden',$actionname,$$rparms{'user'});
                } else {
#                        &pr_list_start(&db_get_disptext($dispn,$actionname));
                        print "<!-- " . &db_get_disptext($dispn,$actionname) . " -->";

                        $retval = eval ($actiontext);
                        $everr  = ($@ ? $@ : "");                 # true if error in eval
                        $retval = "<PRE>$@</PRE>" if $@;
                }
        }

        &dbprint(7,"doAction: everr=|$everr|, retval = |$retval|, ext_result=|$ext_result|");

        if ($everr || $ext_result) {
                $dispn = &gtext($1) if ( $dispn && $dispn =~ /^\s*lang\((.+)\)\s*$/);
                print "<DIV ALIGN=CENTER><TABLE WIDTH=50% BORDER=$border CELLSPACING=$spacing CELLPADDING=$spacing>";
                print "<TR><TH>\n<H2>" . &gtext($report ? 'reporterg' : 'actionerg') . ":</H2>\n";
                print "<TR><TD><H3>" . $retval . "</H3></TD></TR>\n<TR><TD><H3>";
                unless ($everr) {
                        print "<FONT COLOR=green>" . &gtext($report ? 'repoerg' : 'acterg', $dispn) .
                              "</FONT></H3></TABLE></DIV>\n";
                } else {
                        print "<FONT COLOR=red>" . &gtext($report ? 'reponoerg' : 'actnoerg', $dispn) .
                              "</FONT></H3></TABLE></DIV>\n";
                }
        }

        &pr_db_finish;
        &db_db_disc;    # Ending the database-connections

}

#
# Einlesen eines Hilfe-files und Auswahl der richtigen Hilfestelle
#
sub action_get_help {
        my $actionname = shift;
        my $helpname   = shift;
        my $helppath   = $$rconfigs{'refdb'};
        my $helpstr;
        my $dbase = $$rparms{'dbasen'};
        my @bind_values;
        my @langs = split(/,/,$$rconfigs{'langs'}) unless (@langs);
        my $cmd   = "SELECT * FROM helpfile WHERE (dbasename = '$dbase' OR dbasename = '__ALL')" .
                         " AND actionname = '$actionname' AND (languages = ? OR languages = 'ALL')" .
                         " AND helpname = '$helpname'";
        foreach my $lang (@langs) {
                @bind_values = ($lang);
                my $stdh = &db_db_get('dbdesc',$cmd,\@bind_values);
                &dbprint(9,"db_gtextb: langs=|$$rconfigs{'langs'}|, lang=|$lang|");

                my $rarray = &db_db_hashref($stdh);
                next unless $rarray;
                &dbprint_hash(9,"db_gtextb: configs{'lang'}=|$$rconfigs{'lang'}|, rarray",$rarray);
                $helpstr = $$rarray{'helptext'};
                $stdh->finish if $stdh;
                last if $helpstr;
        }

        &dbprint_hash(7,"action_get_help: configs",$rconfigs);
        &dbprint(7,"action_get_help: actionname=|$actionname|, helpname=|$helpname|, file=|$helppath/help_$actionname.hlp|");
        $helpstr = &gtext('no_hlp_fd') unless $helpstr;
        return ($helpstr);
}


1;
