#########################
#
# dbengine_crMenu.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Modul zum Erzeugen des Menus im Menuframe
#
########################

my $rparms;
my $rconfigs;
my $qu;

sub crMenu_init {
        ($rconfigs,$rparms,$qu) = @_;
        &dbprint(7,"crMenu_init: configs=|$rconfigs|, parms=|$rparms|");
        &dbprint_hash(7,"crMenu_init: rparms=|$rparms|, parms",$rparms);
        &dbprint_hash(7,"crMenu_init: rconfigs=|$rconfigs|, configs",$rconfigs);
}

#
# Creating the Menu in the left frame for using the database
#
sub crMenu_createMenu {
        local *parms   = $rparms;
        local *configs = $rconfigs;
        #
        # First lets open the databases: the defining and the ordered
        #
        &db_db_conn(1);

        #
        # let's generate a list with all available tables in $dbase,
        # beginning with the headline of our window
        &pr_men_frame_kopf;
        &dbprint_hash(7,"crMenu_createMenu: rparms=|$rparms|, parms",$rparms);
        &dbprint_hash(7,"crMenu_createMenu: rconfigs=|$rconfigs|, configs",$rconfigs);

        my $dbase   = $parms{'dbase'};
        my $dbasen  = &dbase_get_name($dbase);
        my $dbdesc  = $parms{'dbdesc'};
        my $dbdescn = &dbase_get_name($dbdesc);

        my $kennz   = "mode=plain&dbase=$dbase&kennz=$parms{'kennz'}";
        my ($db_owner, $sch_owner) = &db_db_get_owner;

        #
        # check the user if she has permission to access the database
        my $cmd  = "SELECT username from dbengine_user where dbasename = '$dbasen'";
        my $erge = &db_db_get('dbdesc',$cmd);
        my $rusername = &db_db_hashref($erge);
        my $username  = $$rusername{'username'};
        $erge->finish;
        &dbError(&gtext('usedbnot',$dbasen)) unless(&db_check_usernames($username,$db_owner,$sch_owner));

        #
        # Grouping the Tables along with the Details of BaseDesign
        #    First we ask the table 'valuelist' for the names of the groups
        #
        $cmd = "SELECT display, content, orderno FROM valuelist WHERE name='tableart' AND DBaseName=\'$dbdescn\' ORDER BY orderno";
        $erge = &db_db_get('dbdesc',$cmd);
        &dbprint(9,"createMenu: db_kommando=|$cmd|, erge=|$erge|");

        my $alt = 0;
        my @array;
        my @desarray;
        my @darray = &db_db_tables;	# Tabellen aus der Datenbank

        while (my $rarray = &db_db_hashref($erge)) {	# Tabellenbeschreibungen aus dbinfo-Datenbank: Haupttabellen, ...
                &dbprint_hash(10,"createMenu rarray",$rarray);
                my $tablen = $$rarray{'content'};
                push(@array, $tablen);
        }
        foreach my $name (@array) {	# Je nach Wertigkeit die Tabellen ausgeben
                $cmd = q{SELECT tablename, tableorder, displayname, username FROM basedesign} .
                       qq{ WHERE tableart = \'$name\' AND dbasename = \'$dbasen\' ORDER BY tableorder};
                &dbprint(10,"createMenu: db_kommando=|$cmd|, name=|$name|");
                $erge = &db_db_get('dbdesc',$cmd);
                &dbprint(10,"createMenu: db_kommando=|$cmd|, name=|$name|, erge1=|$erge|");

                my @tables = ();
                my $anz    = 0;
                while (my $rarray = &db_db_hashref($erge)) {
                        &dbprint_hash(7,"createMenu rarray",$rarray);
                        my $table = $$rarray{'tablename'};
                        my $found = 0;
                        push(@desarray,$table);
                        $alt++;
                        next unless (&db_check_usernames($$rarray{'username'},$db_owner,$sch_owner));
                        $tables[$anz]{'table'} = $table;
                        $tables[$anz]{'dispn'} = &db_get_disptext($$rarray{'displayname'},$table);
                        $anz++;
                }
                if (@tables) {
                        print "<HR><TABLE WIDTH=100% BORDER=3 CELLPADDING=5><TR><TH>" . &gtext($name) . ":\n";
                        for (my $i = 0; $i < @tables; $i++) {
                                print qq{<TR><TD><A Href=\"dbengine.cgi?$kennz&table=} . $tables[$i]{'table'} .
                                      qq{\" TARGET=body>} . $tables[$i]{'dispn'} . qq{</A>\n};
                        }
                        print "</TABLE>\n";
                }
        }
        &dbprint(7,"Anzahl Stze aus dbinfo=|$alt|");

        # if there are tables without description in BaseDesign take a default
        #
        # and print a HREF for every record
        &dbprint(7,"createMenu: Satzzahlen: desarray=|%d|, darray=|%d|, alt=|$alt|",$#desarray,$#darray);
        if (@darray > $alt) {
                print "<HR><TABLE WIDTH=100% BORDER=3 CELLPADDING=5><TR><TH>" . &gtext('tables') . ":\n";

                foreach my $darray (@darray) {
                        my $found = 0;
                        if ($alt > 0) {
                                foreach my $array (@desarray) {
                                        if ($array eq $darray) {
                                                $found = 1;
                                                last;
                                        }
                                }
                        }
                        next if $found;
                        print "<TR><TD><A HREF=\"dbengine.cgi?$kennz&table=$darray\" TARGET=body>" .
                        &upfirst($darray) . "</A>\n";
                }
                print "</TABLE>\n";
        }

        #
        # next we search for actions and reports in table action of dbdesc
        #
        $kennz = "mode=action&dbase=$dbase&kennz=$parms{'kennz'}";
        my %std_actions;
        foreach my $s_actionlist (split(/;/,$configs{'std_actions'})) {
                my ($userwert,$s_actionlist) = split(/:/,$s_actionlist);
                foreach my $s_action (split(/,/,$s_actionlist)) {
                        $s_action = $1 if ($s_action =~ /^\s*(\S+)\s*$/);
                        $s_action = $1 if ($s_action =~ /^'(\S+)'$/);
                        $s_action = $1 if ($s_action =~ /^"(\S+)"$/);
                        $std_actions{$s_action} .= "," if ($std_actions{$s_action});
                        $std_actions{$s_action} .= $userwert;
                }
        }
        &dbprint_hash(7,"createMenu: std_actions",\%std_actions);
        foreach my $was ('actions', 'reports') {
#                $cmd = qq{SELECT actionname, usernames FROM action WHERE (dbasename = \'$dbasen\' OR actionname LIKE '\_\_STD\_%')} .
                $cmd = qq{SELECT * FROM action WHERE (dbasename = \'$dbasen\' OR actionname LIKE '\_\_STD\_%')} .
                       " AND report = " . ($was eq 'actions' ? "'f'" : "'t'") . " ORDER BY actionorder";
                &dbprint(7,"createMenu: was=|$was|, cmd=|$cmd|");
                $erge = &db_db_get('dbdesc',$cmd);

                my @actions = ();
                my $i       = 0;
                # while - Schleife: get every record allowed for the actual user
                while (my $rarray = &db_db_hashref($erge)) {
                        &dbprint_hash(9,"createMenu: was=|$was|, rarray",$rarray);
                        next unless ($$rarray{'in_list'});
                        my $action   = $$rarray{'actionname'};
                        my $username = $$rarray{'usernames'};  # allowed users for this action by actiondefinition
                        &dbprint(7,"createMenu: action=|$action|, username=|$username|");
                        $username .= ",$std_actions{$action}" if ($std_actions{$action} ); # also allowed users for standard-actions
                        next unless (&db_check_usernames($username,$db_owner,$sch_owner));
                        $actions[$i]{'dispn'} = &db_get_disptext($$rarray{'displayname'},$action);
                        my $href = "";
                        if ($$rarray{'actiontext'} =~ /^URL\s*=\s*(.*[^\s]+)\s*$/ ) {
                                $href = qq{<TR><TD><A HREF="$1" TARGET=body>};
                        } else {
                                $href = qq{<TR><TD><A HREF="dbengine.cgi?$kennz&actionname=$action" TARGET=body>};
                        }
                        $actions[$i]{'href'}   = $href;
                        $i++;
                }
                # FOR -Schleife: print a HREF for every record
                if (@actions) {
                        print "<HR><TABLE WIDTH=100% BORDER=3 CELLPADDING=5><TR><TH>" . &gtext($was) . ":\n";
                        for ($i = 0; $i < @actions; $i++ ) {
                                print $actions[$i]{'href'} . $actions[$i]{'dispn'} . "</A>\n";
                        }
                        print "</TABLE>\n";
                }
        }

        &db_db_disc;	# Ending the database-connections

        &pr_db_finish;	# Finishing the Output
}


1;
