############################
#
# dbengine_debug.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.2
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
# Version 1.01
# <c> 1997, 1998, 1999 Detlef Duerr
# get closer Information from email Detlef.Duerr@atm-computer.de
# older version
# <c> 1996 Ingo Ciechowski
# see closer information at http://www.cis-computer.com/dbengine
#
#  Output Library for dbengine.pl new Version
#
#  Routinen zur Ausgabe von Debug-Informationen
#
##########################

my $debug;
my $debug_co;
my $debug_file;
my $debfile;
use FileHandle;
sub dbstart {
        ($debug, $debug_co, $debug_file) = @_;
        if ($debug >= 11 || $debug_file) {
                $debfile = DEBUG if( open(DEBUG,">/tmp/..db_debug.$$"));
                autoflush DEBUG 1;
        }
        $| = 1;    # autotflush  to standardchannel
}

sub dbprint {
        my $level = shift;
        if ($level <= $debug) {
                my $format = shift;
                my @pars   = @_;
                my $out_test = ( $level > 2 ? "<P>Test " : "<BR>" );
                $out_test .= "$format<BR>\n";
                $out_test  = "\n<!-- \n" . $out_test if ($debug_co && $level != 1);
                if (@pars) {
                        if($debfile) {
                                printf $debfile $out_test,@pars;
                        } else {
                                printf $out_test,@pars;
                        }
                } else {
                        if($debfile) {
                                print $debfile $out_test;
                        } else {
                                print $out_test;
                        }
                }
                print "<P>\n" unless $debfile;
                print "\n -->\n" if ($debug_co && $level != 1 && !$debfile);
        }
}

sub dbprint_cmd_binds {
        my ($level, $cmd, @bind_values) = @_;

        for (my $i=0; $i < @bind_values; $i++) {
                $bind_values[$i] = &pr_quote($bind_values[$i]);
        }

        my $ausgabe = "<table>\n<tr><td>" . gtext('cmd') . ":</td><td>" . &pr_quote($cmd) . "</td></tr>\n<tr><td>" .
                             gtext('binds') . ":</td><td>|" . join("|,|",@bind_values) . "|</td></tr>\n</table>";
        if ($level > $debug) {
                $level = $debug;
                $ausgabe = gtext('cmd') . ": $cmd\n" . gtext('binds') . ": |" . join("|,|",@bind_values) . "|\n";
        }
        &dbprint($level, $ausgabe);
}

sub dbprint_hash {
        my ($level, $name, $rhash) = @_;
        if ( $debug >= $level) {
                my $output = "dbprint_hash($name):<BR>\n";
                foreach my $hkey (sort keys %$rhash) {
                        my $wert = $$rhash{$hkey};
                        if (defined $wert) {
                                $output .= "        hkey=|$hkey|, wert=|$wert|<BR>\n";
                        } else {
                                $output .= "        hkey=|$hkey|, wert=||<BR>\n";
                        }
                }
                &dbprint($level,$output);
        }
}

sub dbprint_hash_hash {
        my ($level, $name, $rhash) = @_;
        if ( $debug >= $level ) {
                foreach my $hkey (sort keys %$rhash) {
                        my $rhashf = $$rhash{$hkey};
                        &dbprint_hash($level, $name . "{" . $hkey . "}", $rhashf);
                }
        }
}

sub dbprint_array_hash {
        my ($level, $name, $rarray) = @_;
        if ( $debug >= $level ) {
                for ( my $i = 0; $i < @$rarray; $i++) {
                        my $wert = $$rarray[$i];
                        $wert    = "" unless $wert;
                        &dbprint_hash($level, $name . "[$i]",$wert);
                }
        }
}

sub dbprint_array {
        my($level, $name, $rarray) = @_;
        if ( $debug >= $level) {
                my $output = "dbprint_array:$name<BR>\n";
                for (my $i = 0; $i < @$rarray; $i++) {
                        my $wert = $$rarray[$i];
                        $wert    = "" unless $wert;
                        $output .= "        [$i]=|$wert|<BR>\n";
                }
                &dbprint($level,$output);
        }
}


sub dbprint_inits {
        local *configs = shift; local *parms = shift; local *env = shift;

        &dbprint(11,"dbprint_inits: configs=|".%configs."|, parms=|".%parms."|");

        if (%env) {
                foreach my $envkey (keys %env) {
                        &dbprint(11,"ENV: envkey=|$envkey|, wert=|$env{$envkey}|");
                }
        }


        if (%configs) {
                foreach my $config ( keys %configs) {
                        &dbprint(11,"conf-daten: key=|$config|, wert=|$configs{$config}|") if $configs{$config};
                }
        }

        if (%parms) {
                foreach my $keyparm ( keys %parms) {
                        &dbprint(11,"main: keyparm=|$keyparm|, wert=|%s|",$parms{$keyparm});
                }
        }
}

1;
