#########################
#
# dbengine_listtable.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Local Library for executing special standardactions und starting the
# executing of all other actions
#
########################

#use strict;

my $qu;
my $rconfigs;
my $rparms;
my $rfielddesc;
my $rrelations;
my $rvalues;
my $rbuttons;

#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
sub listtable_init {
        ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;
}

#
# Routine zur Ausgabe eines Listings aufgrund einer 'such'-Anweisung
#
sub listtable {
        local *parms    = $rparms;
        my $fields      = $parms{'fields'};
        my $kennz       = $parms{'kennz'};
        my $suche;
        my @bind_values;
        my %tableDesign;
        my $table = $parms{'table'};
        my $dbase = $parms{'dbase'};
        if ($fields) {
                $suche  = "WHERE $fields = ? ";
                push(@bind_values,$parms{'value'});
        } else {
                $suche       = "WHERE ";
        }
        my $search     = $parms{'search'};
        $search        = 0 unless $search;
        my $recno_s    = $parms{'recno'};
        my $recno      = $recno_s;
        my $maxrecno   = $$rconfigs{'maxrecno'};
        $maxrecno      = $parms{'maxrecno'} if $parms{'maxrecno'};
        my $maxrecno_n = $maxrecno + $recno;

        &db_getTableDesign(\%tableDesign);
        $fields             = (($tableDesign{'tableFields'}) ? $tableDesign{'tableFields'} : "a.*");

        my $tableModifyable = $tableDesign{'tableModifyable'};
        my $tableItem       = $tableDesign{'tableItem'};
        my $statement       = $parms{'statement'};

        $statement = 0 if (!$statement || $statement =~ /select\s*$/i );

        unless($statement || $search) {
                &dbprint(7,"pr_listTable: statement=|$statement|, search=|$search|");
                # There is no special 'SELECT' - Statement given
                # And there is also no earlier search by an tableList done
                # dann denken wir an die vom Anwender gewnschten (weil in Feldern des
                # Formulars eingetragenen) Sucheinschrnkungen
                foreach my $nameq ($qu->param) {
                        #
                        # wobei natrlich unsere Programmargumente und der Submit-Button nicht bedacht werden
                        # auch leere Felder interessieren uns nicht. Auerdem nicht das Feld 'tmin', das nur zur Prfung
                        # der Berechtigung von update- und delete-Operationen auf einer speziellen oid bentigt wird.
                        # Daher sind alle Felder vor dem Eintrag mit der Namensverlngerung '__' versehen, die fr die SQL-Anfrage
                        # wieder entfernt werden muss.
                        next unless ($nameq =~ /^__(.+)$/);
                        my $name = $1;
                        my $fdisplay = $$rfielddesc{$name}{'DISPLAY'};
                        next if($fdisplay && $fdisplay eq 'COMPUTATION');
                        my @quer_wert = $qu->param($nameq);
                        my $quer_wert = $parms{$nameq};
                        &dbprint(7,"listTable: name=|$name|, quer_wert=|$quer_wert|");
                        unless( !$quer_wert || length($quer_wert)>100) {
                                $quer_wert = &db_value2SQL(\$suche,\@bind_values,$name,\@quer_wert);
#                                &dbprint(7,"pr_listTable: suche=|$suche|,\nbinds=|@bind_values|, name=|$name|, wert=|$quer_wert|");
                        }
                }
                &dbprint(7,"pr_listTable: suche=|$suche|, binds=|@bind_values|");
                #
                # wenn wir keine echten Sucheingaben gefunden haben, dann
                # entfllt auch der WHERE-Clause in der SQL-Abfrage
                if($suche eq "WHERE ") {
                        $suche = "";
                } else {
                        #
                        # sonst mssen wir hat das letzte "AND " wegschmeissen...
                        $suche = $1 if ($suche =~ /^(.+\s+)AND\s*$/);
                }
                if ($tableDesign{'tableQuery'}) {
                        $_         = $suche;    # bisherigen Wert der Suche fr eval bereitstellen
                        my $retVal = eval ($tableDesign{'tableQuery'});
                        if ($@ || (!$retVal && $suche)) {
                                &dbWarnText(gtext("ferror", $table), $@);
                        } else {
                                $suche = $retVal;
                        }
                }
                my $tablex = $table;
                my $schemax = "";
                $tablex = $2, $schemax = qq{"$1".} if ( $table =~ /^(.+)\.([^\.]+)/ );
                $search = qq{SELECT a.oid, $fields FROM $schemax"$tablex" a $suche};
        } elsif ( $statement ) {
                my $sfields;
                my $stables;
                my $conds = "";
                my $oid   = "oid";
                $tableModifyable = 0;
                $tableItem       = 0;

                #is the Search-command in this form allowed?
                &dbError(&gtext('selectonly')) unless ($statement =~ /^select /i);
                if ($statement =~ /^select\s+(.+)\s+from\s+(.+)\s*$/i ) {
                        $sfields = $1;
                        $stables = $2;
                        #There is no subselect allowed
                        &dbError(&gtext("nosubsel")) if($sfields =~ /\sselect\s/i  || $stables =~ /\sselect\s/i );

                        #DIVIDING THE STATEMENTPART BEHIND FROM IN FORM-PART AND CONDITION-PART
                        if ($stables =~ /^\s*(.+)\s+(where\s+.+)$/i ) {
                                $stables = $1;
                                $conds   = $2;
                        }

                        #in the list of tables after the from part, the selected table in the mask must be the first of
                        #the tables and put the <tablename>.oid to the list of fields
                        &dbprint(7,"pr_listtables: sfields=|$sfields|, stables=|$stables|, conds=|$conds|");
                        my @stables = split(/,/,$stables);
                        if (@stables > 1) {
                                my $stab = $stables[0];
                                if ($stab =~ /^\s*(\S.*)\s+(\S+)\s*$/i ) {
                                        $stab = $1;
                                        $oid  = $2 . ".oid";
                                } else {
                                        $oid  = $table . ".oid";
                                }
                                $stab = $1 if($stab =~ /^\s*(\S+)(\s+as)?\s*$/i );
                                &dbprint(7,"pr_listtables: stab=|$stab|, tables =|@stables|");
                                &dbError(gtext("tabmustfirst")) if ($stab ne $table);
                        }

                }
                $search = qq{SELECT $oid, $sfields FROM $stables $conds};
        } elsif ( $search ) {
                @bind_values = split(/\}bq\{/,$parms{'binds'}) if $parms{'binds'};
        }
        $parms{'search'} = $search;
        unless (@bind_values) {
                $parms{'binds'}  = "";
        } else {
                $parms{'binds'}  = join('}bq{',@bind_values);
        }
        &dbprint(7,"listTable: search=|$search|, binds=|@bind_values|, kennz=|$kennz|, fields=|$fields|");

        $parms{'kennz'} = $kennz = &set_user_file;

        # For tests: output of the original select-string
        # and its bindings
        &dbprint_cmd_binds(1,$search, @bind_values);

        # denn woll'n wir 'mal die Datenbank fragen...
        # wir brauchen sowohl die Daten, als auch die Anzahl der Zeilen
        my ($ntuples, $listResult) = &db_db_get_nrows('dbase',$search,\@bind_values);
        &dbprint(7,"listTables: ntuples=|$ntuples|, listResult=|$listResult|, kennz=|$kennz|");

        # if there's only one resulting record we go ahead and show it directly
        if($ntuples == 1 && !$statement && $$rconfigs{'single_sentence'} eq 'false') {
                my $rarray = &db_db_hashref($listResult);
                $parms{'oid'}	= $$rarray{'oid'};
                &dbprint(7,"listTable: oid=|$parms{'oid'}|");
                $listResult->finish;
                $parms{'mode'}	= "plain";

                &db_fillValues;         # Getting the values for the oid

                &pr_create_dialog;	# Creating the mask for a single record
                &pr_db_stop_o_mode;	# Ending the Form and page

                &db_db_disc;		# Ending the database-connections
                return;
        } else {
                my $title = &gtext('records', &db_get_tabledisplay($table));
                if ((my $table_desc = &db_get_displayname($table,'tablename','basedesign','description')) ne $table) {
                        $title .= "</H1><H3><CENTER>($table_desc)</CENTER></H3><H1>";
                }
                my @fieldnames;
                my @fieldtypes;
                my $headerline = "";

                if (!$statement && (my $tableStart = $tableDesign{'tableStart'})) {
                        # you can use some variables in the xtablestartprocedure:
                        #       $title = standardtitle, can be reset as returnvalue
                        #       $headerline can be set by the procedure to define the fields in the headerline. It must be
                        #           done if there is xtableitem and the fields are not printed in the standard order!!!
                        #           The first field is allways the recordnumber
                        my $retVal = eval ($tableStart);
                        $title    = &dbWarnText(&gtext('xtableerror', $table)) . ":<BR>$@" if $@;
                        &dbprint(7,"pr_listTable: $title=|$title|, headerline=|$headerline|, fields=|$fields|");
                }
                #
                # Getting the fieldnames of the result
                my $rname = $listResult->{NAME};
                foreach my $name (@$rname) {
                        push(@fieldnames,$name);
                }
                my $rftypes = $listResult->{TYPE};
                foreach my $ftype (@$rftypes) {
                        my $typeinfo = &db_get_typeinfo($ftype);
                        $typeinfo    = "" unless $typeinfo;
                        push(@fieldtypes,$typeinfo);
                }
                &dbprint(7,"pr_listtable: rname=|@$rname|, fieldnames=|@fieldnames|<br>\nrftypes=|@$rftypes|," .
                           "fieldtypes=|@fieldtypes|");

                # Defining the standard-headerline using the standard fieldnames
                if (! $headerline || $statement) {
                        for (my $j = 0; $j < @fieldnames; $j++) {
                                my $name  = $fieldnames[$j];
                                my $ftype = $fieldtypes[$j];
                                my $align = (($ftype =~ /int/i || $ftype =~ /numeric/i || $ftype =~ /float/i) ? 'RIGHT' : 'LEFT');
                                my $fieldname = $name;
                                if (!$statement && $$rfielddesc{$name}{'DISPSTR'}) {
                                        $fieldname = $$rfielddesc{$name}{'DISPSTR'};
                                }
                                $headerline .= "<TH ALIGN=$align>".&upfirst($fieldname)."</TH>"
                                     unless ($name eq 'tmin' || $name eq 'oid');
                        }
                }
                $headerline = "<TABLE BORDER CELLSPACING=0 CELLPADDING=10 WIDTH=100%>\n<TR><TH ALIGN=RIGHT>" .
                              &gtext('recno') . "</TH>$headerline</TR>\n";
                #
                # now we start our form part if needed and some additional Informations if tableModifyable
                if($tableModifyable) {
                        &dbprint_hash(9,"pr_listTable: parms", \%parms);
                        my $maxwidth	= ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
                        &pr_form_start($title);
                        print "<TABLE><TR><TD>" . gtext('fieldname') .
                              "</TD><TD><SELECT NAME=\"fieldname\" SIZE=1>\n";
                        foreach my $fieldname (@fieldnames) {
                                next if ($fieldname eq 'oid');
                                print "<OPTION";
                                print " SELECTED" if ($parms{'fieldname'} && $fieldname eq $parms{'fieldname'});
                                print ">$fieldname\n";
                        }
                        print "</SELECT></TD><TD>\n" . gtext('fieldvalue') . "</TD><TD>" .
                              $qu->textfield(-name=>"fieldvalue",
                                             -size=>$maxwidth) . "</TD></TR>\n";
                        print "<TR><TD>&nbsp;</TD><TD><CENTER>" .
                              $qu->submit(-name=>'mode', -value=>&sbutton('mupdate')) .
                              "</CENTER></TD>\n<TD>&nbsp;</TD><TD><CENTER>" .
                              $qu->reset($buttons{'reset'}) .
                              "</CENTER></TD><TD>&nbsp;</TD></TR></TABLE>\n";
                } else {
                        &pr_list_start($title);
                }
                #
                # und zeigen wir einen Link zum Anlegen neuer Eintrge an
                my $newstring = &gtext('newrec');
                printf "<P><A HREF=\"dbengine.cgi?dbase=$dbase&mode=plain&table=$table&kennz=" . $parms{'kennz'} .
                       "\">$newstring</A><P>\n";
                #
                # schalten in der Ausgabe auf einen monospaced Font um
                print "<P><FONT SIZE=3 FACE=\"Monaco\">\n";


                # after printing the table-head-line first we have to read all tuples into an internel buffer
                # build by an array of arrays holding just one tuple in the order of @fieldnames
                #
                my @tupleArray;
                my $tupleno  = 0;
                &dbprint(7,"pr_listTable: recno=|$recno|, maxrecno=|$maxrecno|, maxrecno_n=|$maxrecno_n|");
                while ( my $ary_ref = $listResult->fetch ) {
                        unless ( $tupleno < $recno ) {
                                &dbprint(9,"listTable: ary_ref=|$ary_ref|, tupleno=|$tupleno|");
                                for ( my $i = 0; $i < @$ary_ref; $i++) {
                                        $tupleArray[$tupleno][$i] = $$ary_ref[$i];
                                }
                        }
                        $tupleno++;
                        last if($tupleno >= $maxrecno_n);
                }
                $listResult->finish;

                #
                # second we have to look for virtualfields
                # We take all values and keys in an internal array
                my $nvtuples = 0;
                my @varray;
                unless ( $statement ) {
                        my $comm     = qq{SELECT * FROM virtual WHERE tablename='$table' AND DBaseName='$parms{'dbasen'}'} .
                                q{ ORDER BY level};
                        my $vfields  = &db_db_get('dbdesc',$comm);
                        while ( my $rarray = &db_db_hashref($vfields) ) {
                                foreach my $vkey ( xSort(keys %$rarray)) {
                                        $varray[$nvtuples]{$vkey} = $$rarray{$vkey};
                                }
                                $nvtuples++;
                        }
                }

                print $headerline;           # Printing the headerline
                #
                # und gehen alle Records durch
                &dbprint(7,"pr_listTable: recno=|$recno|, tupleno=|$tupleno|");
                for ( ; $recno < $tupleno; $recno++ ) {
                        #
                        # wobei wir jeweils eine HREF auf den aktuellen Satz mit der Record-ID einbauen
                        # The first selected field  is the 'oid'
                        my $kennz = "dbengine.cgi?mode=plain&dbase=$dbase&table=$table&kennz=" . $parms{'kennz'};
                        my $oid   =  $tupleArray[$recno][0];
                        print "\n<TR><TD ALIGN=RIGHT>";
                        if ($tableModifyable) {
                                print "<INPUT NAME=OID$oid TYPE=CHECKBOX CHECKED>";
                        }
                        print "<A HREF=\"$kennz&oid=$oid\">" . ($recno + 1) . "</TD>\n";

                        if ($tableItem) {   # if you have to use virtualfields, yuo must define a procedure to output every record.
                                my $fno = 0;
                                for (my $j = 0; $j < @fieldnames; $j++) { # filling $$rvalues with all fields incl. oid
                                        my $tkey         = $fieldnames[$j];
                                        my $value        = $tupleArray[$recno][$j];
                                        $value           = "" unless $value;
                                        $$rvalues{$tkey} = &db_SQL2value($tkey, $value);
                                        $fno++;
                                }

                                #
                                # then add the contents of any defined virtual fields if needed
#                                &dbprint_hash(9,"pr_listTable: varray[0]=|$varray[0]|, nvtuples=|$nvtuples|,
#                                              tabledesign",\%tableDesign);
                                if($varray[0] && $tableDesign{'tableVirtuals'}) {
                                        for (my $vidx=0;  $vidx < $nvtuples; $vidx++) {
                                                #
                                                # if there's an error during the evaluation we set our
                                                # virtual fields  contents to the error message
                                                my $value =  eval($varray[$vidx]{'xequation'});
                                                $value    =  &dbWarnText(&gtext("virterror", $varray[$vidx]{'fieldname'}) .
                                                                                ":<BR>$@") if $@;
                                                $$rvalues{$varray[$vidx]{'fieldname'}} = $value;
                                                &dbprint_hash(7,"pr_listTable: value=|$value|, varray[$vidx]", $varray[$vidx]);
                                        }
                                }

                                # to evaluate the procedure in tableitem there are parameters:
                                #           $recno = recordnumber,
                                #           @fieldnames = name of the attributes
                                #           $rvalues = hashref of values of fieldnames
                                #           $firstrec = output of firstrecord (you have to create a header line)
                                #                       Put the ouputline into the variable $line!
                                @_ = ($rvalues, $rconfigs, $rparms);   # stting the parameter for the eval
                                my $line;
                                my $retVal = eval ($tableItem);     # create a output of 1 row in the table
                                $line      = &dbWarnText(&gtext('extrableitem',$tableItem, $table) . ":<BR>$@") if ($@);
                                print $line;
                        } else {
                                #
                                # Ausgabe der in 'fields' gewnschten Felder
                                for (my $j=1; $j < @fieldnames; $j++) {
                                     my $fieldname = $fieldnames[$j];
                                     unless ($fieldname eq 'tmin') {
                                              &dbprint_hash(7,"pr_listTable: name=|$fieldname|, rfielddesc",$$rfielddesc{$fieldname});
                                              my $tdv = "<TD>";
                                              my $ergebnis   = &db_SQL2value($fieldname,$tupleArray[$recno][$j]);
                                              $ergebnis      = "" unless $ergebnis;
                                              my $fieldtype  = $$rfielddesc{$fieldname}{'TYPE'};
                                              $fieldtype     = $fieldtypes[$j] unless $fieldtype;
                                              my $dispname   = $$rfielddesc{$fieldname}{'DISPLAY'};
                                              my $dispdfield = $$rfielddesc{$fieldname}{'DISPDFIELD'};
                                              $dispname      = "" unless $dispname;
                                              $dispdfield    = "" unless $dispdfield;
                                              if ($fieldtype =~ /int/i || $fieldtype =~ /numeric/i || $fieldtype =~ /float/i) {
                                                      $tdv = "<TD ALIGN=RIGHT>";
                                              }
                                              &dbprint(9,"pr_listtables: fieldname=|$fieldname|, ergebnis=|$ergebnis|");
                                              if ($fieldtype eq 'bool') {
                                                      $ergebnis = ($ergebnis ? 't' : 'f' );
                                              } elsif ($dispname =~ /textarea/ ) {
                                                      if($dispdfield =~ /pre/i ) {
                                                        $ergebnis = "<PRE>" . &pr_quote($ergebnis) . "</PRE>";
                                                      } else {
                                                        $ergebnis = pr_textarea_bau($ergebnis);
                                                      }
                                                      &dbprint(7,"pr_listtables: dispdfield=|$dispdfield|, ergebnis=|$ergebnis|");
                                              } elsif ($dispname =~ /multiplepopup/ ) {
                                                      my @mvalues = split(/:::/,$ergebnis);
                                                      $ergebnis = "";
                                                      foreach my $mvalue (@mvalues) {
                                                              $ergebnis .= "<BR>" if $ergebnis;
                                                              $ergebnis .= $mvalue;
                                                      }
                                              }
                                              print $tdv;
                                              print $ergebnis;
                                              print "</A>" if ( $j == 1);
                                              print "</TD>";
                                      }
                                }
                                print "</TR></A>\n";
                        }
              }
              print "</TABLE>";

              if (my $tableEnd = $tableDesign{'tableEnd'}) {
                      my $retVal	= eval ($tableEnd);
                      $retVal = &dbWarnText(&getext("erxtableend", $table) . ":<BR>$@") if $@;
              } else {
                      print "<BR><HR>" . &gtext('nombrecs') . " = $ntuples<BR>";
              }
              &dbprint(7,"pr_listTables: ntuples=|$ntuples|, recno=|$recno|, maxrecno=|$maxrecno|, recno_s=|$recno_s|");
              if ( $ntuples > $maxrecno ) {
                      my $kennz =  "<A HREF=\"dbengine.cgi?mode=search&dbase=$dbase&table=$table&oldsearch=1&kennz=" .
                                   $parms{'kennz'};
                      print "<TABLE Border=3 cellpadding=10><TR>";
                      my $textl = &gtext('lastrecs');
                      my $textn = &gtext('nextrecs');
                      if ($recno_s >= $maxrecno) {
                              print "<TD>$kennz&recno=" . ($recno_s - $maxrecno) . "\">$textl</A></TD>\n";
                      } else {
                              print "<TD>$textl</TD>\n";
                      }
                      if ($recno < $ntuples) {
                              print "<TD>$kennz&recno=$maxrecno_n\">$textn</A></TD>\n";
                      } else {
                              print "<TD>$textn</TD>\n";
                      }
                      print "<TD>$kennz&recno=0&maxrecno=$ntuples\">" . &gtext('allrecs') . "</A></TD>\n";
                      print "</TR></TABLE>\n";
              }

              if ($tableModifyable) {
                      # terminate the form and page
                      &pr_db_stop_o_mode;
              } else {
                      # terminate the  HTML Page
                      &pr_db_finish;
              }
      }
}

1;
