############################
#
# dbengine_out.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
# Version 1.01
# <c> 1997, 1998, 1999 Detlef Duerr
# get closer Information from email Detlef.Duerr@atm-computer.de
# older version
# <c> 1996 Ingo Ciechowski
# see closer information at http://www.cis-computer.com/dbengine
#
#  Output Library for dbengine.pl new version
#
#  Routinen zur Ausgabe der Texte, Frames fr die
#  dynamische HTML-Seite
#
##########################

my $qu;
my $rconfigs;
my $rparms;
my $rfielddesc;
my $rrelations;
my $rvalues;
my $rbuttons;

my $mode;
my $user;
my $dbase;
my $dbasen;
my $kennz;
my $table;

#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
sub pr_db_init {
        ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;

        print $qu->header;

}

#
# Start der HTML-Ausgabe, Erzeugen von HTML-header und dem notwendigen Teil bis zu der
# Stelle, an der die spezifischen Ausgaben erfolgen.
# Verzweigen ber die verschienen Stati (mode) des Systems.
#
sub pr_db_start {
	local *parms 	= $rparms;
	local *configs  = $rconfigs;

	$mode 	= $parms{'mode'} if $parms{'mode'};
	$user	= $parms{'user'} if $parms{'user'};
	$dbase	= $parms{'dbase'} if $parms{'dbase'};
	$kennz	= $parms{'kennz'} if $parms{'kennz'};
	$table	= $parms{'table'} if $parms{'table'};
	$parms{'dbasen'} = $dbasen = &dbase_get_name($dbase) if $dbase;
        &dbprint_hash(9,"pr_db_start: parms", $rparms);

	if ( ($mode eq 'userdefine' && defined $dbase)) {	# Erzeugen der Frames
		print "<HTML><HEAD><TITLE>$parms{'dbasen'}</TITLE>\n";
                      qq{<link rev="made" href="mailto:Detlef.Duerr%40gmx.de" /></HEAD>\n};
	} elsif ( $mode eq 'empty') {
		print $qu->start_html(	-title=>'DBENGINE',
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				_target=>'body',
				-BGCOLOR=>$configs{'bgcol'});
	} elsif ($mode eq 'menu') {
		print $qu->start_html( -title=>&gtext('dtitle') . ": $dbase",
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				_target=>'menu',
				-BGCOLOR=>$configs{'bgmcol'});
	} elsif ($mode eq 'userget') {
		print $qu->start_html( -title=>&gtext('utitle'),
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				-BGCOLOR=>$configs{'bgcol'});
	} elsif ($mode eq 'userdefine') {
		print $qu->start_html( -title=>&gtext('dtitle'),
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				-BGCOLOR=>$configs{'bgcol'});
	} elsif ($mode eq 'action') {
		print $qu->start_html( -title=>&gtext('atitle'),
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				_target=>'body',
				-BGCOLOR=>$configs{'bgcol'});
	} else {
		print $qu->start_html( -title=>&gtext('ttitle') . ": $table",
				-author=>'Detlef.Duerr@gmx.de',
				_base=>'true',
				_target=>'body',
				-BGCOLOR=>$configs{'bgcol'});
	}
}

sub pr_db_finish {
	print $qu->end_html;
}

#
# print all those fields into our page whose values
# we might need upon our next call
#
sub pr_db_stop {
        local *parms	= $rparms;

        print $qu->hidden('mode',$parms{'mode'}) . "\n" if $parms{'mode'};
        &pr_db_stop_o_mode;
}

#
# print all field but 'mode' and end the form and page
#
sub pr_db_stop_o_mode {
        local *parms = $rparms;

        $qu->delete_all;
        print $qu->hidden('dbase',$parms{'dbase'}) . "\n" if $parms{'dbase'};
        print $qu->hidden('user',$parms{'user'}) . "\n" if $parms{'user'};
        print $qu->hidden('kennz',$parms{'kennz'}) . "\n" if $parms{'kennz'};
        print $qu->hidden('table',$parms{'table'}) . "\n" if $parms{'table'};

        if(defined $parms{'oid'}) {
                print $qu->hidden('oid', $parms{'oid'}) . "\n";
                $$rvalues{'tmin'}	=~ s/ //g if ( $$rvalues{'tmin'} );
                print $qu->hidden('tmin', $$rvalues{'tmin'});
        }

#        print $qu->endform . "\n";
        print "</form>\n";
        &pr_db_finish;
}

#
# Routine zur Ausgabe des Beginns der Eingabeteile
#
sub pr_form_start {
        my $title	= shift;

        print <<EOM
        <H1><CENTER>$title</CENTER></H1>
        <FORM METHOD=POST ACTION="dbengine.cgi">
        <P>
EOM
;
}

#
# Routine zur Ausgabe des Beginns der Eingabeteile
#
sub pr_list_start {
	my $title	= shift;

	print "<H1><CENTER>$title</CENTER></H1>\n<P>\n";
}

#
# Routine zum Ausgeben einer appendliste fr eine Referenz zum weiteren Aufruf
#
sub pr_create_appendref {
        my ($text, $stable, $sfield, $gfield) = @_;

        local *parms = $rparms;
        &dbprint(7,"pr_create_appendref: stable=|$stable|, sfield=|$sfield|, gfield=|$gfield|, text=|$text|");

        $qu->delete_all;
        $qu->append(-name=>'table',-value=>$stable);
        $qu->append(-name=>'dbase',-value=>$parms{'dbase'});
        $qu->append(-name=>'kennz',-value=>$parms{'kennz'});
        $qu->append(-name=>'mode',-value=>'search');
        $qu->append(-name=>'fields', -value=>"$sfield");
        $qu->append(-name=>'value',-value=>"$gfield") if($sfield && $gfield);
        print "<A HREF=\"dbengine.cgi?" . $qu->query_string . "\">$text</A>";
}

#
# Routine zur Ausgabe eines Listings aufgrund einer 'such'-Anweisung
#
my $listtable_module_exist = 0;

sub pr_listTable {
        require "dbengine_listtable.pl";
        unless ($listtable_module_exist) {
                &listtable_init($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues);
                $listtable_module_exist = 1;
        }
        &listtable;
}

#
# Routinen zur Ausgabe einer Bildschirmmaske fr eine Relation
#
my $plaindialog_module_exist = 0;

#
# Starten der Maskenerzeugung und globale Fallunterscheidungen
#
sub pr_create_dialog {
        &dbprint(7,"pr_create_dialog: Modul anfordern: INC=|@INC|");
#        require "dbengine_plaindialog.pl";
        &dbprint(7,"pr_create_dialog: Modul geladen");
        unless ($plaindialog_module_exist) {
                &dbprint(7,"pr_create_dialog: module_exist=|$plaindialog_module_exist|");
                &plaindialog_init($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues);
                $plaindialog_module_exist = 1;
        }
        &createdialog;
}

#
# remove those fields that have a given order from the
# displayinfo table from our parameter array @in, sort
# them in the requested display order and return the
# sorted plus unsorted fields in @out
#
sub xSort {
        my @in = @_;
	my @out;
	my $rfielddisporder =  $rfielddesc{'fielddisporder'};

	foreach my $index (sort keys %$rfieldddisporder) {
		push	@out, $$rfielddisporder{$index};
		@in	= &xDel($$rfielddisporder{$index}, @in);
	}
	push @out, (sort @in);
	@out;
}

#
# delete the element with value $element from
# the given array @in and return the remaining
# components in @out
#
sub xDel {
        my ($element, @in) = @_;
	my @out;

	foreach my $name (@in) {
		push @out, $name unless $element eq $name;
	}
	@out;
}

#
# get the maximum number of columns
# specified by the displayinfo table
#
sub maxCols {
	my $cols	= 0;
	my $rfielddispcolumn = $$rfielddesc{'fielddispcolumn'};
	foreach my $name (values %$fielddispcolumn) {
		$cols	= $name if $name > $cols;
	}
	$cols;
}

#
# Routine zur Anforderung von username und passwort
#
sub pr_form_pw {
        local *configs	= $rconfigs;
        local *parms	= $rparms;

        print "<CENTER><TABLE Border=0>\n";

        unless($parms{'user'}) {
                # User und Passwort anfordern, wenn kein user vorhanden
                my $username = &gtext('user');
                my $password = &gtext('passwd');
                print <<EOM
                <TR><TD>$username:</TD>
                <TD><INPUT TYPE=TEXT SIZE=30 MAXLENGTH=30 NAME="user"></TD></TR>
                <TR><TD>$password:</TD>
                <TD><INPUT TYPE=PASSWORD SIZE=30 MAXLENGTH=30 NAME="pwd"></TD></TR>
                <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
                <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
EOM
;
        }
        unless ($parms{'dbase'}) {
                # Wenn nicht vorhanden, Datenbank bzw. DBSystem anfordern
                my $auswahl;
                my @dbdats;
                my $dbsys;
                my $namea;

                if ($parms{'dbsystem'}) {
                        @dbdats = &dbase_get_sources($parms{'dbsystem'});
                        if (@dbdats == 1) {
                                $parms{'dbase'} = shift @dbdats;
                        } elsif (!@dbdats) {
                                &dberror(&gtext('dbserror'));
                        } else {
                                $auswahl = &gtext('dbase') . ":";
                                $namea   = "dbase";
                                &dbprint(8,"pr_form_pw: Treiber=|%s|, Datenbanken (Anzahl=|%d|)=|@dbdats|",
                                         $parms{'dbsystem'},$#dbdats + 1);
                        }
                }
                if (@dbdats > 1) {
                        &pr_get_dbs($auswahl,$namea,\@dbdats);
                }
        }
}

#
# Allgemeines Ende des Formscripts
#
sub pr_form_stop {
	my @submits = @_;

	print <<EOM
	<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
	<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
	<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
	<TR>
EOM
;
	foreach my $subm (@submits) {
		print "<TD><INPUT TYPE=SUBMIT VALUE=\"$subm\"></TD>\n";
	}
	print <<EOM
	</TR>
	</TABLE></CENTER>
EOM
;
}

#
# create a simple HTML popup menu that displays all the different values
# in $relField from table $relTable in the main database
#
sub relationPopup {
        my ($popupArt,$name, $relTable, $relField, $reldField, $mlines) = @_;
        my $popup;
        my $rtestField;
        my $rtestWert;
        my $vname = ($$rvalues{$name} ? xChop($$rvalues{$name}) : "");
        &dbprint_hash(9,"relationPopup: vname=|$vname|, rvalues", $rvalues);

        my $cmd = "";
        if ($relField =~ /^\s*(\w+)\s+(\w+)\s+([^\s].*[^\s])\s*$/ ) {
                $relField = $1;
                $rtestfield = $2;
                $rtestWert = $3;
                if ($rtestWert =~ /^'(.+)'$/ ) {
                        $rtestWert = $1;
                }
                $cmd = "WHERE $rtestfield = \'$rtestWert\' ";
        }
        $cmd      .= "ORDER BY $relField";
        $reldField = $relField unless $reldField;
        $cmd = "SELECT DISTINCT $relField as relField, $reldField as reldField FROM $relTable " . $cmd;
        &dbprint(9,"relationPopup: cmd=|$cmd|");
        my ($ntuples, $res) = &db_db_get_nrows('dbase',$cmd);

        my $size = 1;
        my $reltupleanz = $$rconfigs{'reltupleanz'};
        $reltupleanz = 25 unless $reltupleanz;
        my $reltuplelines = $$rconfigs{'reltuplelines'};
        $size = ($reltuplelines ? $reltuplelines : 2 ) if ( $ntuples > $reltupleanz );
        &dbprint(9,"relationPopup: ntuples=|$ntuples|, size=|$size|, res=|$res|");

        my @popupvalues;
        #
        # get all records and add the relnames to the popup
        while (my $rarray = $res->fetch) {
                my $value = xChop($$rarray[0]);
                my $vdisp = $value;
                $vdisp = "$value ($$rarray[1])" if($reldField ne $relField);
                if($vname &&  $vname eq $value) {
                        $vname = $vdisp;
                } else {
                        push(@popupvalues, $vdisp);
                }
        }


        #
        # start with the <SELECT tag and add (if any) the real value of the field as first <OPTION>
        if ($popupArt =~ /^relation/ ) {
                $popup	= "<SELECT NAME=\"__$name\" SIZE=$size>\n<OPTION>";
                $popup .=  $vname . "\n<OPTION>\n" if $vname;
        } else {
                my $mSize = $$rconfigs{'mreltupellines'};
                $mSize = 4 unless $mSize;
                $mSize = $mlines if $mlines;
                $popup = "<SELECT NAME=\"__$name\" SIZE=$mSize MULTIPLE>\n";
                &dbprint(9,"relationPopup: name=|$name|, vname=|$vname|");
                if($vname) {
                        my @vnames = split(/:::/,$vname);
                        &dbprint(9,"relationPopup: vname=|$vname|, anz_vnames=|" . @vnames . "|, vnames=#@vnames#");
                        foreach my $value (@vnames){
                                $popup .=  "<OPTION SELECTED>$value\n";
                        }
                }
                $popup .= "<OPTION>";
        }

        #
        # scan all records and add the relnames to the popup unless it's the default option
        foreach my $vdisp (@popupvalues) {
#                &dbprint(9,"relationPopup: rarray=|@$rarray|, value=|$value|, relfield=|$relField|, reldfield=|$reldField|");
                $popup	.= "<OPTION>$vdisp\n";
        }

        $popup . "</SELECT>\n";
}

#
# create a simple HTML popup menu that displays all the values
# specified in the valuelist table of our display description database for
# this specific field name
#
sub valueListPopup {
        my $name     = shift;
        my $cmd      = "SELECT display,content,orderno FROM valuelist " .
                          "WHERE name = '$name' AND DBaseName='$dbasen' ORDER BY orderno";
        my $result   = &db_db_get('dbdesc',$cmd);
        my $value    = $$rvalues{$name};
        $value       = "" unless $value;
        $value       = &xChop($value);
        $popups      = "";
        my $hiddenfs = "";

        # get all values and create a readable text for them and a hidden valuelist
        while (my $rarray = $result->fetch()) {
                my $disp   = $$rarray[0];
                my $cont   = $$rarray[1];
                $disp      = &gtext($1) if ($disp =~ /^lang\((.+)\)$/);
                $hiddenfs .= $qu->hidden("_:_lang-1__$disp",$cont) . "\n";
                if ($value eq $cont) {
                        $value = $disp;
                } else {
                        $popups .= "<OPTION>" . $disp . "\n"
                }
        }

        #
        # start with the <SELECT tag and add (if any) the real value of the field as first <OPTION>
        my $popup = "<SELECT NAME=\"__$name\" SIZE=1>\n<OPTION>" . $value . "\n";
        $popup   .= "<OPTION>\n" if $value;
        $popup   .= $popups . "</SELECT>\n" . $hiddenfs;
}

#
# Kopfteil fr Datenbank - Menu - Frame erstellen
#
sub pr_men_frame_kopf {
        print "<CENTER><H2>";
        print &gtext('database') . ":<BR>" . &upfirst($dbasen) . "</H2></CENTER>\n";
        if ( my $schemas = $$rparms{'schemas'} ) {
                print "<H3><CENTER>" . &gtext('schema') . ":<BR>\n$schemas</CENTER></H3>\n" ;
        }
}

#
# Liste der Datenbanken fr Auswahl erstellen
#
sub pr_get_dbs {
        my $auswahl = shift; my $namea = shift; local *dbdats = shift;

        print "<TR><TD width=25%>$auswahl</TD><TD><SELECT NAME=\"$namea\" SIZE=1>\n";
        foreach my $elem (@dbdats) {
                my $p2 = $elem;
                $p2 = &dbase_get_name($elem) if $namea eq 'dbase';
                print "<OPTION VALUE=\"$elem\">$p2\n";
        }
        print "</SELECT></TD></TR>\n";
}

#
# Texte aus sprachbezogenem Texthash holen
#
sub gtext {
        my $gtextindex = shift; my @wert  = @_;
        my $gtextcmd = "SELECT translate_text, language FROM langtexts WHERE indextext = ?";
        my $erg;
        my $format = "";

        # get the value from database
        $format = &db_gtextb($gtextcmd,'translate_text',$gtextindex,);

        if (@wert) {
                &dbprint(11,"gtext: index=|$gtextindex|, werte=|@wert|, erg=|$format|");
                $erg = sprintf($format,@wert);
        } else {
                &dbprint(11,"gtext: index=|$gtextindex|, erg=|$format|");
                $erg = $format;
        }
        # $erg must be quoted for html-output , will be done later
        return($erg);
}

#
# Buttontexte aus Buttonhash holen
#
sub sbutton {
        my $key = shift;
        return (&db_gtextb("SELECT translate_text, language FROM langtexts WHERE button AND indextext = ?",'translate_text',$key));
}

#
# Buttonschlssel zu buttonwert aus buttonhash holen (reversefunktion von sbutton)
#
sub gbutton {
         my $value = shift;
         return(&db_gtextb("SELECT indextext, language FROM langtexts WHERE button='t' AND translate_text = ?",'indextext',$value));
}

#
# Ersten Buchstaben eines Wortes gro�chreiben oder Alle, wenn spezialword
#
sub upfirst {
        my $var  = shift;
        #
        # this function returns a name with the first and every character direct after a '_'
        # made to an uppercase character if the language is german
        local *configs = $rconfigs;
        my $var1 = ucfirst($var);
        my $var2;
        my @abk  = &get_db_array('shortenings');
        my $abk1;

        &dbprint(9,"upfirst: var=|$var|, var1=|$var1|, lang=|$configs{'upfirst'}|");
        return $var unless ($configs{'upfirst'});
        $var = "";
        while ( $var1 =~ /_/ ) {
                ($var2,$var1) = split("_",$var1,2);
                foreach $abk1 (@abk) {
                        $var2 = uc($var2) if ($var2 =~ /^$abk1$/i );
                }
                $var .= $var2;
                $var .= "_" if $var1;
                $var1 = ucfirst($var1);
        }
        foreach $abk1 (@abk) {
                $var1 = uc($var1) if ($var1 =~ /^$abk1$/i );
        }
        return $var . $var1;
}

#
# Subroutine to quote strings for HTML-output
# using ISO-UNICODE for ISO8859-1
sub pr_quote {
        my @was = split(/\r*/,shift);
        my $erg = "";
        foreach my $char1 (@was) {
                $char = ord($char1);
                my ($char2,$erg1) = &pr_quote_char($char1);
#                &dbprint(9,"pr_qoute: char=|$char|, char1=|$char1|, char2=|$cahr2|, erg1=|$erg1|, erg=|$erg|");
                if ($erg1) {
                        $erg .= $char2;
                } elsif ($char == 60 ) {
                        $erg .= "&#60;"; # '<'
                } elsif ( $char == 62 ) {
                        $erg .= "&#62;"; # '>'
                } else {
                        $erg .= $char1;
                }
        }
        return($erg);
}

sub pr_quote_part {
        my @was = split(/\r*/,shift);
        my $erg = "";
        foreach my $char1 (@was) {
                my ($char1,$erg1) = &pr_quote_char($char1);
                $erg .= $char1;
        }
        return($erg);
}

sub pr_quote_char {
        my $char1 = shift;
        my $char = ord($char1);
        my $erg = "";
        if( $char >= 160) {
                $erg = "&#" . $char . ";";
        } elsif ( $char == 34 ) {
               $erg = "&#34;"; # '"'
        } elsif ( $char == 38 ) {
               $erg = "&#38;"; # '&'
        } else {
               return($char1,0);
        }
        return($erg,1);
}

#
# Ereignis in Tabellen ggbfls. umbauen
#
my $anf;
my $rest;
sub pr_textarea_bau {
        $rest = shift;
        $anf     = "";
        return(&pr_textarea_bau_r($rest,"",0));
}

my $vgl_mask = "table|dl|ol|ul";
my %end      = ('table'=>'</td></tr>', 'dl'=>'</dd>', 'ul'=>'', 'ol'=>'');
my %beg      = ('table'=>'<tr><td valign=TOP>', 'dl'=>'<dt>', 'ul'=>'<li>', 'ol'=>'<li>');
my %tab      = ('table'=>'</td><td valign=TOP>', 'dl'=>'</dt><dd>', 'ul'=>'<li>', 'ol'=>'<li>');
my %nl       = ('table'=>'</td></tr><tr><td valign=TOP>', 'dl'=>'</dd><dt>', 'ul'=>'<li>', 'ol'=>'<li>');
my %tr       = ('table'=>'<tr>', 'dl'=>'<dd>', 'ul'=>'<li>', 'ol'=>'<li>');
sub pr_textarea_bau_r {
        $rest      = shift;
        my $key    = shift;
        my $arlev  = shift;
        my $vgl_m1 = $vgl_mask;
        $vgl_m1   .= "|\/$key" if $key;
        my $tag    = 0;
        my $tagbeg = 0;
        &dbprint(7,"pr_textarea_bau_r 1($arlev): key=|$key|, rest=|$rest|, anf=|$anf|");
        while ( $rest =~ /^(.*?)<(${vgl_m1})>(.*)$/is ){
                my $anf1 = ($1 ? $1 : "");
                my $vgl  = $2;
                $rest    = ($3 ? $3 : "");
                &dbprint(7,"pr_textarea_bau_r 2($arlev): vgl=|$vgl|, key=|$key|, anf1=|$anf1|, rest=|$rest|");
                if ($key && $vgl eq "/$key") {
                        ($tagbeg,$tag)  = &pr_textarea_bau_part($anf1,$key,$tagbeg,$tag);
                        $anf .= $end{$key} if $tag;
                        $anf .= "</$key>";
                        $tagbeg = $tagda = 0;
                        &dbprint(7,"pr_textarea_bau_r 3a($arlev): anf=|$anf|, rest=|$rest|");
                        return($anf) if ($arlev);
                } else {
                        unless ($key) {
                                $anf .= &pr_quote_part_nl($anf1);
                        } else {
                                ($tagbeg,$tag) = &pr_textarea_bau_part($anf1,$key,$tagbeg,$tag);
                        }
                        $anf .= "<$vgl>";
                        &dbprint(7,"pr_textarea_bau_r 3b($arlev): vgl=|$vgl|, key=|$key|, anf=|$anf|, rest=|$rest|");
#                        $anf = &pr_textarea_bau_r($rest,$vgl);
#                        $arlev--;
                        $anf = &pr_textarea_bau_r($rest,$vgl,$arlev + 1);
#                        return($anf) if ($arlev);
                }
        }
        $anf .= &pr_quote_part_nl($rest);
        $rest = "";
        &dbprint(7,"pr_textarea_bau_r 4($arlev): anf=|$anf|, rest=|$rest|");
#        $arlev--;
        return($anf);
}

sub pr_textarea_bau_part {
        my ($text,$key,$tagbeg,$tagda) = @_;
        &dbprint(7,"pr_textarea_bau_part: key=|$key|, tagbeg=|$tagbeg|, tagda=|$tagda|, text=|$text|");
        if ($key) {
                unless ( $text =~ /$tr{$key}/is ) {
                        $anf  .= $beg{$key} unless $tagbeg;
                        $tagda = 1;
                        $text  =~ s/\t/$tab{$key}/mg;
                        $text  =~ s/\r*\n\r*/$nl{$key}/mg;
                }
        } else {
                $text = &pr_quote_part_nl($text) unless $tagda;
        }
        $anf .= $text;
        return(1,$tagda);

}

sub pr_quote_part_nl {
        my $str = shift;
        $str = &pr_quote_part($str);
        if ( $str =~ /\012/s ) {
                my $str_nl = ( $str =~ /\012\r*$/s ) ? 1 : 0;
                my @str = split(/\012/,$str);
                $str = "";
                foreach my $str1 (@str) {
                        if (length($str1) <= 50) {
                                $str1 =~ s/ /&nbsp;/g;
                        } else {
                                $str1 =~ s/  /&nbsp;&nbsp;/g;
                        }
                        $str .= "<BR>" if $str;
                        $str .= $str1;
                }
                $str .= "<BR>" if $str_nl;
        }
        return ($str);

}

sub pr_textarea_bau_old {
        my $rest = shift;
        my ($anf,$table);
        while ($rest =~ /<table>/ ){
                my ($anf1, $anf2);
                ($anf1,$rest) = split(/<table>/,$rest,2);
                ($anf1,$anf2) = &pr_quote_part($anf1);
                if ($anf1 =~ /\012/) {
                        my @anf1 = split(/\012/,$anf1);
                        $anf1 = "";
                        foreach my $anf2 (@anf1) {
                                if (length($anf2) <= 50) {
                                        $anf2 =~ s/ /&nbsp;/g;
                                } else {
                                        $anf2 =~ s/  /&nbsp;&nbsp;/g;
                                }
                                $anf1 .= "<BR>" if $anf1;
                                $anf1 .= $anf2;
                        }
                }
                ($table,$rest) = split(/<\/table>/,$rest,2);
                unless ($table =~ /<tr>/i ) {
                        $table =~ s/\t/<\/td><td valign=TOP>/mg;
                        $table =~ s/\r*\n\r*/<\/td><\/tr><tr><td valign=TOP>/mg;
                        $anf .= $anf1 . "<table><tr><td valign=TOP>" . $table . "</td></tr>";
                } else {
                        $anf .= $anf1. "<table>" . $table;
                }
                $anf .= "</table>" if $table;
                &dbprint(7,"pr_textarea_bau: rest=|$rest|");
        }
        &dbprint(7,"pr_textarea_bau: anf=|$anf|, rest=|$rest|");
        return($anf . $rest);
}

#
# This routine checks whether the value of a given field is valid
# in case there's a Perl subroutine defined for this test
# and dies if the test fails.
# In this case the subroutines failure description from @_ is presented
#
sub pr_checkFieldContent {
        my ($name, @Werte) = @_;
        # if there are an input in a multipleselect-field, it will be given as a valuelist combinde with ', '

        my $content;
        my $rcurrent = $$rfielddesc{$name};
        my $dispname = $$rcurrent{'DISPLAY'};
        $dispname = "" unless $dispname;
        my $fieldtype = $$rcurrent{'TYPE'};
        $fieldtype = "" unless $fieldtype;
        my $warning = 0;

        $content = &pr_get_relvalues($name, \@Werte);
        $content = "" unless $content;
#        &dbprint(7,"pr_checkFieldContent: name=|$name|, content=|$content|, Werte=|@Werte|");

        my $feval = $$rcurrent{'EVAL'};
        if($feval) {
                @_ = ( $content );
                my($was) = $feval;
                $was     =~ tr/\r/ /;
                &dbprint (7,"pr_checkFieldContent: content=\'$content\', \@_=|@_|, name=\'$name\', eval=[".$feval."]");
                $content = eval "$was";
                #
                # if there's an error during the evaluation we
                # display the error message just before we die :-((
                &dbprint (7,"pr_checkFieldContent: nach eval: content=\'$content\', \@_=@_");
                if ($@) {
                        &dbWarning(&gtext('eingerr',$name,$@,$content));
                        $warning = 1;
                }
        }
        if ( !$content && $$rcurrent{'NOTNULL'}  &&  (!$$rcurrent{'DEFAULT'} || $$rparms{'mode'} ne 'add')) {
                &dbprint_hash(9,"pr_checkFieldContent: name=|$name|, rfielddesc=",$$rfielddesc{$name});
                &dbWarning(&gtext('eingmuss',$name));
                $warning = 1;
        }
        $$rvalues{$name} = $content;

        return($warning, $content);
}

sub pr_get_relvalues{
        my ($name, $rWerte) = @_;
        # if there are an input in a multipleselect-field, it will be given as a valuelist combinde with ', '

        my $content;
        my $dispname = $$rfielddesc{$name}{'DISPLAY'};
        $dispname = "" unless $dispname;
        my $fieldtype = $$rfielddesc{$name}{'TYPE'};
        $fieldtype = "" unless $fieldtype;
        return(&pr_get_RelValues($name,$dispname,$fieldtype,$rWerte));
}

#
# Getting the Values from input modifying them if popup-fields
# also for external use
#
sub pr_get_RelValues {
        my ($name,$dispname,$fieldtype,$rWerte) = @_;
        my $warning = 0;
        my $content;
        &dbprint(7,"pr_get_RelValues: name=|$name|, dispname=|$dispname|, fieldtype=|$fieldtype|, rWerte=|@$rWerte|");

        foreach my $wert (@$rWerte) {
                if ($dispname =~ /^\s*(relationpopup|multiplepopup)/ ) {
                        $wert = $1 if ( $wert =~ /^\s*([^\s]+)\s+\(.+\)\s*$/ );
                        if ($dispname =~ /multiplepopup/){
                                unless ($fieldtype =~ /(char|text)/ ) {
                                        &dbWarning(&gtext('multpopntext',$name,$fieldtype));
                                        $warning = 1;
                                }
                                $wert = $1 if ( $wert =~ /^\s*([^\s]*)\s+\(.*\)\s*$/ );
                                $wert = "$wert";
                        }
                } elsif ($dispname =~ /^s*popup/  && $$rparms{"_:_lang-1__$wert"}) {
                        $wert = $$rparms{"_:_lang-1__$wert"};
                } elsif ($fieldtype eq 'bool' && $wert eq 'u') {
                        $wert = "";
                }
                $content .= ":::" if ($content && $wert);
                $content .= $wert if $wert;
        }
        return($content);
}

sub pr_local2SQLformat {
        my ($var, $fieldtype) = @_;

        &dbprint(7, "pr_local2SQLformat: var=|$var|, type=|$fieldtype|");
        if($fieldtype =~ /float/ || $fieldtype =~ /numeric/) {
                $var =~ s/ //g;
                if($var =~ /^(.+),(\d+)$/) {
                        my $var1 = $1;
                        my $var2 = $2;
                        $var1 =~ s/\.//g;
                        $var  = "$var1.$var2";
                        &dbprint(7,"pr_local2SQLformat:  nach �derung: type=|$fieldtype|, var=|$var|");
                }
                $var .= ".0" unless $var =~ /\./;
        } elsif($fieldtype eq "date") {
#                $var =~ s/\./\-/g;
#                $var =~ /(\d+)\-(\d+)\-(\d+)/;
#                $tag=$1;$monat=$2;$jahr=$3;
#                $jahr += 2000 if $jahr < 45;
#                $jahr += 1900 if $jahr < 1000;
#                $var = $tag."-".$monat."-".$jahr;
                $var = join('-',&db_inp_date($var));
        } elsif($fieldtype =~ /int/) {
                return "\'$var\'" if ($var eq '0');
        } elsif ($fieldtype =~ /bool/) {
                return undef if ($var eq "'u'");
                return $1 if ($var =~ /^'(.)'$/);
        }
        return $var;
}

#
# building a search-string for values of type char
#
sub pr_char_suchw {
        my ($name,$quer_wert,$vgl,$foptype,$dispname,$rsuche,$rbind_values) = @_;
        $quer_wert = &pr_local2SQLformat($quer_wert,$foptype);
        &dbprint(7,"pr_char_suchw: quer_wert=|$quer_wert|, type=|$foptype|, vgl=|$vgl|, dispname=|$dispname|");
        #
        # hat der User einen % Wildcard selbst eingegeben, dann benutzen wir seine Vorgaben
        if(!$vgl && ( $quer_wert =~ /\%/ || $quer_wert =~ /\_/ )) {
                $vgl = "LIKE";
        } elsif ( !$vgl ) {
              if ( $foptype eq "char") {
                      $vgl = "=";
              } else {
                      if ($dispname =~ /multiplepopup/ && $quer_wert =~ /:::/) {
                              # multiplepopup mit 'OR' - suche verbinden
                              my @mvalues = split(/:::/,$quer_wert);
                              my $suchw = "";
                              foreach my $mvalue (@mvalues) {
                                      unless ($suchw) {
                                              $suchw = "(";
                                      } else {
                                              $suchw .= " OR ";
                                      }
                                      $suchw .= qq{a."$name" LIKE ?};
                                      push(@$rbind_values,"%$mvalue%");
                              }
                              $$rsuche .= "$suchw )";
                              &dbprint(7,"pr_char_suchw: name=|$name|, vgl=|$vgl|, rsuche=|$$rsuche|, quer_wert=|$quer_wert|");
                              return;
                      } elsif ($quer_wert =~ /[^\.\*\\\(\)\[\]\{\}\^\$\|\?].*$/  &&  !$vgl) {
                              #   Wenn der String Elemente einer 'regular-expression' enth�t, dann
                              #   den Operator 'LIKE' verwenden, sonst
                              #   den Operator '~*' = case-insensitive match
                              $vgl = "~*";
                      } else {
                              $vgl = "LIKE";
                              $quer_wert = "%" . $quer_wert . "%"
                      }
              }
        }
        $$rsuche .= qq{a."$name" $vgl ?};
        push(@$rbind_values,$quer_wert);
        &dbprint(7,"pr_char_suchw: name=|$name|, vgl=|$vgl|, rsuche=|$$rsuche|, quer_wert=|$quer_wert|");
}

#
# building a searchstring for values of type date
#
sub pr_date_suchw {
        my ($name,$quer_wert,$vgl,$rsuche,$rbind_values) = @_;
        my $vglda   = ">=";
        my $vglde   = "<";
        $vglde     = "<=" if ($quer_wert =~ /^!?\[.*\]$/); # Zeitraum Angabe
        my $vgnot   = 0;
        $vgnot      = 1 if ($quer_wert =~ /^!\[.*\]$/); # Zeitraum Angabe negiert
        if ($vgl eq "!=" || $vgl eq "<>") {
                $vgl = "=";       # Wie Operator '=' behandeln, aber 'NOT' setzen
                $vgnot = 1;
        }
        $vgl = "" if ($vgl eq "="); # Operator '=' wirkt in allen F�len als sei kein Operator gesetzt.
        my $vglwert = qq{(a."$name" $vglda ? AND a."$name" $vglde ?)};
        $vglwert    = "NOT $vglwert" if ($vgnot);
        &dbprint(7,"pr_date_suchw: quer_wert=|$quer_wert|, name=|$name|, vgl=|$vgl|");
        my $datum   = $quer_wert;
        $datum = join('-',&db_inp_date($quer_wert)) unless ($quer_wert =~ /^\[.*]$/);
        &dbprint(7,"pr_date_suchw: datum=|$datum|");
        if ($datum =~ /^!?\[(\d\d?(\.|\/|-)\d\d?(\.|\/|-)\d{1,4})\s*-\s*(\d\d?(\.|\/|-)\d\d?(\.|\/|-)\d{1,4})\]$/) {
                # Angabe eines Zeitraumes mit jeweils Anfang bzw. Ende = Tag-Monat-Jahr als '[Anfang-Ende]'
                my $anfdat = $1;
                my $enddat = $4;
                $anfdat = join('-',db_inp_date($anfdat));
                $enddat = join('-',db_inp_date($enddat));
                &dbprint(7,"pr_date_suchw: anfdat=|$anfdat|, enddat=|$enddat|, datum=|$datum|");
                $$rsuche .= $vglwert;
                push(@$rbind_values, $anfdat);
                push(@$rbind_values, $enddat);
        } elsif ($datum =~ /^\-(\d+)\-(\d+)$/ ) {     # Angabe von Monat und Jahr gegeben.
                my $monat   = $1; $jahr = $2;
                my $atermin = &db_bind_date("01-$monat-$jahr");
                if ($monat eq 12) {   # Bei Dezember auf Januar des folgejahres schalten.
                        $monat = 1;
                        $jahr++;
                } else {
                        $monat++;
                }
                my $etermin = &db_bind_date("01-$monat-$jahr"); # Endtermin = 1. Tag des Folgemonats.
                if ( $vgl ) {
                        if ($vgl eq ">") {
                                $vgl     = ">=";
                                $atermin = $etermin;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values, $atermin);
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values, $atermin);
                        push(@$rbind_values, $etermin);
                }
        } elsif ( $datum =~ /\-Q([1-4])\-(\d+)/i ) {   #Angabe eines Quartals gegeben
                my $weq   = $1;
                my $jahra = $2;
                my $jahre = $jahr;
                my $mona = ($weq == 1 ? "01" : ($weq == 2 ? "04" : ($weq == 3 ? "07" : "10")));
                my $mone = ($weq == 1 ? "04" : ($weq == 2 ? "04" : ($weq == 3 ? "10" : "01")));
                $jahre = $jahra + 1 if ($weq == 4);
                if ( $vgl ) {
                        if ( $vgl eq ">" ) {
                                $vgl   = ">=";
                                $mona  = $mone;
                                $jahra = $jahre;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,&db_bind_date("01-$mona-$jahra" ));
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values,&db_bind_date("01-$mona-$jahra"));
                        push(@$rbind_values,&db_bind_date("01-$mone-$jahre"));
                }
        } elsif ( $datum =~ /\-H([12])\-(\d+)/i ) {  # Angabe eines Halbjahres gegeben.
                my $weh    = $1;
                my $jahrh  = $2;
                my $amonj  = &db_bind_date("01-" . ($weh == 1 ? "01" : "07") . "-$jahrh");
                my $emonj  = &db_bind_date("01-" . ($weh == 1 ? "07" : "01") . "-" . ($weh ==1 ? $jahrh : ($jahrh + 1)));
                if( $vgl ) {
                        if ($vgl eq ">") {
                                $vgl   = ">=";
                                $amonj = $emonj;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,$amonj);
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values, $amonj);
                        push(@$rbind_values, $emonj);
                }
        } elsif ( $datum =~ /^\-\-(\d+)$/ ) {   # Angabe eines Jahres gegeben.
                my $jahr    = $1;
                my $endjahr = $jahr + 1;
                if ( $vgl ) {
                        if ($vgl eq ">") {
                                $jahr = $endjahr;
                                $vgl  = ">=";
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,&db_bind_date("01-01-$jahr"));
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values,&db_bind_date("01-01-$jahr"));
                        push(@$rbind_values,&db_bind_date("01-01-$endjahr"));
                }
        } else {               # Angabe eines echten Datums gegeben
                $vgl      = "=" unless $vgl;
                $$rsuche .= ($vgnot ? qq{NOT (a."$name" $vgl ?) AND } : qq{(a."$name" $vgl ?)});
                push(@$rbind_values, &db_bind_date($datum));
        }
}

#
# building a searchstring from booleans
#
sub pr_bool_suchw {
        my ($name,$quer_wert,$vgl,$rsuche,$rbind_values) = @_;
        $quer_wert = '' unless $quer_wert;
        my $erg    = 0;
        $quer_wert = $1 if ($quer_wert =~ /^'(.)'$/);
        $vgl       = "=" unless $vgl;
#        &dbprint(7,"pr_bool_suchw: quer_wert=|$quer_wert|, name=|$name|, vgl=|$vgl|");
        if ($quer_wert eq 'f' || $quer_wert eq 't') {
                $$rsuche .= qq{a."$name" $vgl ?};
                push(@$rbind_values,$quer_wert);
                $erg = 1;
        }
        return($erg);
}

#
# building a searchstring from numbers
#
sub pr_number_suchw {
        my ($name,$number,$vgl,$foptype,$rsuche,$rbind_values) = @_;
        &dbprint(7,"pr_number_suchw: number=|$number|, name=|$name|, vgl=|$vgl|, foptype=|$foptype|");
        if ($foptype =~ /float.*/ && (!$vgl || $vgl eq '=')) {
                my $value = &pr_local2SQLformat($number, $foptype);
                $$rsuche .= qq{dround(a."$name" + 0.5) = dround($value + 0.5)};
        } else {
                $vgl      = "=" unless $vgl;
                $$rsuche .= qq{a."$name" $vgl ?};
                push(@$rbind_values,&pr_local2SQLformat($number, $foptype));
        }
}

#
# selecting an operator from a field_value to build a correct search string
#
#                  Festlegung fr welche Datentypen welche Operatoren zul�sig sind:
#                  1 = 2**0, char's
#                  2 = 2**1, date
#                  4 = 2**2, bool
#                  8 = 2**3, alle brigen
sub pr_get_operator {
        my($foptype,$quer_wert) = @_;
        my %Field_Type  = ("char"=>1,"text"=>1,"date"=>2,"bool"=>4,"sonstige"=>8);
        my @pg_ops      = ("<=","<>","<",">=","=",">","\\\|\\\|","!=","~~","!~~","~\\\*","!~\\\*","!~","~");
        my %pg_op_types = ("<"=>2+8,"<="=>2+8,"<>"=>1+2+4+8,"="=>1+2+4+8,">"=>2+8,">="=>2+8,"||"=>0,
                           "!="=>1+2+8,"~~"=>1,"!~~"=>1,"~"=>1,"~\\\*"=>1,"!~"=>1,"!~\\\*"=>1);

        $foptype      = "char" if ($foptype =~ /char/);
        my $fopnumber = $Field_Type{$foptype};

#        &dbprint(7,"pr_get_operator: Vor Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|");
        unless ($fopnumber) {
                $foptype   = "sonstige";
                $fopnumber = $Field_Type{$foptype};
        }
#        &dbprint(7,"pr_get_operator: Vor Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|");

        my $vgl = "";
        foreach my $vglx (@pg_ops) {   # Bestimmen des Operators
                last unless $quer_wert;
                my $vglt = "^" . $vglx . "\\s*(\\S.*)\$";
#                &dbprint(10,"pr_get_operator: Vor Treffer quer_wert=|$quer_wert|, type=|$foptypen|, vgl=|$vgl|,vglt=|$vglt|");
                if ( $quer_wert =~ /$vglt/ ) {
                        if ( $pg_op_types{$vglx} & $fopnumber ) {
                                $quer_wert = $1;
                                $quer_wert = $1 if($quer_wert =~ /^'(.+)'\s*$/);
                                $vgl = $vglx;
                                $vgl =~ s/\\//g;
                                last;
                        }
                }
        }
#        &dbprint(7,"pr_get_operator: Nach Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|,vgl=|$vgl|");
        return($vgl,$quer_wert,$foptype,$fopnumber);
}

#
# setting one Parameter of the Hashfield parms
#
sub pr_set_parms {
        my ($parm_wen,$womit) = shift;
        $$rparms{$parm_wen} = $womit;
        return;
}
#
# loading one Parameter of the Hashfield parms
#
sub pr_get_parms {
        my $parm_wen = shift;
        return($$rparms{$parm_wen});
}

#
# loading one Parameter of the Hashfield parms
#
sub pr_get_parmfields {
        my ($name,$dispname,$fieldtype) = @_;
        my @Werte = $qu->param($name);
        &dbprint(7,"pr_get_parmfields: name=|$name|, dispname=|$dispname|, fieldtype=|$fieldtype|");
        my $erg = &pr_get_RelValues($name,$dispname,$fieldtype,\@Werte);
#        &dbprint(7,"pr_get_parmfields: erg=|$erg|");
        return($erg);
}

#
# Routinen zum crypten und decrypten von Werten fr user-files
#
my $td;

sub crypt_start {
	my $user	= $ENV{'REMOTE_USER'};
	$user		= $ENV{'USER'} unless $user;
	$user	   	= substr(`id`,0,8) unless $user;

	$td  = Mcrypt->new(	algorithm => Mcrypt::BLOWFISH,
				mode => Mcrypt::CFB,
				verbose => 0);

	&dbError(&gtext("crerror")) unless $td;

	my $keysize = $td->{KEY_SIZE};
	my $ivsize  = $td->{IV_SIZE};
	my $keypart = substr($$rconfigs{'keypart'},0,12);
	my $key     =   $keypart . $user .
			$ENV{"REMOTE_ADDR"} . $ENV{"HTTP_USER_AGENT"} .
			"als Schluessel fuer dbengine";
	$key        = substr($key,0,$keysize);
	my $iv      = substr($ENV{"HTTP_HOST"} . $ENV{"HTTP_ACCEPT_LANGUAGE"} .
			"als IV Schluessel", 0, $ivsize);
	$td->init($key, $iv);
	return;
}

sub name_crypt {
	my ($name) = @_;
	my $erg = $td->encrypt($name);
	return (encode_base64($erg,''));
}

sub name_decrypt{
	my ($name) = @_;
	my $erg;
	&dbprint(10,"name_decrypt: name=|$name|");
	$name = decode_base64($name);
	$erg = $td->decrypt($name);
	&dbprint(10,"name_decrypt: erg=|$erg|");
	return ($erg);
}

sub crypt_stop {
	$td->end($td);
}


#
# print the given $message and the current database
# error message to STDOUT and die unless $check
sub dBaseError {
        my ($errstr,$cmd, $format, @Werte) = @_;
	if (@Werte) {
		printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
	} else {
		print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
	}
	print "<H4><FONT COLOR=red><P>+++" . &gtext('dberror') . ":<br>+++$errstr<BR></FONT></H4>\n";
	print "<P><FONT COLOR=red>" . &gtext('bcmd') . ": $cmd </FONT><P>" if $cmd;

	&db_db_disc;
	exit(1);
}


sub dbError {
        my ($format,@Werte) = @_;
	if (@Werte) {
		printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
	} else {
		print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
	}

	&db_db_disc;
	exit(1);
}

sub dbWarning {
        my ($format,@Werte) = @_;
        if (@Werte) {
                printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
        } else {
                print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
        }
}

sub dbWarnText {
        my ($format,@Werte) = @_;
        if (@Werte) {
                return(sprintf("<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte));
        } else {
                return("<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n");
        }
}



1;

