############################
#
# dbengine_out.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.2
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
# Version 1.01
# <c> 1997, 1998, 1999 Detlef Duerr
# get closer Information from email Detlef.Duerr@atm-computer.de
# older version
# <c> 1996 Ingo Ciechowski
# see closer information at http://www.cis-computer.com/dbengine
#
#  Output Library for dbengine.pl new version
#
#  Routinen zur Ausgabe der Texte, Frames fr die
#  dynamische HTML-Seite
#
##########################

my $qu;
my $rconfigs;
my $rparms;
my $rfielddesc;
my $rrelations;
my $rvalues;
my $rbuttons;

my $mode;
my $user;
my $dbase;
my $dbasen;
my $kennz;
my $table;

#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
sub pr_db_init {
        ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;

        print $qu->header;

}

#
# Start der HTML-Ausgabe, Erzeugen von HTML-header und dem notwendigen Teil bis zu der
# Stelle, an der die spezifischen Ausgaben erfolgen.
# Verzweigen ber die verschienen Stati (mode) des Systems.
#
sub pr_db_start {
        local *parms    = $rparms;
        local *configs  = $rconfigs;

        $mode   = $parms{'mode'} if $parms{'mode'};
        $user   = $parms{'user'} if $parms{'user'};
        $dbase  = $parms{'dbase'} if $parms{'dbase'};
        $kennz  = $parms{'kennz'} if $parms{'kennz'};
        $table  = $parms{'table'} if $parms{'table'};
        $parms{'dbasen'} = $dbasen = &dbase_get_name($dbase) if $dbase;
        &dbprint_hash(9,"pr_db_start: parms", $rparms);

        if ( ($mode eq 'userdefine' && defined $dbase)) {       # Erzeugen der Frames
                print "<HTML><HEAD><TITLE>$configs{'MainTitle'}$parms{'dbasen'}</TITLE>\n";
                      qq{<link rev="made" href="mailto:Detlef.Duerr%40gmx.de" /></HEAD>\n};
        } elsif ( $mode eq 'empty') {
                print $qu->start_html(  -title=>$configs{'MainTitle'} . 'DBENGINE',
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                _target=>'body',
                                -BGCOLOR=>$configs{'bgcol'});
        } elsif ($mode eq 'menu') {
                print $qu->start_html( -title=>$configs{'MainTitle'} . &gtext('dtitle') . ": $dbase",
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                _target=>'menu',
                                -BGCOLOR=>$configs{'bgmcol'});
        } elsif ($mode eq 'userget') {
                print $qu->start_html( -title=>$configs{'MainTitle'} . &gtext('utitle'),
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                -BGCOLOR=>$configs{'bgcol'});
        } elsif ($mode eq 'userdefine') {
                print $qu->start_html( -title=>$configs{'MainTitle'} . &gtext('dtitle'),
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                -BGCOLOR=>$configs{'bgcol'});
        } elsif ($mode eq 'action') {
                print $qu->start_html( -title=>$configs{'MainTitle'} . &gtext('atitle'),
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                _target=>'body',
                                -BGCOLOR=>$configs{'bgcol'});
        } else {
                print $qu->start_html( -title=>$configs{'MainTitle'} . &gtext('ttitle') . ": $table",
                                -author=>'Detlef.Duerr@gmx.de',
                                _base=>'true',
                                _target=>'body',
                                -BGCOLOR=>$configs{'bgcol'});
        }
}

sub pr_db_finish {
        print $qu->end_html;
}

#
# print all those fields into our page whose values
# we might need upon our next call
#
sub pr_db_stop {
        local *parms    = $rparms;

        print $qu->hidden('mode',$parms{'mode'}) . "\n" if $parms{'mode'};
        &pr_db_stop_o_mode;
}

#
# print all field but 'mode' and end the form and page
#
sub pr_db_stop_o_mode {
        local *parms = $rparms;

        $qu->delete_all;
        print $qu->hidden('dbase',$parms{'dbase'}) . "\n" if $parms{'dbase'};
        print $qu->hidden('user',$parms{'user'}) . "\n" if $parms{'user'};
        print $qu->hidden('kennz',$parms{'kennz'}) . "\n" if $parms{'kennz'};
        print $qu->hidden('table',$parms{'table'}) . "\n" if $parms{'table'};

        if(defined $parms{'oid'}) {
                print $qu->hidden('oid', $parms{'oid'}) . "\n";
                $$rvalues{'tmin'}       =~ s/ //g if ( $$rvalues{'tmin'} );
                print $qu->hidden('tmin', $$rvalues{'tmin'});
        }

#        print $qu->endform . "\n";
        print "</form>\n";
        &pr_db_finish;
}

#
# Routine zur Ausgabe des Beginns der Eingabeteile
#
sub pr_form_start {
        my $title       = shift;

        print <<EOM
        <H1><CENTER>$title</CENTER></H1>
        <FORM METHOD=POST ACTION="dbengine.cgi">
        <P>
EOM
;
}

#
# Routine zur Ausgabe des Beginns der Eingabeteile
#
sub pr_list_start {
        my $title       = shift;

        print "<H1><CENTER>$title</CENTER></H1>\n<P>\n";
}

#
# Routine zum Ausgeben einer appendliste fr eine Referenz zum weiteren Aufruf
#
sub pr_create_appendref {
        my ($text, $stable, $sfield, $gfield) = @_;

        local *parms = $rparms;
        &dbprint(7,"pr_create_appendref: stable=|$stable|, sfield=|$sfield|, gfield=|$gfield|, text=|$text|");

        $qu->delete_all;
        $qu->append(-name=>'table',-value=>$stable);
        $qu->append(-name=>'dbase',-value=>$parms{'dbase'});
        $qu->append(-name=>'kennz',-value=>$parms{'kennz'});
        $qu->append(-name=>'mode',-value=>'search');
        $qu->append(-name=>'fields', -value=>"$sfield");
        $qu->append(-name=>'value',-value=>"$gfield") if($sfield && $gfield);
        print "<A HREF=\"dbengine.cgi?" . $qu->query_string . "\">$text</A>";
}

#
# Routine zur Ausgabe eines Listings aufgrund einer 'such'-Anweisung
#
my $listtable_module_exist = 0;

sub pr_listTable {
#        require "dbengine_listtable.pl";
#        unless ($listtable_module_exist) {
#                &listtable_init($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues);
#                $listtable_module_exist = 1;
#        }
        &listtable;
}

#
# Routinen zur Ausgabe einer Bildschirmmaske fr eine Relation
#
my $plaindialog_module_exist = 0;

#
# Starten der Maskenerzeugung und globale Fallunterscheidungen
#
sub pr_create_dialog {
#        &dbprint(7,"pr_create_dialog: Modul anfordern: INC=|@INC|");
#        require "dbengine_plaindialog.pl";
#        &dbprint(7,"pr_create_dialog: Modul geladen");
#        unless ($plaindialog_module_exist) {
#                &dbprint(7,"pr_create_dialog: module_exist=|$plaindialog_module_exist|");
#                &plaindialog_init($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues);
#                $plaindialog_module_exist = 1;
#        }
        &createdialog;
}

#
# remove those fields that have a given order from the
# displayinfo table from our parameter array @in, sort
# them in the requested display order and return the
# sorted plus unsorted fields in @out
#
sub xSort {
        my @in = @_;
        my @out;
        my $rfielddisporder =  $rfielddesc{'fielddisporder'};

        foreach my $index (sort keys %$rfieldddisporder) {
                push    @out, $$rfielddisporder{$index};
                @in     = &xDel($$rfielddisporder{$index}, @in);
        }
        push @out, (sort @in);
        @out;
}

#
# delete the element with value $element from
# the given array @in and return the remaining
# components in @out
#
sub xDel {
        my ($element, @in) = @_;
        my @out;

        foreach my $name (@in) {
                push @out, $name unless $element eq $name;
        }
        @out;
}

#
# get the maximum number of columns
# specified by the displayinfo table
#
sub maxCols {
        my $cols        = 0;
        my $rfielddispcolumn = $$rfielddesc{'fielddispcolumn'};
        foreach my $name (values %$fielddispcolumn) {
                $cols   = $name if $name > $cols;
        }
        $cols;
}

#
# Routine zur Anforderung von username und passwort
#
sub pr_form_pw {
        local *configs  = $rconfigs;
        local *parms    = $rparms;

        print "<CENTER><TABLE Border=0>\n";

        unless($parms{'user'}) {
                # User und Passwort anfordern, wenn kein user vorhanden
                my $username = &gtext('user');
                my $password = &gtext('passwd');
                print <<EOM
                <TR><TD>$username:</TD>
                <TD><INPUT TYPE=TEXT SIZE=30 MAXLENGTH=30 NAME="user"></TD></TR>
                <TR><TD>$password:</TD>
                <TD><INPUT TYPE=PASSWORD SIZE=30 MAXLENGTH=30 NAME="pwd"></TD></TR>
                <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
                <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
EOM
;
        }
        unless ($parms{'dbase'}) {
                # Wenn nicht vorhanden, Datenbank bzw. DBSystem anfordern
                my $auswahl;
                my @dbdats;
                my $dbsys;
                my $namea;

                if ($parms{'dbsystem'}) {
                        @dbdats = &dbase_get_sources($parms{'dbsystem'});
                        if (@dbdats == 1) {
                                $parms{'dbase'} = shift @dbdats;
                        } elsif (!@dbdats) {
                                &dberror(&gtext('dbserror'));
                        } else {
                                $auswahl = &gtext('dbase') . ":";
                                $namea   = "dbase";
                                &dbprint(8,"pr_form_pw: Treiber=|%s|, Datenbanken (Anzahl=|%d|)=|@dbdats|",
                                         $parms{'dbsystem'},$#dbdats + 1);
                        }
                }
                if (@dbdats > 1) {
                        &pr_get_dbs($auswahl,$namea,\@dbdats);
                }
        }
}

#
# Allgemeines Ende des Formscripts
#
sub pr_form_stop {
        my @submits = @_;

        print <<EOM
        <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
        <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
        <TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>
        <TR>
EOM
;
        foreach my $subm (@submits) {
                print "<TD><INPUT TYPE=SUBMIT VALUE=\"$subm\"></TD>\n";
        }
        print <<EOM
        </TR>
        </TABLE></CENTER>
EOM
;
}

#
# create a simple HTML popup menu that displays all the different values
# in $relField from table $relTable in the main database
#
sub relationPopup {
        my ($popupArt,$name, $relTable, $relField, $reldField, $mlines) = @_;
        my $popup;
        my $rtestField;
        my $rtestWert;
        my $vname = ($$rvalues{$name} ? xChop($$rvalues{$name}) : "");
        &dbprint_hash(9,"relationPopup: vname=|$vname|, rvalues", $rvalues);

        my $cmd = "";
        if ($relField =~ /^\s*(\w+)\s+(\w+)\s+([^\s].*[^\s])\s*$/ ) {
                $relField = $1;
                $rtestfield = $2;
                $rtestWert = $3;
                if ($rtestWert =~ /^'(.+)'$/ ) {
                        $rtestWert = $1;
                }
                $cmd = "WHERE $rtestfield = \'$rtestWert\' ";
        }
        $cmd      .= "ORDER BY $relField";
        $reldField = $relField unless $reldField;
        $cmd = "SELECT DISTINCT $relField as relField, $reldField as reldField FROM $relTable " . $cmd;
        &dbprint(9,"relationPopup: cmd=|$cmd|");
        my ($ntuples, $res) = &db_db_get_nrows('dbase',$cmd);

        my $size = 1;
        my $reltupleanz = $$rconfigs{'reltupleanz'};
        $reltupleanz = 25 unless $reltupleanz;
        my $reltuplelines = $$rconfigs{'reltuplelines'};
        $size = ($reltuplelines ? $reltuplelines : 2 ) if ( $ntuples > $reltupleanz );
        &dbprint(9,"relationPopup: ntuples=|$ntuples|, size=|$size|, res=|$res|");

        my @popupvalues;
        #
        # get all records and add the relnames to the popup
        while (my $rarray = $res->fetch) {
                my $value = xChop($$rarray[0]);
                my $vdisp = $value;
                $vdisp = "$value ($$rarray[1])" if($reldField ne $relField);
                if($vname &&  $vname eq $value) {
                        $vname = $vdisp;
                } else {
                        push(@popupvalues, $vdisp);
                }
        }


        #
        # start with the <SELECT tag and add (if any) the real value of the field as first <OPTION>
        if ($popupArt =~ /^relation/ ) {
                $popup  = "<SELECT NAME=\"__$name\" SIZE=$size>\n<OPTION>";
                $popup .=  $vname . "\n<OPTION>\n" if $vname;
        } else {
                my $mSize = $$rconfigs{'mreltupellines'};
                $mSize = 4 unless $mSize;
                $mSize = $mlines if $mlines;
                $popup = "<SELECT NAME=\"__$name\" SIZE=$mSize MULTIPLE>\n";
                &dbprint(9,"relationPopup: name=|$name|, vname=|$vname|");
                if($vname) {
                        my @vnames = split(/:::/,$vname);
                        &dbprint(9,"relationPopup: vname=|$vname|, anz_vnames=|" . @vnames . "|, vnames=#@vnames#");
                        foreach my $value (@vnames){
                                $popup .=  "<OPTION SELECTED>$value\n";
                        }
                }
                $popup .= "<OPTION>";
        }

        #
        # scan all records and add the relnames to the popup unless it's the default option
        foreach my $vdisp (@popupvalues) {
#                &dbprint(9,"relationPopup: rarray=|@$rarray|, value=|$value|, relfield=|$relField|, reldfield=|$reldField|");
                $popup  .= "<OPTION>$vdisp\n";
        }

        $popup . "</SELECT>\n";
}

#
# create a simple HTML popup menu that displays all the values
# specified in the valuelist table of our display description database for
# this specific field name
#
sub valueListPopup {
        my $name     = shift;
        my $cmd      = "SELECT display,content,orderno FROM valuelist " .
                          "WHERE name = '$name' AND DBaseName='$dbasen' ORDER BY orderno";
        my $result   = &db_db_get('dbdesc',$cmd);
        my $value    = $$rvalues{$name};
        $value       = "" unless $value;
        $value       = &xChop($value);
        $popups      = "";
        my $hiddenfs = "";

        # get all values and create a readable text for them and a hidden valuelist
        while (my $rarray = $result->fetch()) {
                my $disp   = $$rarray[0];
                my $cont   = $$rarray[1];
                $disp      = &gtext($1) if ($disp =~ /^lang\((.+)\)$/);
                $hiddenfs .= $qu->hidden("_:_lang-1__$disp",$cont) . "\n";
                if ($value eq $cont) {
                        $value = $disp;
                } else {
                        $popups .= "<OPTION>" . $disp . "\n"
                }
        }

        #
        # start with the <SELECT tag and add (if any) the real value of the field as first <OPTION>
        my $popup = "<SELECT NAME=\"__$name\" SIZE=1>\n<OPTION>" . $value . "\n";
        $popup   .= "<OPTION>\n" if $value;
        $popup   .= $popups . "</SELECT>\n" . $hiddenfs;
}

#
# Kopfteil fr Datenbank - Menu - Frame erstellen
#
sub pr_men_frame_kopf {
        print "<CENTER><H2>";
        print &gtext('database') . ":<BR>" . &upfirst($dbasen) . "</H2></CENTER>\n";
        if ( my $schemas = $$rparms{'schemas'} ) {
                print "<H3><CENTER>" . &gtext('schema') . ":<BR>\n$schemas</CENTER></H3>\n" ;
        }
}

#
# Liste der Datenbanken fr Auswahl erstellen
#
sub pr_get_dbs {
        my $auswahl = shift; my $namea = shift; local *dbdats = shift;

        print "<TR><TD width=25%>$auswahl</TD><TD><SELECT NAME=\"$namea\" SIZE=1>\n";
        foreach my $elem (@dbdats) {
                my $p2 = $elem;
                $p2 = &dbase_get_name($elem) if $namea eq 'dbase';
                print "<OPTION VALUE=\"$elem\">$p2\n";
        }
        print "</SELECT></TD></TR>\n";
}

#
# Texte aus sprachbezogenem Texthash holen
#
sub gtext {
        my $gtextindex = shift; my @wert  = @_;
        my $gtextcmd = "SELECT translate_text, language FROM langtexts WHERE indextext = ?";
        my $erg;
        my $format = "";

        # get the value from database
        $format = &db_gtextb($gtextcmd,'translate_text',$gtextindex,);

        if (@wert) {
                &dbprint(11,"gtext: index=|$gtextindex|, werte=|@wert|, erg=|$format|");
                $erg = sprintf($format,@wert);
        } else {
                &dbprint(11,"gtext: index=|$gtextindex|, erg=|$format|");
                $erg = $format;
        }
        # $erg must be quoted for html-output , will be done later
        return($erg);
}

#
# Buttontexte aus Buttonhash holen
#
sub sbutton {
        my $key = shift;
        return (&db_gtextb("SELECT translate_text, language FROM langtexts WHERE button AND indextext = ?",'translate_text',$key));
}

#
# Buttonschluessel zu buttonwert aus buttonhash holen (reversefunktion von sbutton)
#
sub gbutton {
         my $value = shift;
         return(&db_gtextb("SELECT indextext, language FROM langtexts WHERE button='t' AND translate_text = ?",'indextext',$value));
}

#
# Ersten Buchstaben eines Wortes gro?chreiben oder Alle, wenn spezialword
#
sub upfirst {
        my $var  = shift;
        #
        # this function returns a name with the first and every character direct after a '_'
        # made to an uppercase character if the language is german
        local *configs = $rconfigs;
        my $var1 = ucfirst($var);
        my $var2;
        my @abk  = &get_db_array('shortenings');
        my $abk1;

        &dbprint(9,"upfirst: var=|$var|, var1=|$var1|, lang=|$configs{'upfirst'}|");
        return $var unless ($configs{'upfirst'});
        $var = "";
        while ( $var1 =~ /_/ ) {
                ($var2,$var1) = split("_",$var1,2);
                foreach $abk1 (@abk) {
                        $var2 = uc($var2) if ($var2 =~ /^$abk1$/i );
                }
                $var .= $var2;
                $var .= "_" if $var1;
                $var1 = ucfirst($var1);
        }
        foreach $abk1 (@abk) {
                $var1 = uc($var1) if ($var1 =~ /^$abk1$/i );
        }
        return $var . $var1;
}

#
# Subroutine to quote strings for HTML-output
# using ISO-UNICODE for ISO8859-1
sub pr_quote {
        my @was = split(/\r*/,shift);
        my $erg = "";
        foreach my $char1 (@was) {
                $char = ord($char1);
                my ($char2,$erg1) = &pr_quote_char($char1);
#                &dbprint(9,"pr_qoute: char=|$char|, char1=|$char1|, char2=|$cahr2|, erg1=|$erg1|, erg=|$erg|");
                if ($erg1) {
                        $erg .= $char2;
                } elsif ($char == 60 ) {
                        $erg .= "&#60;"; # '<'
                } elsif ( $char == 62 ) {
                        $erg .= "&#62;"; # '>'
                } else {
                        $erg .= $char1;
                }
        }
        return($erg);
}

sub pr_quote_part {
        my $parm = shift;
        @parms = split(/(&#\d+;|&\w+;)/,$parm);
        &dbprint(7,"pr_quote_part: parm=|$parm|, parms=|@parms|");
        my $erg = "";
        foreach my $was (@parms) {
                &dbprint(7,"pr_quote_part: was=|$was|");
                if ($was =~ /^(&#\d+;|&\w+;)$/) {
                        $erg .= $was;
                        &dbprint(0,"pr_quote_part: erg=|$erg|, was=|$was|");
                        next;
                }
                my @was1 = split(/\r*/,$was);
                &dbprint(7,"pr_quote_part: was=|$was|, was1=|@was1|");
                foreach my $char1 (@was1) {
                        my ($char1,$erg1) = &pr_quote_char($char1);
                        $erg .= $char1;
                }
                &dbprint(7,"pr_quote_part: erg=|$erg|");
        }
        return($erg);
}

sub pr_quote_char {
        my $char1 = shift;
        my $char = ord($char1);
        my $erg = "";
        if( $char >= 160) {
                $erg = "&#" . $char . ";";
        } elsif ( $char == 34 ) {
               $erg = "&#34;"; # '"'
        } elsif ( $char == 38 ) {
               $erg = "&#38;"; # '&'
        } else {
               return($char1,0);
        }
        return($erg,1);
}

#
# This routine checks whether the value of a given field is valid
# in case there's a Perl subroutine defined for this test
# and dies if the test fails.
# In this case the subroutines failure description from @_ is presented
#
sub pr_checkFieldContent {
        my ($name, @Werte) = @_;
        # if there are an input in a multipleselect-field, it will be given as a valuelist combinde with ', '

        my $content;
        my $rcurrent = $$rfielddesc{$name};
        my $dispname = $$rcurrent{'DISPLAY'};
        $dispname = "" unless $dispname;
        my $fieldtype = $$rcurrent{'TYPE'};
        $fieldtype = "" unless $fieldtype;
        my $warning = 0;

        $content = &pr_get_relvalues($name, \@Werte);
        &dbprint(7,"pr_checkFieldContent: name=|$name|, content=|$content|, Werte=|@Werte|");
        $content = "" unless (defined $content);
        &dbprint(7,"pr_checkFieldContent: name=|$name|, content=|$content|");

        my $feval = $$rcurrent{'EVAL'};
        if($feval) {
                @_ = ( $content );
                my($was) = $feval;
                $was     =~ tr/\r/ /;
                &dbprint (7,"pr_checkFieldContent: content=\'$content\', \@_=|@_|, name=\'$name\', eval=[".$feval."]");
                $content = eval "$was";
                #
                # if there's an error during the evaluation we
                # display the error message just before we die :-((
                &dbprint (7,"pr_checkFieldContent: nach eval: content=\'$content\', \@_=@_");
                if ($@) {
                        &dbWarning(&gtext('eingerr',$name,$@,$content));
                        $warning = 1;
                }
        }
        if ( !$content && $$rcurrent{'NOTNULL'}  &&  (!$$rcurrent{'DEFAULT'} || $$rparms{'mode'} ne 'add')) {
                &dbprint_hash(9,"pr_checkFieldContent: name=|$name|, rfielddesc=",$$rfielddesc{$name});
                &dbWarning(&gtext('eingmuss',$name));
                $warning = 1;
        }
        $$rvalues{$name} = $content;
        &dbprint(7,"pr_checkFieldContent: name=|$name|, content=|$content|, warning=|$warning|");

        return($warning, $content);
}

sub pr_get_relvalues{
        my ($name, $rWerte) = @_;
        # if there are an input in a multipleselect-field, it will be given as a valuelist combinde with ', '

        my $dispname = $$rfielddesc{$name}{'DISPLAY'};
        $dispname = "" unless $dispname;
        my $fieldtype = $$rfielddesc{$name}{'TYPE'};
        $fieldtype = "" unless $fieldtype;
        return(&pr_get_RelValues($name,$dispname,$fieldtype,$rWerte));
}

#
# Getting the Values from input modifying them if popup-fields
# also for external use
#
sub pr_get_RelValues {
        my ($name,$dispname,$fieldtype,$rWerte) = @_;
        my $warning = 0;
        my $content;
        &dbprint(7,"pr_get_RelValues: name=|$name|, dispname=|$dispname|, fieldtype=|$fieldtype|, rWerte=|@$rWerte|");

        foreach my $wert (@$rWerte) {
                if ($dispname =~ /^\s*(relationpopup|multiplepopup)/ ) {
                        $wert = $1 if ( $wert =~ /^\s*([^\s]+)\s+\(.+\)\s*$/ );
                        if ($dispname =~ /multiplepopup/){
                                unless ($fieldtype =~ /(char|text)/ ) {
                                        &dbWarning(&gtext('multpopntext',$name,$fieldtype));
                                        $warning = 1;
                                }
                                $wert = $1 if ( $wert =~ /^\s*([^\s]*)\s+\(.*\)\s*$/ );
                                $wert = "$wert";
                        }
                } elsif ($dispname =~ /^s*popup/  && $$rparms{"_:_lang-1__$wert"}) {
                        $wert = $$rparms{"_:_lang-1__$wert"};
                } elsif ($fieldtype =~ /^bool/ && $wert eq 'u') {
                        $wert = "";
                }
                $content .= ":::" if (defined $content && defined $wert);
                $content .= $wert if defined $wert;
        }
        return($content);
}

sub pr_local2SQLformat {
        my ($var, $fieldtype) = @_;

        &dbprint(7, "pr_local2SQLformat: var=|$var|, type=|$fieldtype|");
        if($fieldtype =~ /float/ || $fieldtype =~ /numeric/) {
                $var =~ s/ //g;
                if($var =~ /^(.+),(\d+)$/) {
                        my $var1 = $1;
                        my $var2 = $2;
                        $var1 =~ s/\.//g;
                        $var  = "$var1.$var2";
                        &dbprint(7,"pr_local2SQLformat:  nach ?derung: type=|$fieldtype|, var=|$var|");
                }
                $var .= ".0" unless $var =~ /\./;
        } elsif($fieldtype eq "date") {
                $var = join('.', &db_inp_date($var));
        } elsif($fieldtype =~ /int/) {
                return "\'$var\'" if ($var eq '0');
        } elsif ($fieldtype =~ /^bool/) {
                return undef if ($var eq "'u'");
                return $1 if ($var =~ /^'(.)'$/);
        }
        return $var;
}

#
# building a search-string for values of type char
#
sub pr_char_suchw {
        my ($name,$quer_wert,$vgl,$foptype,$dispname,$rsuche,$rbind_values) = @_;
        $quer_wert = &pr_local2SQLformat($quer_wert,$foptype);
        &dbprint(6,"pr_char_suchw: quer_wert=|$quer_wert|, type=|$foptype|, vgl=|$vgl|, dispname=|$dispname|");
        if ($quer_wert eq '0') {
                $$rsuche .= qq{a."$name" = '0' };
                return(1);
        } elsif (!$quer_wert) {
                return (0);
        }
        #
        # hat der User einen % Wildcard selbst eingegeben, dann benutzen wir seine Vorgaben
        if(!$vgl && ( $quer_wert =~ /\%/ || $quer_wert =~ /\_/ )) {
                $vgl = "LIKE";
        } elsif ( !$vgl ) {
              if ( $foptype eq "char") {
                      $vgl = "=";
              } else {
                     &dbprint(6,"pr_char_suchw: vgl=|$vgl|, quer_wert=|$quer_wert|");
#                     if ($dispname =~ /multiplepopup/ && $quer_wert =~ /:::/) {
                     if ($dispname =~ /multiplepopup/ ) {
                              # multiplepopup mit 'OR' - suche verbinden
                              my @mvalues = split(/:::/,$quer_wert);
                              my $suchw = "";
                              foreach my $mvalue (@mvalues) {
                                      unless ($suchw) {
                                              $suchw = "(";
                                      } else {
                                              $suchw .= " OR ";
                                      }
                                      $suchw .= qq{a."$name" LIKE ?};
                                      push(@$rbind_values,"%$mvalue%");
                              }
                              $$rsuche .= "$suchw )";
                              &dbprint(7,"pr_char_suchw: name=|$name|, vgl=|$vgl|, rsuche=|$$rsuche|, quer_wert=|$quer_wert|");
                              return (1);
                      } elsif ( $quer_wert =~ /[\.\*\\\(\)\[\]\{\}\^\$\|\?]/ ) {
                              #   Wenn der String Elemente einer 'regular-expression' enth?t, dann
                              #   den Operator 'LIKE' verwenden sonst
                              #   den Operator '~*' = case-insensitive match
                              $quer_wert = "%" . $quer_wert . "%";
                              $vgl = "LIKE";
                      } else {
                              &dbprint(6,"pr_char_suchw: name=|$name|, rsuche=|$$rsuche|, quer_wert=|$quer_wert|");
                              $quer_wert = &pr_char_check_diversification($quer_wert);
                              &dbprint(6,"pr_char_suchw: name=|$name|, quer_wert=|$quer_wert|");
                              $vgl = "~*";
                      }
              }
        }
        $$rsuche .= qq{a."$name" $vgl ?};
        push(@$rbind_values,$quer_wert);
        &dbprint(6,"pr_char_suchw: name=|$name|, vgl=|$vgl|, rsuche=|$$rsuche|, quer_wert=|$quer_wert|");
        return (1);
}

#
# Subroutine to set groups in the string for values that ale possible
# to show other writings of searchable nounces
#
sub pr_char_check_diversification {
        my $old_str = shift;
        my $new_str = "";
my %change_table = ('\xE4'  => '(\xE4|(ae))', '\xF6'  => '(\xF6|(oe))', '\xFC'  => '(\xFC|(ue))',
                            's'  => '(s|(ss)|(sz)|\xDF)',
                            '\xEB' => '((ei)|(ie)|\xEB)',
                            'a'  => '(\xE0|\xE1|\xE2|\xE3|\xE4|\xE5|\xE6|a)',
                            'c'  => '(c|\xE7)',
                            'e'  => '(e|\xE8|\xE9|\xEa|\xEB)',
                            'd'  => '(d|\xF0)',
                            'i'  => '(i|\xEC|\xED|\xEE|\xEF)',
                            'n'  => '((n+)|\xF1|(m+))',
                            'o'  => '(o|\xF2|\xF3|\xF4|\xF5|\x9C|\xF8)',
                            'u'  => '(u|\xF9|\xFA|\xFB|\xFC)',
                            'p'  => 'p+',
                            'y'  => '(y|i|j|\xFD|\xFF)',
                            'r'  => 'r+', 'l'  => 'l+', 'm'  => '((m+)|(n+))',
                            't'  => 't+', 'k'  => '(k|(ck))',
                           );

        # First: change ei/ie -> i, ae->� oe->� ue->�, sz|ss->�, ck->k, ...
        $old_str =~ s/(ei)|(ie)/\xEB/g;
        $old_str =~ s/(ae)/\xE4/g;
        $old_str =~ s/(oe)/\xF6/g;
        $old_str =~ s/(ue)/\xFC/g;
        $old_str =~ s/(ss)|(sz)|\xDF/s/g;
        $old_str =~ s/(ck)/k/g;

        my $anf = 0;
        my $l;
        my $laenge = length($old_str);
        for ($l = 1; $l <= $laenge; $l++) {
                my $astr = substr($old_str,$anf,$l - $anf);
                &dbprint(6,"pr_char_check_diversification: l=|$l|, anf=|$anf|, old_str=|$old_str|, astr=|$astr|");
                for my $ch_w (keys %change_table) {
                        if ($astr =~ /^(.*?)$ch_w/i ) {
                                $new_str .= $1 . $change_table{$ch_w};
                                &dbprint(6,"pr_char_check_diversification: new_str=|$new_str|, astr=|$astr|, ch_w=|$ch_w|");
                                $anf = $l;
                                last;
                        }
                }
        }
        $new_str .= substr($old_str,$anf);
        return ($new_str);
}

#
# building a searchstring for values of type date
#
sub pr_date_suchw {
        my ($name,$quer_wert,$vgl,$rsuche,$rbind_values) = @_;
        my $vglda   = ">=";
        my $vglde   = "<";
        $vglde     = "<=" if ($quer_wert =~ /^!?\[.*\]$/); # Zeitraum Angabe
        my $vgnot   = 0;
        $vgnot      = 1 if ($quer_wert =~ /^!\[.*\]$/); # Zeitraum Angabe negiert
        if ($vgl eq "!=" || $vgl eq "<>") {
                $vgl = "=";       # Wie Operator '=' behandeln, aber 'NOT' setzen
                $vgnot = 1;
        }
        $vgl = "" if ($vgl eq "="); # Operator '=' wirkt in allen Faellen als sei kein Operator gesetzt.
        my $vglwert = qq{(a."$name" $vglda ? AND a."$name" $vglde ?)};
        $vglwert    = "NOT $vglwert" if ($vgnot);
        &dbprint(7,"pr_date_suchw: quer_wert=|$quer_wert|, name=|$name|, vgl=|$vgl|");
        my $datum   = $quer_wert;
        $datum = join('-',&db_inp_date($quer_wert)) unless ($quer_wert =~ /^\[.*]$/);
        &dbprint(6,"pr_date_suchw: datum=|$datum|");
        if ($datum =~ /^!?\[(\d\d?(\.|\/|-)\d\d?(\.|\/|-)\d{1,4})\s*-\s*(\d\d?(\.|\/|-)\d\d?(\.|\/|-)\d{1,4})\]$/) {
                # Angabe eines Zeitraumes mit jeweils Anfang bzw. Ende = Tag-Monat-Jahr als '[Anfang-Ende]'
                my $anfdat = $1;
                my $enddat = $4;
                $anfdat = join('-',db_inp_date($anfdat));
                $enddat = join('-',db_inp_date($enddat));
                &dbprint(7,"pr_date_suchw: anfdat=|$anfdat|, enddat=|$enddat|, datum=|$datum|");
                $$rsuche .= $vglwert;
                push(@$rbind_values, $anfdat);
                push(@$rbind_values, $enddat);
        } elsif ($datum =~ /^\-(\d+)\-(\d+)$/ ) {     # Angabe von Monat und Jahr gegeben.
                my $monat   = $1; $jahr = $2;
                my $atermin = &db_bind_date("01-$monat-$jahr");
                if ($monat eq 12) {   # Bei Dezember auf Januar des folgejahres schalten.
                        $monat = 1;
                        $jahr++;
                } else {
                        $monat++;
                }
                my $etermin = &db_bind_date("01-$monat-$jahr"); # Endtermin = 1. Tag des Folgemonats.
                if ( $vgl ) {
                        if ($vgl eq ">") {
                                $vgl     = ">=";
                                $atermin = $etermin;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values, $atermin);
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values, $atermin);
                        push(@$rbind_values, $etermin);
                }
        } elsif ($quer_wert =~ /^(\d\d?)([^\d])(\d\d?)([^\d])$/ ) {     # Angabe von Tag und Monat gegeben.
                $vgl      = "~*" unless $vgl;
                $datum = sprintf("%02d%s%02d%s",$1,$2,$3,$4);
                &dbprint(6,"pr_date_suchw: quer_wert=|$quer_wert|, datum=|$datum|");
#                $$rsuche .= ($vgnot ? qq{NOT (a."$name" $vgl ?) AND } : qq{(a."$name" $vgl ?)});
                $$rsuche .= ($vgnot ? qq{NOT (a."$name" $vgl ?)} : qq{(a."$name" $vgl ?)});
#                push(@$rbind_values, &db_bind_date($datum));
                push(@$rbind_values, $datum);
        } elsif ( $datum =~ /\-Q([1-4])\-(\d+)/i ) {   #Angabe eines Quartals gegeben
                my $weq   = $1;
                my $jahra = $2;
                my $jahre = $jahr;
                my $mona = ($weq == 1 ? "01" : ($weq == 2 ? "04" : ($weq == 3 ? "07" : "10")));
                my $mone = ($weq == 1 ? "04" : ($weq == 2 ? "04" : ($weq == 3 ? "10" : "01")));
                $jahre = $jahra + 1 if ($weq == 4);
                if ( $vgl ) {
                        if ( $vgl eq ">" ) {
                                $vgl   = ">=";
                                $mona  = $mone;
                                $jahra = $jahre;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,&db_bind_date("01-$mona-$jahra" ));
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values,&db_bind_date("01-$mona-$jahra"));
                        push(@$rbind_values,&db_bind_date("01-$mone-$jahre"));
                }
        } elsif ( $datum =~ /\-H([12])\-(\d+)/i ) {  # Angabe eines Halbjahres gegeben.
                my $weh    = $1;
                my $jahrh  = $2;
                my $amonj  = &db_bind_date("01-" . ($weh == 1 ? "01" : "07") . "-$jahrh");
                my $emonj  = &db_bind_date("01-" . ($weh == 1 ? "07" : "01") . "-" . ($weh ==1 ? $jahrh : ($jahrh + 1)));
                if( $vgl ) {
                        if ($vgl eq ">") {
                                $vgl   = ">=";
                                $amonj = $emonj;
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,$amonj);
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values, $amonj);
                        push(@$rbind_values, $emonj);
                }
        } elsif ( $datum =~ /^\-\-(\d+)$/ ) {   # Angabe eines Jahres gegeben.
                my $jahr    = $1;
                my $endjahr = $jahr + 1;
                if ( $vgl ) {
                        if ($vgl eq ">") {
                                $jahr = $endjahr;
                                $vgl  = ">=";
                        }
                        $$rsuche .= qq{a."$name" $vgl ?};
                        push(@$rbind_values,&db_bind_date("01-01-$jahr"));
                } else {
                        $$rsuche .= $vglwert;
                        push(@$rbind_values,&db_bind_date("01-01-$jahr"));
                        push(@$rbind_values,&db_bind_date("01-01-$endjahr"));
                }
        } else {               # Angabe eines echten Datums gegeben
                $vgl      = "=" unless $vgl;
#                $$rsuche .= ($vgnot ? qq{NOT (a."$name" $vgl ?) AND } : qq{(a."$name" $vgl ?)});
                $$rsuche .= ($vgnot ? qq{NOT (a."$name" $vgl ?)} : qq{(a."$name" $vgl ?)});
                push(@$rbind_values, &db_bind_date($datum));
        }
}

#
# building a searchstring from booleans
#
sub pr_bool_suchw {
        my ($name,$quer_wert,$vgl,$rsuche,$rbind_values) = @_;
        $quer_wert = '' unless $quer_wert;
        my $erg    = 0;
        $quer_wert = $1 if ($quer_wert =~ /^'(.)'$/);
        $vgl       = "=" unless $vgl;
#        &dbprint(7,"pr_bool_suchw: quer_wert=|$quer_wert|, name=|$name|, vgl=|$vgl|");
        if ($quer_wert eq 'f' || $quer_wert eq 't') {
                $$rsuche .= qq{a."$name" $vgl ?};
                push(@$rbind_values,$quer_wert);
                $erg = 1;
        }
        return($erg);
}

#
# building a searchstring from numbers
#
sub pr_number_suchw {
        my ($name,$number,$vgl,$foptype,$rsuche,$rbind_values) = @_;
        &dbprint(7,"pr_number_suchw: number=|$number|, name=|$name|, vgl=|$vgl|, foptype=|$foptype|");
        if ($foptype =~ /float.*/ && (!$vgl || $vgl eq '=')) {
                my $value = &pr_local2SQLformat($number, $foptype);
                $$rsuche .= qq{dround(a."$name" + 0.5) = dround($value + 0.5)};
        } else {
                $vgl      = "=" unless $vgl;
                $$rsuche .= qq{a."$name" $vgl ?};
                push(@$rbind_values,&pr_local2SQLformat($number, $foptype));
        }
}

#
# selecting an operator from a field_value to build a correct search string
#
#                  Festlegung fr welche Datentypen welche Operatoren zul?sig sind:
#                  1 = 2**0, char's
#                  2 = 2**1, date
#                  4 = 2**2, bool
#                  8 = 2**3, alle brigen
sub pr_get_operator {
        my($foptype,$quer_wert) = @_;
        my %Field_Type  = ("char"=>1,"text"=>1,"date"=>2,"bool"=>4,"sonstige"=>8);
        my @pg_ops      = ("<=","<>","<",">=","=",">","\\\|\\\|","!=","~~","!~~","~\\\*","!~\\\*","!~","~");
        my %pg_op_types = ("<"=>2+8,"<="=>2+8,"<>"=>1+2+4+8,"="=>1+2+4+8,">"=>2+8,">="=>2+8,"||"=>0,
                           "!="=>1+2+8,"~~"=>1,"!~~"=>1,"~"=>1,"~\\\*"=>1,"!~"=>1,"!~\\\*"=>1);

        $foptype      = "char" if ($foptype =~ /char/);
        $foptype      = "bool" if ($foptype =~ /^bool/ );
        my $fopnumber = $Field_Type{$foptype};

#        &dbprint(7,"pr_get_operator: Vor Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|");
        unless ($fopnumber) {
                $foptype   = "sonstige";
                $fopnumber = $Field_Type{$foptype};
        }
#        &dbprint(7,"pr_get_operator: Vor Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|");

        my $vgl = "";
        foreach my $vglx (@pg_ops) {   # Bestimmen des Operators
                last unless $quer_wert;
                my $vglt = "^" . $vglx . "\\s*(\\S.*)\$";
#                &dbprint(10,"pr_get_operator: Vor Treffer quer_wert=|$quer_wert|, type=|$foptypen|, vgl=|$vgl|,vglt=|$vglt|");
                if ( $quer_wert =~ /$vglt/ ) {
                        if ( $pg_op_types{$vglx} & $fopnumber ) {
                                $quer_wert = $1;
                                $quer_wert = $1 if($quer_wert =~ /^'(.+)'\s*$/);
                                $vgl = $vglx;
                                $vgl =~ s/\\//g;
                                last;
                        }
                }
        }
#        &dbprint(7,"pr_get_operator: Nach Treffer fopnumber=|$fopnumber|, quer_wert=|$quer_wert|, type=|$foptype|,vgl=|$vgl|");
        return($vgl,$quer_wert,$foptype,$fopnumber);
}

#
# setting one Parameter of the Hashfield parms
#
sub pr_set_parms {
        my ($parm_wen,$womit) = shift;
        $$rparms{$parm_wen} = $womit;
        return;
}
#
# loading one Parameter of the Hashfield parms
#
sub pr_get_parms {
        my $parm_wen = shift;
        return($$rparms{$parm_wen});
}

#
# loading one Parameter of the Hashfield parms
#
sub pr_get_parmfields {
        my ($name,$dispname,$fieldtype) = @_;
        my @Werte = $qu->param($name);
        &dbprint(7,"pr_get_parmfields: name=|$name|, dispname=|$dispname|, fieldtype=|$fieldtype|");
        my $erg = &pr_get_RelValues($name,$dispname,$fieldtype,\@Werte);
#        &dbprint(7,"pr_get_parmfields: erg=|$erg|");
        return($erg);
}

#
# Routinen zum crypten und decrypten von Werten fr user-files
#
my $td;

sub crypt_start {
        my $user        = $ENV{'REMOTE_USER'};
        $user           = $ENV{'USER'} unless $user;
        $user           = substr(`id`,0,8) unless $user;

#        $td  = Mcrypt->new(     algorithm => Mcrypt::BLOWFISH,
#                                mode => Mcrypt::CFB,
#                                verbose => 0);
#        my $keysize = $td->{KEY_SIZE};
#        my $ivsize  = $td->{IV_SIZE};
        my $keypart = substr($$rconfigs{'keypart'},0,12);
        my $key     =   $keypart . $user .
                        $ENV{"REMOTE_ADDR"} . $ENV{"HTTP_USER_AGENT"} .
                        "als Schluessel fuer dbengine";
#        $key        = substr($key,0,$keysize);
        $td  = Crypt::CBC->new(-key => $key,
                               -cipher => 'Blowfish'
                               );

        &dbError(&gtext("crerror")) unless $td;

#        my $iv      = substr($ENV{"HTTP_HOST"} . $ENV{"HTTP_ACCEPT_LANGUAGE"} .
#                        "als IV Schluessel", 0, $ivsize);
#        $td->init($key, $iv);
        return;
}

sub name_crypt {
        my ($name) = @_;
        my $erg = $td->encrypt($name);
        return (encode_base64($erg,''));
}

sub name_decrypt{
        my ($name) = @_;
        my $erg;
        &dbprint(10,"name_decrypt: name=|$name|");
        $name = decode_base64($name);
        $erg = $td->decrypt($name);
        &dbprint(10,"name_decrypt: erg=|$erg|");
        return ($erg);
}

sub crypt_stop {
#        $td->end($td);
}


#
# print the given $message and the current database
# error message to STDOUT and die unless $check
sub dBaseError {
        my ($errstr,$cmd, $format, @Werte) = @_;
        if (@Werte) {
                printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
        } else {
                print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
        }
        print "<H4><FONT COLOR=red><P>+++" . &gtext('dberror') . ":<br>+++$errstr<BR></FONT></H4>\n";
        print "<P><FONT COLOR=red>" . &gtext('bcmd') . ": $cmd </FONT><P>" if $cmd;

        &db_db_disc;
        exit(1);
}


sub dbError {
        my ($format,@Werte) = @_;
        if (@Werte) {
                printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
        } else {
                print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
        }

        &db_db_disc;
        exit(1);
}

sub dbWarning {
        my ($format,@Werte) = @_;
        if (@Werte) {
                printf "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte;
        } else {
                print "<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n";
        }
}

sub dbWarnText {
        my ($format,@Werte) = @_;
        if (@Werte) {
                return(sprintf("<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n",@Werte));
        } else {
                return("<H4><FONT COLOR=red><P>+++ DbEngine-" . &gtext("Message") . ":<P>$format<BR></FONT></H4>\n");
        }
}

# 1;


#########################
#
# dbengine_plaindialog.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Local Library for executing special standardactions und starting the
# executing of all other actions
#
########################

#use strict;

# my $qu;
# my $rconfigs;
# my $rparms;
# my $rfielddesc;
# my $rrelations;
# my $rvalues;
# my $rbuttons;

# my $table;
#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
# sub plaindialog_init {
#         ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;
# }

#
# Routinen zur Ausgabe einer Bildschirmmaske fr eine Relation
#

#
# Starten der Maskenerzeugung und globale Fallunterscheidungen
#
sub createdialog {

        $table = $$rparms{'table'} unless $table;
        if (open (SEARCHMASK, "$$rconfigs{'templ'}/$table.html")) {
                # now we try to open a template .html file that shall
                # be used to display the contents of our record
                &scanAndReplaceTemplate;
                close SEARCHMASK;
        } else {
                #
                # if there's no template file available we
                # create something from the database definition ;-))
                &createdialog_part;
        }
        #
        # if there're relations available for $table we now
        # have to create a popUpMenue for Details
        if (!$$rparms{'printm'} && $$rparms{'oid'} && ($$rparms{'parent'} > 0 || $$rparms{'child'} > 0) ) {
                print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>";
                my $i = 0;
                my $tuples = 0;
                foreach my $wer ('parent', 'child') {
                        $tuples = $$rparms{$wer};
                        print "<TR><TD WIDTH=25%>" . &gtext('connec',($wer eq 'parent' ? "1:n" : "n:1")) . "</TD>\n"
                            if ($i < $tuples);
                        for ($j = 0; $i < $tuples; $j++, $i++) {
                                print "</TR><TR><TD>&nbsp;</TD>" if ( $j > 0 && ($j % 3) eq 0 );
                                my $stable;
                                my $sfield;
                                my $ctable;
                                my $gfield;
                                my $rrelart = $$rrelations{$wer}[$i];
                                &dbprint_hash(7,"pr_create_dialog: wer=|$wer|, i=|$i|, j=|$j|, relations",$rrelart);
                                if ($wer eq 'parent') {
                                        $stable = $$rrelart{'child'};
                                        $sfield = $$rrelart{'childfield'};
                                        $gfield = $$rrelart{'parentfield'};
                                } else {
                                        $stable = $$rrelart{'parent'};
                                        $sfield = $$rrelart{'parentfield'};
                                        $gfield = $$rrelart{'childfield'};
                                }
                                if(defined $$rvalues{$gfield}) {
                                        print "<TD WIDTH=25%>";
                                        &pr_create_appendref(&upfirst($sfield) . "(" . &upfirst($stable) . ")",
                                                            $stable,$sfield,$$rvalues{$gfield});
                                        print "</TD>\n";
                                }
                        }
                        print "</TR>";
                }
                print "</TABLE><P>\n";
        }
        &createdialog_end;
}

#
# Routine zur Erzeugung des Hauptteils einer maske
#
sub createdialog_part {

        my $fields;

        local *fielddesc = $rfielddesc;
        local *parms     = $rparms;
        local *values    = $rvalues;
        #
        # create the main Part of a simple Dialog
        my $Titel   = &gtext('tablemask', &db_get_tabledisplay($table));
        $Titel = &gtext('tableprint', &upfirst($table)) if ($parms{'printm'});
        #
        # Wenn Daten vorhanden, dann Befehl Neuanlage eingeben
        #
        #
        # now we start our form part
        &pr_form_start($Titel); # Starting the Form for the mask

        &dbprint_hash_hash(9,'pr_create_dialog_part: fielddesc',\%fielddesc);
        &dbprint_hash(9,"pr_create_dialog_part: values",\%values);
        &dbprint_hash(9,"pr_create_dialog_part: parms",\%parms);

        #
        # start the table with our fields
        print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>\n";
        my $maxwidth    = ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
        my $line        = 0;
        my $column      = 999;
        my $maxcol      = &maxCols;
        my $rowspan     = 0;
        my $rowspanalt  = 0;
        my %attribs;
        my @attribs;
        my @fields;

        # Zunaechst die Felder, die in dbinfo angegeben sind nach Rangordnung sortieren
        # das ist nur 2-Phasig moeglich
        foreach $key (&xSort(keys %fielddesc)) {
                if ((my $value = $fielddesc{$key}{'DISPORDER'})) {
                        $attribs{$value} = $key;
                } else {
                        push(@fields,$key);
                }
        }
        foreach $key (&xSort(keys %attribs)) {
                push(@attribs,$attribs{$key});
        }

        # Dann die Felder, die keine Beschreibung in dbinfo haben alphabetisch sortiert anfuegen
        #
        push(@attribs, @fields) if @fields;
        &dbprint(9,"pr_createDialogPart: attribs=|@attribs|, fields=|@fields|");

        # Feldausgaben durchfuehren. Wenn Werte vorhanden sind, dann diese ausgeben,
        # sonst die Default-Werte eintragen
        my $lastUsed = 0;
        foreach my $name (@attribs) {
                #
                # don't include the last modification date of our record
                if ($name && $name ne "tmin" && $name ne "oid") {
                        my $rcurrent   = $fielddesc{$name};
                        &dbprint_hash(7,'pr_create_dialog_part: rcurrent=fielddesc{' . $name . "}",$rcurrent);
                        my $dispname   = $$rcurrent{'DISPLAY'};
                        $dispname      = "" unless $dispname;
                        my $wert       = $$rvalues{$name};
                        my $colspan    = $$rcurrent{'COLS'};
                        $colspan       = 1 unless $colspan;
                        $colspan       = 2 * $colspan - 1;
                        my $dispcolumn = 2 * ($$rcurrent{'DISPCOL'} ? $$rcurrent{'DISPCOL'} : 1) - 1;
                        $rowspanalt  = $rowspan unless $rowspanalt;
                        $rowspan     = 0;
                        if ($parms{'printm'}) {
                                print "</TD></TR>\n" if $line;
                                $line = 1;
                                print "<TR><TD>";
                                if($rcurrent{'DISPSTR'}) {
                                        print $rcurrent{'DISPSTR'};
                                } else {
                                        print &upfirst($name);
                                }
                                print ":</TD><TD>";
                        } else {
                                &dbprint(7,"pr_create_dialog_part: name=|$name|, dispcolumn=|%d|" .
                                           ", column=|%d|, lastused=|%d|, rowspan=|%d|, colspan=|%d|",
                                            $dispcolumn, $column,$lastUsed,$rowspan,$colspan);
                                print "</TD>" if $lastUsed;
                                if($dispcolumn < $column) {
                                        $rowspanalt-- if $rowspanalt;
                                        $rowspan = $rcurrent{'ROWS'} if $rcurrent{'ROWS'};
                                        $column  = 1;
                                        $column++ if $rowspanalt;
                                        print "</TR>\n" if $line;
                                        print "<TR>";
#                                        print "<TR><TD WIDTH=30%";
#                                        print " rowspan=" . $rowspan if ($rowspan > 0);
#                                        print ">";
                                        $line++;
                                }

                                while($dispcolumn >= $column) {
                                        &dbprint(9,"pr_create_dialog_part: name=|$name|, dispcolumn=|%d|" .
                                                   ", column=|%d|, lastused=|%d|", $dispcolumn, $column,$lastUsed);
                                        print "<TD";
#                                        print "><TD" unless $lastUsed == $column;
                                        $column++;
                                        print " rowspan=" . $rowspan if ($rowspan > 0);
                                        print ">";
                                }

                                if (defined $wert || !($dispname =~ /VIRTUAL/)) {
                                        if($$rcurrent{'DISPSTR'}) {
                                                print $$rcurrent{'DISPSTR'};
                                        } else {
                                                print &upfirst($name);
                                        }
                                } else {
                                        print "&nbsp;";
                                }
                                print "<TD";
                                print " colspan=" . $colspan if ($colspan > 1);
                                print " rowspan=" . $rowspan if ($rowspan > 1);
                                print ">";
                                &dbprint(9,"createdialogPart: lastused=|$lastUsed|, column=|$column|");
                                $lastUsed = $column;
                                $column  += $colspan;
                                &dbprint(9,"createdialogPart: lastused=|$lastUsed|, column=|$column|");
                        }

                        #
                        # print static virtual fields
                        if($dispname =~ /VIRTUAL/) {
                                print $wert . "\n" if (defined $wert);
                        #
                        # print editable fields
                        } else {
                                #
                                # if there's designinfo available for the field, use it
                                if ($parms{'printm'}) {
                                        &dbprint_hash(9,"createDialogPart: name=|$name|, wert=|$wert|, values=",%values);
                                        &dbprint_hash(9,"createDialogPart: name=|$name|, wert=|$wert|, values=",$rvalues);
                                        if($dispname) {
                                                if($dispname =~ /currency/ && $wert) {
                                                        use Math::Currency qw(Money $LC_MONETARY);
                                                        Math::Currency->format( $LC_MONETARY->{$$rconfigs{'currency'}} );
                                                        $wert = Money(sprintf ("%-15.2f", $wert)) if $wert;
                                                } elsif ($dispname =~ /textarea\s*\d*\s*\d*/ && $wert) {
                                                        if($$rcurrent{'DISPDFIELD'} =~ /pre/i ) {
                                                                $wert = "<PRE>" . &pr_quote($wert) . "</PRE>";
#                                                        } else {
#                                                                $wert = pr_textarea_bau($wert);
                                                        }
                                                }
                                        }
                                        $wert = "&nbsp;" unless (defined $wert);
                                        print $wert;
                                } else {
                                        my $wert = $values{$name};
                                        $wert    = "" unless (defined $wert);
                                        if( $dispname ) {
                                                my $what;
                                                my $arg1;
                                                my $arg2;
                                                my $arg3;
                                                my $arg4;
                                                &dbprint(9,"createDialogPart: name=|$name|, dispname=|$dispname|, wert=|$wert|");
                                                if($dispname =~ /textarea\s*$/) {
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        print $qu->textarea(-name=>"__$name",
                                                                            -default=>$wert,-force=>1,
                                                                            -rows=>$arg1,
                                                                            -columns=>$arg2) . "\n";
                                                } elsif($dispname =~ /textarea\s*(\d*)\s*(\d*)/) {
                                                        $arg1 = $1, $arg2 = $2;
                                                        print $qu->textarea(-name=>"__$name",
                                                                            -default=>$wert,-force=>1,
                                                                            -rows=>$arg1,
                                                                            -columns=>$arg2) . "\n";
                                                } elsif($dispname =~ /text\s*$/) {
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$arg1,
                                                                             -maxlength=>$arg2) . "\n";
                                                } elsif($dispname =~ /text\s*(\d*)\s*(\d*)/) {
                                                        $arg1 = $1, $arg2 = $2;
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$arg1,
                                                                             -maxlength=>$arg2) . "\n";
                                                } elsif($dispname =~
                                                         /^\s*(relationpopup|multiplepopup)\s*(\w*)\s*([^\s].*[^\s])\s*$/) {
                                                        $what = $1, $arg1 = $2, $arg2 = $3;   # Old Version, will be obsolete later
                                                        print &relationPopup($what,$name, $arg1, $arg2, $arg3) . "\n";
                                                } elsif($dispname =~ /^\s*(relationpopup|multiplepopup\s*(\S*))\s*$/) {
                                                        $what = $1;
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        $arg3 = $$rcurrent{'DISPDFIELD'};
                                                        $arg4 = $2;
                                                        print &relationPopup($what,$name, $arg1, $arg2, $arg3) . "\n";
                                                } elsif($dispname =~ /popup/) {
                                                        print &valueListPopup($name) . "\n";
                                                } elsif($dispname =~ /NONE/) {
                                                        print "&nbsp;";
                                                } elsif($dispname =~ /COMPUTATION/) {
                                                        print "<INPUT TYPE=HIDDEN NAME=\__$name\ VALUE=\" \">";
                                                        print $wert;
                                                } elsif($dispname =~ /SERIAL/) {
                                                        print $wert;
                                                } elsif($dispname =~ /VIRTUAL/) {
                                                        print "&nbsp;";
                                                } elsif($dispname =~ /CURRENCY/) {
                                                        use Math::Currency qw(Money $LC_MONETARY);
                                                        Math::Currency->format( $LC_MONETARY->{$$rconfigs{'currency'}} );
                                                        $wert = Money(sprintf ("%-15.2f", $wert)) if $wert;
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>15) . "\n";
                                                }
                                                #
                                                # if there's no designinfo available for the field, use common sense...
                                        } else {
                                                my $fieldtype   = $$rcurrent{'TYPE'};
                                                my $fieldlength = $$rcurrent{'SIZE'};
                                                &dbprint_hash(7,"pr_createDialogPart: rcurrent",$rcurrent);
                                                #
                                                # chars are displayed in editable textfields with the size
                                                # of the database field, but not wider than $maxwidth
                                                if($fieldlength > 0 && $fieldtype =~ /char/ ) {
                                                        print $qu->textfield(-name => "__$name",
                                                                             -default => $wert,-force=>1,
                                                                             -size => ($fieldlength > $maxwidth) ?
                                                                                       $maxwidth : $fieldlength,
                                                                             -maxlength => $fieldlength) . "\n";
                                                #
                                                # booleans are displayed in form of radio buttons $buttons{'true'} and
                                                # $buttons{'false'}
                                                } elsif ($fieldtype =~ /^bool/) {
                                                        my $defv = ($wert ? ($wert eq "u" ? "u" : ($wert eq "f" ? "f" : "t")) :
                                                                            ($$rconfigs{'undefbool'} ? $$rconfigs{'undefbool'} :
                                                                             "u"));
                                                        $defv = $1 if ($defv =~ /^'(.)'$/);
                                                        my %plabels  = ("t" => &gtext('true'), "f" => &gtext('false'),
                                                                        "u" => &gtext('bundef'));
                                                        &dbprint(7,"pr_create_dialog_part: name=|$name|, wert bei bool=|$wert|," .
                                                                   " defv=|$defv|");
                                                        print $qu->radio_group( -name => "__$name",
                                                                                -values => ["t", "f", "u"],
                                                                                -default => $defv,-force => 1,
                                                                                -labels => \%plabels
                                                                               );
                                               #
                                                # date fields are shown as is or in language specific format
                                                } elsif ($fieldtype eq "date") {
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>25) . "\n";

                                                #
                                                # float4 fields are shown as is or in language specific format
                                                } elsif ($fieldtype eq "float4") {
                                                        use locale;
                                                        my $oldlocal = setlocale(LC_NUMERIC,$rconfigs{'lang'}) if $rconfigs{'lang'};
                                                        my $wert     = sprintf("%g",$wert);
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>10) . "\n";

                                                #
                                                # text fields are shown as standard text fields, $maxwidth chars wide,
                                                # but accept up to 512 chars
                                                } elsif ($fieldtype eq "text") {
                                                        &dbprint(7,"pr_create_dialog_part: name=|$name|, wert bei txt=|$wert|");
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$maxwidth,
                                                                             -maxlength=>$$rconfigs{'maxinpwidth'}) . "\n";

                                                #
                                                # all other fields are also shown as text fields
                                                } else{
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,) . "\n";
                                                }
                                        }
                                }
                        }
                }
                $fields .= $name . "," unless $oid;
        }
        chop($fields) unless $oid;
        print "</TABLE>\n";

        #
        # when we show a real record we'll allow our user to either delete or update
        # it or to add a variation of it to the database
        if ($parms{'printm'}) {
                print "<P><CENTER>\n";
                print $qu->submit(-name=>'mode', -value=>&sbutton('back')) . "\n";
                print "</CENTER><P>\n";
        } else {
                print "<P><HR SIZE=4><TABLE BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=100%><TR>";
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->submit(-name=>'mode', -value=>&sbutton('search')) . "\n";
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->submit(-name=>'mode', -value=>&sbutton('add')) . "\n";
                if ( $parms{'oid'} ) {
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('update')) . "\n";
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('delete')) . "\n";
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('print')) . "\n";

                #
                # when we only show an empty dialog the user is allowed to search or add records
                } else {
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                }
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->reset(&sbutton('reset')) . "\n";
                print "</TABLE><P>\n";
        }
}

#
# create the rest of the HTML-Sheet
sub createdialog_end {

        unless ($$rparms{'printm'}) {
                my $maxwidth    = ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
                my $text = &gtext("specialselect");
                print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>";
                print "<TR><TD WIDTH=25%>$text</TD><TD>";
                print $qu->textfield(-name=>'statement', -default=>'SELECT ', -force=>1, -size=>$maxwidth, -maxlength=>512);
                print "</TD></TR></TABLE><P>\n";
        }
}

#
# Subroutine to create a Form from a given template
#
# duplicate the contents of SEARCHMASK into
# MAINFRAME and do some replacements...
#
sub scanAndReplaceTemplate {
        while (<SEARCHMASK>) {

                #
                # if we find a TEXTAREA tag we insert the contents of the field
                # with the given name ahead of the </TEXTAREA> tag
                if(/textarea\s*name\s*\=\s*\"(\w*)\"\s*/i && $values{$1}) {
                        $name   = $1;
                        s/>(.*)<\/textarea>/>$1$values{$name}<\/TEXTAREA>/i;

                #
                # in case of any NAME tags in the HTML file we insert a VALUE tag with the
                # named fields contents right behind it
                } elsif(/name\s*\=\s*\"(\w*)\"\s*/i && $values{$1}) {
                        s/name\s*\=\s*\"(\w*)\"\s*/NAME=\"$1\" VALUE=\"$values{$1}\" /i;
                }


                #
                # in case of #exec commands for SSIs we simply execute them
                if (/<\!--\#exec\s*cmd\=\"(.*)\"\s-->/) {
                        $arg    = $1;
                        $result = `$arg`;

                        #
                        # ... und and replace their call by the result
                        s/<\!--\#exec\s*cmd\=\"(.*)\"\s-->/$result/;
                }


                #
                # finally we scan for comment lines starting with <--** -->
                # and interpret the text inside as a Perl script
                if (/<--\*\*(.*)-->/) {
                        $arg    = $1;
                        $result = eval ($arg);

                        #
                        # if there's an error during the evaluation we replace
                        # the output with the error message
                        $result = &dbWarnText(&gtext('eexpr', $arg) . ":<BR>\n$@") if $@;

                        #
                        # finally we replace the comment by its result
                        s/<--\*\*(.*)-->/$result/;
                }

                #
                # if we're showing a real record ...
                if($oid) {
                        #
                        # replace any search button by an update button and any add button by a delete button
                        s/(.*)VALUE\=\"$buttons{'search'}\"(.*)/$1VALUE=\"$buttons{'update'}\"$2/;
                        s/(.*)VALUE\=\"$buttons{'add'}\"(.*)/$1VALUE=\"$buttons{'delete'}\"$2/;
                }

                #
                # finally the current line has to be saved
                print $_ . "\n";

                #
                # once we're behind the <FORM ACTION tag we go ahead and insert
                # a couple of hidden fields that we need to know when we're called again...
                if( /FORM\s*ACTION/i ) {
                        &pr_db_stop_o_mode;
                }
        }
}


# 1;

#########################
#
# dbengine_listtable.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Local Library for executing special standardactions und starting the
# executing of all other actions
#
########################

#use strict;

# my $qu;
# my $rconfigs;
# my $rparms;
# my $rfielddesc;
# my $rrelations;
# my $rvalues;
# my $rbuttons;

#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
# sub listtable_init {
#        ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;
#}

#
# Routine zur Ausgabe eines Listings aufgrund einer 'such'-Anweisung
#
sub listtable {
        local *parms    = $rparms;
        my $fields      = $parms{'fields'};
        my $kennz       = $parms{'kennz'};
        my $suche;
        my @bind_values;
        my %tableDesign;
        my $table = $parms{'table'};
        my $dbase = $parms{'dbase'};
        if ($fields) {
                $suche  = "WHERE $fields = ? ";
                push(@bind_values,$parms{'value'});
        } else {
                $suche       = "WHERE ";
        }
        my $search     = $parms{'search'};
        $search        = 0 unless $search;
        my $recno_s    = $parms{'recno'};
        my $recno      = $recno_s;
        my $maxrecno   = $$rconfigs{'maxrecno'};
        $maxrecno      = $parms{'maxrecno'} if $parms{'maxrecno'};
        my $maxrecno_n = $maxrecno + $recno;

        &db_getTableDesign(\%tableDesign);
        $fields             = (($tableDesign{'tableFields'}) ? $tableDesign{'tableFields'} : "a.*");

        my $tableModifyable = $tableDesign{'tableModifyable'};
        my $tableItem       = $tableDesign{'tableItem'};
        my $statement       = $parms{'statement'};

        $statement = 0 if (!$statement || $statement =~ /select\s*$/i );

        unless($statement || $search) {
                &dbprint(7,"listTable: statement=|$statement|, search=|$search|");
                # There is no special 'SELECT' - Statement given
                # And there is also no earlier search by an tableList done
                # dann denken wir an die vom Anwender gewnschten (weil in Feldern des
                # Formulars eingetragenen) Sucheinschr?kungen
                foreach my $nameq ($qu->param) {
                        #
                        # wobei natrlich unsere Programmargumente und der Submit-Button nicht bedacht werden
                        # auch leere Felder interessieren uns nicht. Au?rdem nicht das Feld 'tmin', das nur zur Prfung
                        # der Berechtigung von update- und delete-Operationen auf einer speziellen oid ben?igt wird.
                        # Daher sind alle Felder vor dem Eintrag mit der Namensverl?gerung '__' versehen, die fr die SQL-Anfrage
                        # wieder entfernt werden muss.
                        next unless ($nameq =~ /^__(.+)$/);
                        my $name = $1;
                        my $fdisplay = $$rfielddesc{$name}{'DISPLAY'};
                        next if($fdisplay && $fdisplay eq 'COMPUTATION');
                        my @quer_wert = $qu->param($nameq);
                        my $quer_wert = $parms{$nameq};
                        next if (!defined $quer_wert || length($quer_wert) == 0);
                        &dbprint(7,"listTable: name=|$name|, quer_wert=|$quer_wert|, length(quer_wert)=|%d|", length($quer_wert));
                        unless( ! defined $quer_wert || length($quer_wert)>100) {
                                $quer_wert = &db_value2SQL(\$suche,\@bind_values,$name,\@quer_wert);
                                &dbprint(7,"listTable: suche=|$suche|,\nbinds=|@bind_values|, name=|$name|, wert=|$quer_wert|");
                        }
                }
                &dbprint(7,"listTable: suche=|$suche|, binds=|@bind_values|");
                #
                # wenn wir keine echten Sucheingaben gefunden haben, dann
                # entf?lt auch der WHERE-Clause in der SQL-Abfrage
                if($suche eq "WHERE ") {
                        $suche = "";
                } else {
                        #
                        # sonst mssen wir hat das letzte "AND " wegschmeissen...
                        $suche = $1 if ($suche =~ /^(.+\s+)AND\s*$/);
                }
                if ($tableDesign{'tableQuery'}) {
                        $_         = $suche;    # bisherigen Wert der Suche fr eval bereitstellen
                        my $retVal = eval ($tableDesign{'tableQuery'});
                        if ($@ || (!$retVal && $suche)) {
                                &dbWarnText(gtext("ferror", $table), $@);
                        } else {
                                $suche = $retVal;
                        }
                }
                my $tablex = $table;
                my $schemax = "";
                $tablex = $2, $schemax = qq{"$1".} if ( $table =~ /^(.+)\.([^\.]+)/ );
                $search = qq{SELECT a.oid, $fields FROM $schemax"$tablex" a $suche};
        } elsif ( $statement ) {
                my $sfields;
                my $stables;
                my $conds = "";
                my $oid   = "oid";
                $tableModifyable = 0;
                $tableItem       = 0;

                #is the Search-command in this form allowed?
                &dbError(&gtext('selectonly')) unless ($statement =~ /^select /i);
                if ($statement =~ /^select\s+(.+)\s+from\s+(.+)\s*$/i ) {
                        $sfields = $1;
                        $stables = $2;
                        #There is no subselect allowed
                        &dbError(&gtext("nosubsel")) if($sfields =~ /\sselect\s/i  || $stables =~ /\sselect\s/i );

                        #DIVIDING THE STATEMENTPART BEHIND FROM IN FORM-PART AND CONDITION-PART
                        if ($stables =~ /^\s*(.+)\s+(where\s+.+)$/i ) {
                                $stables = $1;
                                $conds   = $2;
                        }

                        #in the list of tables after the from part, the selected table in the mask must be the first of
                        #the tables and put the <tablename>.oid to the list of fields
                        &dbprint(7,"listtables: sfields=|$sfields|, stables=|$stables|, conds=|$conds|");
                        my @stables = split(/,/,$stables);
                        if (@stables > 1) {
                                my $stab = $stables[0];
                                if ($stab =~ /^\s*(\S.*)\s+(\S+)\s*$/i ) {
                                        $stab = $1;
                                        $oid  = $2 . ".oid";
                                } else {
                                        $oid  = $table . ".oid";
                                }
                                $stab = $1 if($stab =~ /^\s*(\S+)(\s+as)?\s*$/i );
                                &dbprint(7,"listtables: stab=|$stab|, tables =|@stables|");
                                &dbError(gtext("tabmustfirst")) if ($stab ne $table);
                        }

                }
                $search = qq{SELECT $oid, $sfields FROM $stables $conds};
        } elsif ( $search ) {
                @bind_values = split(/\}bq\{/,$parms{'binds'}) if $parms{'binds'};
        }
        $parms{'search'} = $search;
        unless (@bind_values) {
                $parms{'binds'}  = "";
        } else {
                $parms{'binds'}  = join('}bq{',@bind_values);
        }
        &dbprint(7,"listTable: search=|$search|, binds=|@bind_values|, kennz=|$kennz|, fields=|$fields|");

        $parms{'kennz'} = $kennz = &set_user_file;

        # For tests: output of the original select-string
        # and its bindings
        &dbprint_cmd_binds(1,$search, @bind_values);

        # denn woll'n wir 'mal die Datenbank fragen...
        # wir brauchen sowohl die Daten, als auch die Anzahl der Zeilen
        my ($ntuples, $listResult) = &db_db_get_nrows('dbase',$search,\@bind_values);
        &dbprint(7,"listTables: ntuples=|$ntuples|, listResult=|$listResult|, kennz=|$kennz|");

        # if there's only one resulting record we go ahead and show it directly
        if($ntuples == 1 && !$statement && $$rconfigs{'single_sentence'} eq 'false') {
                my $rarray = &db_db_hashref($listResult);
                $parms{'oid'}   = $$rarray{'oid'};
                &dbprint(7,"listTable: oid=|$parms{'oid'}|");
                $listResult->finish;
                $parms{'mode'}  = "plain";

                &db_fillValues;         # Getting the values for the oid

                &pr_create_dialog;      # Creating the mask for a single record
                &pr_db_stop_o_mode;     # Ending the Form and page

                &db_db_disc;            # Ending the database-connections
                return;
        } else {
                my $title = &gtext('records', &db_get_tabledisplay($table));
                if ((my $table_desc = &db_get_displayname($table,'tablename','basedesign','description')) ne $table) {
                        $title .= "</H1><H3><CENTER>($table_desc)</CENTER></H3><H1>";
                }
                my @fieldnames;
                my @fieldtypes;
                my $headerline = "";

                if (!$statement && (my $tableStart = $tableDesign{'tableStart'})) {
                        # you can use some variables in the xtablestartprocedure:
                        #       $title = standardtitle, can be reset as returnvalue
                        #       $headerline can be set by the procedure to define the fields in the headerline. It must be
                        #           done if there is xtableitem and the fields are not printed in the standard order!!!
                        #           The first field is allways the recordnumber
                        my $retVal = eval ($tableStart);
                        $title    = &dbWarnText(&gtext('xtableerror', $table)) . ":<BR>$@" if $@;
                        &dbprint(7,"listTable: $title=|$title|, headerline=|$headerline|, fields=|$fields|");
                }
                #
                # Getting the fieldnames of the result
                my $rname = $listResult->{NAME};
                foreach my $name (@$rname) {
                        push(@fieldnames,$name);
                }
                my $rftypes = $listResult->{TYPE};
                foreach my $ftype (@$rftypes) {
                        my $typeinfo = &db_get_typeinfo($ftype);
                        $typeinfo    = "" unless $typeinfo;
                        push(@fieldtypes,$typeinfo);
                }
                &dbprint(7,"listtable: rname=|@$rname|, fieldnames=|@fieldnames|<br>\nrftypes=|@$rftypes|," .
                           "fieldtypes=|@fieldtypes|");

                # Defining the standard-headerline using the standard fieldnames
                if (! $headerline || $statement) {
                        for (my $j = 0; $j < @fieldnames; $j++) {
                                my $name  = $fieldnames[$j];
                                my $ftype = $fieldtypes[$j];
                                my $align = (($ftype =~ /int/i || $ftype =~ /numeric/i || $ftype =~ /float/i) ? 'RIGHT' : 'LEFT');
                                my $fieldname = $name;
                                if (!$statement && $$rfielddesc{$name}{'DISPSTR'}) {
                                        $fieldname = $$rfielddesc{$name}{'DISPSTR'};
                                }
                                $headerline .= "<TH ALIGN=$align>".&upfirst($fieldname)."</TH>"
                                     unless ($name eq 'tmin' || $name eq 'oid');
                        }
                }
                $headerline = "<TABLE BORDER CELLSPACING=0 CELLPADDING=10 WIDTH=100%>\n<TR><TH ALIGN=RIGHT>" .
                              &gtext('recno') . "</TH>$headerline</TR>\n";
                #
                # now we start our form part if needed and some additional Informations if tableModifyable
                if($tableModifyable) {
                        &dbprint_hash(9,"listTable: parms", \%parms);
                        my $maxwidth    = ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
                        &pr_form_start($title);
                        print "<TABLE><TR><TD>" . gtext('fieldname') .
                              "</TD><TD><SELECT NAME=\"fieldname\" SIZE=1>\n";
                        foreach my $fieldname (@fieldnames) {
                                next if ($fieldname eq 'oid');
                                print "<OPTION";
                                print " SELECTED" if ($parms{'fieldname'} && $fieldname eq $parms{'fieldname'});
                                print ">$fieldname\n";
                        }
                        print "</SELECT></TD><TD>\n" . gtext('fieldvalue') . "</TD><TD>" .
                              $qu->textfield(-name=>"fieldvalue",
                                             -size=>$maxwidth) . "</TD></TR>\n";
                        print "<TR><TD>&nbsp;</TD><TD><CENTER>" .
                              $qu->submit(-name=>'mode', -value=>&sbutton('mupdate')) .
                              "</CENTER></TD>\n<TD>&nbsp;</TD><TD><CENTER>" .
                              $qu->reset($buttons{'reset'}) .
                              "</CENTER></TD><TD>&nbsp;</TD></TR></TABLE>\n";
                } else {
                        &pr_list_start($title);
                }
                #
                # und zeigen wir einen Link zum Anlegen neuer Eintr?e an
                my $newstring = &gtext('newrec');
                printf "<P><A HREF=\"dbengine.cgi?dbase=$dbase&mode=plain&table=$table&kennz=" . $parms{'kennz'} .
                       "\">$newstring</A><P>\n";
                #
                # schalten in der Ausgabe auf einen monospaced Font um
                print "<P><FONT SIZE=3 FACE=\"Monaco\">\n";


                # after printing the table-head-line first we have to read all tuples into an internel buffer
                # build by an array of arrays holding just one tuple in the order of @fieldnames
                #
                my @tupleArray;
                my $tupleno  = 0;
                &dbprint(7,"listTable: recno=|$recno|, maxrecno=|$maxrecno|, maxrecno_n=|$maxrecno_n|");
                while ( my $ary_ref = $listResult->fetch ) {
                        unless ( $tupleno < $recno ) {
                                &dbprint(9,"listTable: ary_ref=|$ary_ref|, tupleno=|$tupleno|");
                                for ( my $i = 0; $i < @$ary_ref; $i++) {
                                        $tupleArray[$tupleno][$i] = $$ary_ref[$i];
                                }
                        }
                        &dbprint_array(7,"listtable: tupleno=|$tupleno|, arrayref[tupleno]",$tupleArray[$tupleno]);
                        $tupleno++;
                        last if($tupleno >= $maxrecno_n);
                }
                $listResult->finish;

                #
                # second we have to look for virtualfields
                # We take all values and keys in an internal array
                my $nvtuples = 0;
                my @varray;
                unless ( $statement ) {
                        my $comm     = qq{SELECT * FROM virtual WHERE tablename='$table' AND DBaseName='$parms{'dbasen'}'} .
                                q{ ORDER BY level};
                        my $vfields  = &db_db_get('dbdesc',$comm);
                        while ( my $rarray = &db_db_hashref($vfields) ) {
                                foreach my $vkey ( xSort(keys %$rarray)) {
                                        $varray[$nvtuples]{$vkey} = $$rarray{$vkey};
                                }
                                $nvtuples++;
                        }
                }

                print $headerline;           # Printing the headerline
                #
                # und gehen alle Records durch
                &dbprint(7,"listTable: recno=|$recno|, tupleno=|$tupleno|");
                for ( ; $recno < $tupleno; $recno++ ) {
                        #
                        # wobei wir jeweils eine HREF auf den aktuellen Satz mit der Record-ID einbauen
                        # The first selected field  is the 'oid'
                        my $kennz = "dbengine.cgi?mode=plain&dbase=$dbase&table=$table&kennz=" . $parms{'kennz'};
                        my $oid   =  $tupleArray[$recno][0];
                        print "\n<TR><TD ALIGN=RIGHT>";
                        if ($tableModifyable) {
                                print "<INPUT NAME=OID$oid TYPE=CHECKBOX CHECKED>";
                        }
                        print "<A HREF=\"$kennz&oid=$oid\">" . ($recno + 1) . "</TD>\n";

                        if ($tableItem) {   # if you have to use virtualfields, yuo must define a procedure to output every record.
                                my $fno = 0;
                                for (my $j = 0; $j < @fieldnames; $j++) { # filling $$rvalues with all fields incl. oid
                                        my $tkey         = $fieldnames[$j];
                                        my $value        = $tupleArray[$recno][$j];
                                        $value           = "" unless (defined $value);
                                        $$rvalues{$tkey} = &db_SQL2value($tkey, $value);
                                        $fno++;
                                }

                                #
                                # then add the contents of any defined virtual fields if needed
#                                &dbprint_hash(9,"listTable: varray[0]=|$varray[0]|, nvtuples=|$nvtuples|,
#                                              tabledesign",\%tableDesign);
                                if($varray[0] && $tableDesign{'tableVirtuals'}) {
                                        for (my $vidx=0;  $vidx < $nvtuples; $vidx++) {
                                                #
                                                # if there's an error during the evaluation we set our
                                                # virtual fields  contents to the error message
                                                my $value =  eval($varray[$vidx]{'xequation'});
                                                $value    =  &dbWarnText(&gtext("virterror", $varray[$vidx]{'fieldname'}) .
                                                                                ":<BR>$@") if $@;
                                                $$rvalues{$varray[$vidx]{'fieldname'}} = $value;
                                                &dbprint_hash(7,"listTable: value=|$value|, varray[$vidx]", $varray[$vidx]);
                                        }
                                }

                                # to evaluate the procedure in tableitem there are parameters:
                                #           $recno = recordnumber,
                                #           @fieldnames = name of the attributes
                                #           $rvalues = hashref of values of fieldnames
                                #           $firstrec = output of firstrecord (you have to create a header line)
                                #                       Put the ouputline into the variable $line!
                                @_ = ($rvalues, $rconfigs, $rparms);   # stting the parameter for the eval
                                my $line;
                                my $retVal = eval ($tableItem);     # create a output of 1 row in the table
                                $line      = &dbWarnText(&gtext('extrableitem',$tableItem, $table) . ":<BR>$@") if ($@);
                                print $line;
                        } else {
                                #
                                # Ausgabe der in 'fields' gewnschten Felder
                                for (my $j=1; $j < @fieldnames; $j++) {
                                     my $fieldname = $fieldnames[$j];
                                     unless ($fieldname eq 'tmin') {
                                              &dbprint_hash(7,"listTable (no tanbleitem): name=|$fieldname|, rfielddesc",$$rfielddesc{$fieldname});
                                              my $tdv = "<TD>";
                                              my $ergebnis   = &db_SQL2value($fieldname,$tupleArray[$recno][$j]);
                                              $ergebnis      = "" unless (defined $ergebnis);
                                              my $fieldtype  = $$rfielddesc{$fieldname}{'TYPE'};
                                              $fieldtype     = $fieldtypes[$j] unless $fieldtype;
                                              my $dispname   = $$rfielddesc{$fieldname}{'DISPLAY'};
                                              my $dispdfield = $$rfielddesc{$fieldname}{'DISPDFIELD'};
                                              $dispname      = "" unless $dispname;
                                              $dispdfield    = "" unless $dispdfield;
                                              if ($fieldtype =~ /int/i || $fieldtype =~ /numeric/i || $fieldtype =~ /float/i) {
                                                      $tdv = "<TD ALIGN=RIGHT>";
                                              }
                                              &dbprint(7,"listtables: fieldname=|$fieldname|, ergebnis=|$ergebnis|");
                                              if ($fieldtype =~ /^bool/ ) {
                                                      $ergebnis = ($ergebnis ? 't' : 'f' );
                                              } elsif ($dispname =~ /textarea/ ) {
                                                      if($dispdfield =~ /pre/i ) {
                                                        $ergebnis = "<PRE>" . &pr_quote($ergebnis) . "</PRE>";
#                                                      } else {
#                                                        $ergebnis = pr_textarea_bau($ergebnis);
                                                      }
                                                      &dbprint(7,"listtables: dispdfield=|$dispdfield|, ergebnis=|$ergebnis|");
                                              } elsif ($dispname =~ /multiplepopup/ ) {
                                                      my @mvalues = split(/:::/,$ergebnis);
                                                      $ergebnis = "";
                                                      foreach my $mvalue (@mvalues) {
                                                              $ergebnis .= "<BR>" if $ergebnis;
                                                              $ergebnis .= $mvalue;
                                                      }
                                              }
                                              print $tdv;
                                              print $ergebnis;
                                              print "</A>" if ( $j == 1);
                                              print "</TD>";
                                      }
                                }
                                print "</TR></A>\n";
                        }
              }
              print "</TABLE>";

              if (my $tableEnd = $tableDesign{'tableEnd'}) {
                      my $retVal        = eval ($tableEnd);
                      $retVal = &dbWarnText(&getext("erxtableend", $table) . ":<BR>$@") if $@;
              } else {
                      print "<BR><HR>" . &gtext('nombrecs') . " = $ntuples<BR>";
              }
              &dbprint(7,"listTables: ntuples=|$ntuples|, recno=|$recno|, maxrecno=|$maxrecno|, recno_s=|$recno_s|");
              if ( $ntuples > $maxrecno ) {
                      my $kennz =  "<A HREF=\"dbengine.cgi?mode=search&dbase=$dbase&table=$table&oldsearch=1&kennz=" .
                                   $parms{'kennz'};
                      print "<TABLE Border=3 cellpadding=10><TR>";
                      my $textl = &gtext('lastrecs');
                      my $textn = &gtext('nextrecs');
                      if ($recno_s >= $maxrecno) {
                              print "<TD>$kennz&recno=" . ($recno_s - $maxrecno) . "\">$textl</A></TD>\n";
                      } else {
                              print "<TD>$textl</TD>\n";
                      }
                      if ($recno < $ntuples) {
                              print "<TD>$kennz&recno=$maxrecno_n\">$textn</A></TD>\n";
                      } else {
                              print "<TD>$textn</TD>\n";
                      }
                      print "<TD>$kennz&recno=0&maxrecno=$ntuples\">" . &gtext('allrecs') . "</A></TD>\n";
                      print "</TR></TABLE>\n";
              }

              if ($tableModifyable) {
                      # terminate the form and page
                      &pr_db_stop_o_mode;
              } else {
                      # terminate the  HTML Page
                      &pr_db_finish;
              }
      }
}

1;
