#########################
#
# dbengine_plaindialog.pl
#
# Modul zu dbengine.cgi: Verwaltung und Nutzung von Datenbanken ber
# Browserschnittstelle.
#
# Version 2.3.0
# <c> 2003, 2004 Detlef Duerr
# get closer Information from email Detlef.Duerr@gmx.de
#
# Local Library for executing special standardactions und starting the
# executing of all other actions
#
########################

#use strict;

my $qu;
my $rconfigs;
my $rparms;
my $rfielddesc;
my $rrelations;
my $rvalues;
my $rbuttons;

my $table;
#
# Initialisierung des Printmoduls und Ausgabe des generellen Headers
#
sub plaindialog_init {
        ($qu, $rparms, $rconfigs, $rbuttons, $rfielddesc, $rrelations, $rvalues) = @_;
}

#
# Routinen zur Ausgabe einer Bildschirmmaske fr eine Relation
#

#
# Starten der Maskenerzeugung und globale Fallunterscheidungen
#
sub createdialog {

        $table = $$rparms{'table'} unless $table;
        if (open (SEARCHMASK, "$$rconfigs{'templ'}/$table.html")) {
                # now we try to open a template .html file that shall
                # be used to display the contents of our record
                &scanAndReplaceTemplate;
                close SEARCHMASK;
        } else {
                #
                # if there's no template file available we
                # create something from the database definition ;-))
                &createdialog_part;
        }
        #
        # if there're relations available for $table we now
        # have to create a popUpMenue for Details
        if (!$$rparms{'printm'} && $$rparms{'oid'} && ($$rparms{'parent'} > 0 || $$rparms{'child'} > 0) ) {
                print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>";
                my $i = 0;
                my $tuples = 0;
                foreach my $wer ('parent', 'child') {
                        $tuples = $$rparms{$wer};
                        print "<TR><TD WIDTH=25%>" . &gtext('connec',($wer eq 'parent' ? "1:n" : "n:1")) . "</TD>\n"
                            if ($i < $tuples);
                        for ($j = 0; $i < $tuples; $j++, $i++) {
                                print "</TR><TR><TD>&nbsp;</TD>" if ( $j > 0 && ($j % 3) eq 0 );
                                my $stable;
                                my $sfield;
                                my $ctable;
                                my $gfield;
                                my $rrelart = $$rrelations{$wer}[$i];
                                &dbprint_hash(7,"pr_create_dialog: wer=|$wer|, i=|$i|, j=|$j|, relations",$rrelart);
                                if ($wer eq 'parent') {
                                        $stable = $$rrelart{'child'};
                                        $sfield = $$rrelart{'childfield'};
                                        $gfield = $$rrelart{'parentfield'};
                                } else {
                                        $stable = $$rrelart{'parent'};
                                        $sfield = $$rrelart{'parentfield'};
                                        $gfield = $$rrelart{'childfield'};
                                }
                                if(defined $$rvalues{$gfield}) {
                                        print "<TD WIDTH=25%>";
                                        &pr_create_appendref(&upfirst($sfield) . "(" . &upfirst($stable) . ")",
                                                            $stable,$sfield,$$rvalues{$gfield});
                                        print "</TD>\n";
                                }
                        }
                        print "</TR>";
                }
                print "</TABLE><P>\n";
        }
        &createdialog_end;
}

#
# Routine zur Erzeugung des Hauptteils einer maske
#
sub createdialog_part {

        my $fields;

        local *fielddesc = $rfielddesc;
        local *parms	 = $rparms;
        local *values    = $rvalues;
        #
        # create the main Part of a simple Dialog
        my $Titel   = &gtext('tablemask', &db_get_tabledisplay($table));
        $Titel = &gtext('tableprint', &upfirst($table)) if ($parms{'printm'});
        #
        # Wenn Daten vorhanden, dann Befehl Neuanlage eingeben
        #
        #
        # now we start our form part
        &pr_form_start($Titel);	# Starting the Form for the mask

        &dbprint_hash_hash(9,'pr_create_dialog_part: fielddesc',\%fielddesc);
        &dbprint_hash(9,"pr_create_dialog_part: values",\%values);
        &dbprint_hash(9,"pr_create_dialog_part: parms",\%parms);

        #
        # start the table with our fields
        print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>\n";
        my $maxwidth	= ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
        my $line	= 0;
        my $column	= 999;
        my $maxcol	= &maxCols;
        my $rowspan	= 0;
        my $rowspanalt	= 0;
        my %attribs;
        my @attribs;
        my @fields;

        # Zun�hst die Felder, die in dbinfo angegeben sind nach Rangordnung sortieren
        # das ist nur 2-Phasig moeglich
        foreach $key (&xSort(keys %fielddesc)) {
                if ((my $value = $fielddesc{$key}{'DISPORDER'})) {
                        $attribs{$value} = $key;
                } else {
                        push(@fields,$key);
                }
        }
        foreach $key (&xSort(keys %attribs)) {
                push(@attribs,$attribs{$key});
        }

        # Dann die Felder, die keine Beschreibung in dbinfo haben alphabetisch sortiert anfgen
        #
        push(@attribs, @fields) if @fields;
        &dbprint(9,"pr_createDialogPart: attribs=|@attribs|, fields=|@fields|");

        # Feldausgaben durchfhren. Wenn Werte vorhanden sind, dann diese ausgeben,
        # sonst die Default-Werte eintragen
        my $lastUsed = 0;
        foreach my $name (@attribs) {
                #
                # don't include the last modification date of our record
                if ($name && $name ne "tmin" && $name ne "oid") {
                        my $rcurrent   = $fielddesc{$name};
                        &dbprint_hash(7,'pr_create_dialog_part: rcurrent=fielddesc{' . $name . "}",$rcurrent);
                        my $dispname   = $$rcurrent{'DISPLAY'};
                        $dispname      = "" unless $dispname;
                        my $wert       = $$rvalues{$name};
                        my $colspan    = $$rcurrent{'COLS'};
                        $colspan       = 1 unless $colspan;
                        $colspan       = 2 * $colspan - 1;
                        my $dispcolumn = 2 * ($$rcurrent{'DISPCOL'} ? $$rcurrent{'DISPCOL'} : 1) - 1;
                        $rowspanalt  = $rowspan unless $rowspanalt;
                        $rowspan     = 0;
                        if ($parms{'printm'}) {
                                print "</TD></TR>\n" if $line;
                                $line = 1;
                                print "<TR><TD>";
                                if($rcurrent{'DISPSTR'}) {
                                        print $rcurrent{'DISPSTR'};
                                } else {
                                        print &upfirst($name);
                                }
                                print ":</TD><TD>";
                        } else {
                                &dbprint(7,"pr_create_dialog_part: name=|$name|, dispcolumn=|%d|" .
                                           ", column=|%d|, lastused=|%d|, rowspan=|%d|, colspan=|%d|",
                                            $dispcolumn, $column,$lastUsed,$rowspan,$colspan);
                                print "</TD>" if $lastUsed;
                                if($dispcolumn < $column) {
                                        $rowspanalt-- if $rowspanalt;
                                        $rowspan = $rcurrent{'ROWS'} if $rcurrent{'ROWS'};
                                        $column  = 1;
                                        $column++ if $rowspanalt;
                                        print "</TR>\n" if $line;
                                        print "<TR>";
#                                        print "<TR><TD WIDTH=30%";
#                                        print " rowspan=" . $rowspan if ($rowspan > 0);
#                                        print ">";
                                        $line++;
                                }

                                while($dispcolumn >= $column) {
                                        &dbprint(9,"pr_create_dialog_part: name=|$name|, dispcolumn=|%d|" .
                                                   ", column=|%d|, lastused=|%d|", $dispcolumn, $column,$lastUsed);
                                        print "<TD";
#                                        print "><TD" unless $lastUsed == $column;
                                        $column++;
                                        print " rowspan=" . $rowspan if ($rowspan > 0);
                                        print ">";
                                }

                                if ($wert || !($dispname =~ /VIRTUAL/)) {
                                        if($$rcurrent{'DISPSTR'}) {
                                                print $$rcurrent{'DISPSTR'};
                                        } else {
                                                print &upfirst($name);
                                        }
                                } else {
                                        print "&nbsp;";
                                }
                                print "<TD";
                                print " colspan=" . $colspan if ($colspan > 1);
                                print " rowspan=" . $rowspan if ($rowspan > 1);
                                print ">";
                                &dbprint(9,"createdialogPart: lastused=|$lastUsed|, column=|$column|");
                                $lastUsed = $column;
                                $column  += $colspan;
                                &dbprint(9,"createdialogPart: lastused=|$lastUsed|, column=|$column|");
                        }

                        #
                        # print static virtual fields
                        if($dispname =~ /VIRTUAL/) {
                                print $wert . "\n" if $wert;
                        #
                        # print editable fields
                        } else {
                                #
                                # if there's designinfo available for the field, use it
                                if ($parms{'printm'}) {
                                        &dbprint_hash(9,"createDialogPart: name=|$name|, wert=|$wert|, values=",%values);
                                        &dbprint_hash(9,"createDialogPart: name=|$name|, wert=|$wert|, values=",$rvalues);
                                        if($dispname) {
                                                if($dispname =~ /currency/ && $wert) {
                                                        use Math::Currency qw(Money $LC_MONETARY);
                                                        Math::Currency->format( $LC_MONETARY->{$$rconfigs{'currency'}} );
                                                        $wert = Money(sprintf ("%-15.2f", $wert)) if $wert;
                                                } elsif ($dispname =~ /textarea\s*\d*\s*\d*/ && $wert) {
                                                        if($$rcurrent{'DISPDFIELD'} =~ /pre/i ) {
                                                                $wert = "<PRE>" . &pr_quote($wert) . "</PRE>";
                                                        } else {
                                                                $wert = pr_textarea_bau($wert);
                                                        }
                                                }
                                        }
                                        $wert = "&nbsp;" unless $wert;
                                        print $wert;
                                } else {
                                        my $wert = $values{$name};
                                        $wert    = "" unless $wert;
                                        if( $dispname ) {
                                                my $what;
                                                my $arg1;
                                                my $arg2;
                                                my $arg3;
                                                my $arg4;
                                                &dbprint(9,"createDialogPart: name=|$name|, dispname=|$dispname|, wert=|$wert|");
                                                if($dispname =~ /textarea\s*$/) {
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        print $qu->textarea(-name=>"__$name",
                                                                            -default=>$wert,-force=>1,
                                                                            -rows=>$arg1,
                                                                            -columns=>$arg2) . "\n";
                                                } elsif($dispname =~ /textarea\s*(\d*)\s*(\d*)/) {
                                                        $arg1 = $1, $arg2 = $2;
                                                        print $qu->textarea(-name=>"__$name",
                                                                            -default=>$wert,-force=>1,
                                                                            -rows=>$arg1,
                                                                            -columns=>$arg2) . "\n";
                                                } elsif($dispname =~ /text\s*$/) {
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$arg1,
                                                                             -maxlength=>$arg2) . "\n";
                                                } elsif($dispname =~ /text\s*(\d*)\s*(\d*)/) {
                                                        $arg1 = $1, $arg2 = $2;
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$arg1,
                                                                             -maxlength=>$arg2) . "\n";
                                                } elsif($dispname =~
                                                         /^\s*(relationpopup|multiplepopup)\s*(\w*)\s*([^\s].*[^\s])\s*$/) {
                                                        $what = $1, $arg1 = $2, $arg2 = $3;   # Old Version, will be obsolete later
                                                        print &relationPopup($what,$name, $arg1, $arg2, $arg3) . "\n";
                                                } elsif($dispname =~ /^\s*(relationpopup|multiplepopup\s*(\S*))\s*$/) {
                                                        $what = $1;
                                                        $arg1 = $$rcurrent{'DISPTABLE'};
                                                        $arg2 = $$rcurrent{'DISPVFIELD'};
                                                        $arg3 = $$rcurrent{'DISPDFIELD'};
                                                        $arg4 = $2;
                                                        print &relationPopup($what,$name, $arg1, $arg2, $arg3) . "\n";
                                                } elsif($dispname =~ /popup/) {
                                                        print &valueListPopup($name) . "\n";
                                                } elsif($dispname =~ /NONE/) {
                                                        print "&nbsp;";
                                                } elsif($dispname =~ /COMPUTATION/) {
                                                        print "<INPUT TYPE=HIDDEN NAME=\__$name\ VALUE=\" \">";
                                                        print $wert;
                                                } elsif($dispname =~ /SERIAL/) {
                                                        print $wert;
                                                } elsif($dispname =~ /VIRTUAL/) {
                                                        print "&nbsp;";
                                                } elsif($dispname =~ /CURRENCY/) {
                                                        use Math::Currency qw(Money $LC_MONETARY);
                                                        Math::Currency->format( $LC_MONETARY->{$$rconfigs{'currency'}} );
                                                        $wert = Money(sprintf ("%-15.2f", $wert)) if $wert;
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>15) . "\n";
                                                }
                                                #
                                                # if there's no designinfo available for the field, use common sense...
                                        } else {
                                                my $fieldtype	= $$rcurrent{'TYPE'};
                                                my $fieldlength = $$rcurrent{'SIZE'};
                                                &dbprint_hash(9,"pr_createDialogPart: rcurrent",$rcurrent);
                                                #
                                                # chars are displayed in editable textfields with the size
                                                # of the database field, but not wider than $maxwidth
                                                if($fieldlength > 0 && $fieldtype =~ /char/ ) {
                                                        print $qu->textfield(-name => "__$name",
                                                                             -default => $wert,-force=>1,
                                                                             -size => ($fieldlength > $maxwidth) ?
                                                                                       $maxwidth : $fieldlength,
                                                                             -maxlength => $fieldlength) . "\n";
                                                #
                                                # booleans are displayed in form of radio buttons $buttons{'true'} and
                                                # $buttons{'false'}
                                                } elsif ($fieldtype eq "bool") {
                                                        my $defv = ($wert ? ($wert eq "u" ? "u" : ($wert eq "f" ? "f" : "t")) :
                                                                            ($$rconfigs{'undefbool'} ? $$rconfigs{'undefbool'} :
                                                                             "u"));
                                                        $defv = $1 if ($defv =~ /^'(.)'$/);
                                                        my %plabels  = ("t" => &gtext('true'), "f" => &gtext('false'),
                                                                        "u" => &gtext('bundef'));
                                                        &dbprint(7,"pr_create_dialog_part: name=|$name|, wert bei bool=|$wert|," .
                                                                   " defv=|$defv|");
                                                        print $qu->radio_group( -name => "__$name",
                                                                                -values => ["t", "f", "u"],
                                                                                -default => $defv,-force => 1,
                                                                                -labels => \%plabels
                                                                               );
                                               #
                                                # date fields are shown as is or in language specific format
                                                } elsif ($fieldtype eq "date") {
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>25) . "\n";

                                                #
                                                # float4 fields are shown as is or in language specific format
                                                } elsif ($fieldtype eq "float4") {
                                                        use locale;
                                                        my $oldlocal = setlocale(LC_NUMERIC,$rconfigs{'lang'}) if $rconfigs{'lang'};
                                                        my $wert     = sprintf("%g",$wert);
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>10,
                                                                             -maxlength=>10) . "\n";

                                                #
                                                # text fields are shown as standard text fields, $maxwidth chars wide,
                                                # but accept up to 512 chars
                                                } elsif ($fieldtype eq "text") {
                                                        &dbprint(7,"pr_create_dialog_part: name=|$name|, wert bei txt=|$wert|");
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,
                                                                             -size=>$maxwidth,
                                                                             -maxlength=>$$rconfigs{'maxinpwidth'}) . "\n";

                                                #
                                                # all other fields are also shown as text fields
                                                } else{
                                                        print $qu->textfield(-name=>"__$name",
                                                                             -default=>$wert,-force=>1,) . "\n";
                                                }
                                        }
                                }
                        }
                }
                $fields	.= $name . "," unless $oid;
        }
        chop($fields) unless $oid;
        print "</TABLE>\n";

        #
        # when we show a real record we'll allow our user to either delete or update
        # it or to add a variation of it to the database
        if ($parms{'printm'}) {
                print "<P><CENTER>\n";
                print $qu->submit(-name=>'mode', -value=>&sbutton('back')) . "\n";
                print "</CENTER><P>\n";
        } else {
                print "<P><HR SIZE=4><TABLE BORDER CELLSPACING=0 CELLPADDING=0 WIDTH=100%><TR>";
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->submit(-name=>'mode', -value=>&sbutton('search')) . "\n";
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->submit(-name=>'mode', -value=>&sbutton('add')) . "\n";
                if ( $parms{'oid'} ) {
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('update')) . "\n";
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('delete')) . "\n";
                        print "<TD WIDTH=20% ALIGN=CENTER>";
                        print $qu->submit(-name=>'mode', -value=>&sbutton('print')) . "\n";

                #
                # when we only show an empty dialog the user is allowed to search or add records
                } else {
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                        print "<TD WIDTH=20% ALIGN=CENTER>&nbsp; </TD>";
                }
                print "<TD WIDTH=20% ALIGN=CENTER>";
                print $qu->reset(&sbutton('reset')) . "\n";
                print "</TABLE><P>\n";
        }
}

#
# create the rest of the HTML-Sheet
sub createdialog_end {

        unless ($$rparms{'printm'}) {
                my $maxwidth	= ($$rconfigs{'maxinpwidth'} ? $$rconfigs{'maxinpwidth'} : 25);
                my $text = &gtext("specialselect");
                print "<TABLE BORDER CELLSPACING=0 CELLPADDING=5 WIDTH=100%>";
                print "<TR><TD WIDTH=25%>$text</TD><TD>";
                print $qu->textfield(-name=>'statement', -default=>'SELECT ', -force=>1, -size=>$maxwidth, -maxlength=>512);
                print "</TD></TR></TABLE><P>\n";
        }
}

#
# Subroutine to create a Form from a given template
#
# duplicate the contents of SEARCHMASK into
# MAINFRAME and do some replacements...
#
sub scanAndReplaceTemplate {
	while (<SEARCHMASK>) {

		#
		# if we find a TEXTAREA tag we insert the contents of the field
		# with the given name ahead of the </TEXTAREA> tag
		if(/textarea\s*name\s*\=\s*\"(\w*)\"\s*/i && $values{$1}) {
			$name	= $1;
			s/>(.*)<\/textarea>/>$1$values{$name}<\/TEXTAREA>/i;

		#
		# in case of any NAME tags in the HTML file we insert a VALUE tag with the
		# named fields contents right behind it
		} elsif(/name\s*\=\s*\"(\w*)\"\s*/i && $values{$1}) {
			s/name\s*\=\s*\"(\w*)\"\s*/NAME=\"$1\" VALUE=\"$values{$1}\" /i;
		}


		#
		# in case of #exec commands for SSIs we simply execute them
		if (/<\!--\#exec\s*cmd\=\"(.*)\"\s-->/) {
			$arg	= $1;
			$result	= `$arg`;

			#
			# ... und and replace their call by the result
			s/<\!--\#exec\s*cmd\=\"(.*)\"\s-->/$result/;
		}


		#
		# finally we scan for comment lines starting with <--** -->
		# and interpret the text inside as a Perl script
		if (/<--\*\*(.*)-->/) {
			$arg    = $1;
			$result = eval ($arg);

			#
			# if there's an error during the evaluation we replace
			# the output with the error message
			$result = &dbWarnText(&gtext('eexpr', $arg) . ":<BR>\n$@") if $@;

			#
			# finally we replace the comment by its result
			s/<--\*\*(.*)-->/$result/;
		}

		#
		# if we're showing a real record ...
		if($oid) {
			#
			# replace any search button by an update button and any add button by a delete button
			s/(.*)VALUE\=\"$buttons{'search'}\"(.*)/$1VALUE=\"$buttons{'update'}\"$2/;
			s/(.*)VALUE\=\"$buttons{'add'}\"(.*)/$1VALUE=\"$buttons{'delete'}\"$2/;
		}

		#
		# finally the current line has to be saved
		print $_ . "\n";

		#
		# once we're behind the <FORM ACTION tag we go ahead and insert
		# a couple of hidden fields that we need to know when we're called again...
		if( /FORM\s*ACTION/i ) {
			&pr_db_stop_o_mode;
		}
	}
}


1;
