--
-- PostgreSQL database dump
--

\connect - detlef

SET search_path = public, pg_catalog;

--
-- TOC entry 8 (OID 17519)
-- Name: suppliers; Type: TABLE; Schema: public; Owner: detlef
--

CREATE TABLE suppliers (
    suppl_no integer NOT NULL,
    suppl_name character varying(30) NOT NULL,
    city character varying(30)
);


--
-- TOC entry 9 (OID 17523)
-- Name: parts; Type: TABLE; Schema: public; Owner: detlef
--

CREATE TABLE parts (
    part_no integer NOT NULL,
    description character varying(30) NOT NULL,
    suppl_no integer NOT NULL,
    price numeric(6,2),
    category character(1),
    contained_in integer
);


--
-- TOC entry 2 (OID 17527)
-- Name: customer_cust_no_seq; Type: SEQUENCE; Schema: public; Owner: detlef
--

CREATE SEQUENCE customer_cust_no_seq
    START 1
    INCREMENT 1
    MAXVALUE 9223372036854775807
    MINVALUE 1
    CACHE 1;


--
-- TOC entry 10 (OID 17529)
-- Name: customer; Type: TABLE; Schema: public; Owner: detlef
--

CREATE TABLE customer (
    cust_no integer DEFAULT nextval('"customer_cust_no_seq"'::text) NOT NULL,
    cust_name character varying(30) NOT NULL,
    city character varying(30)
);


--
-- TOC entry 4 (OID 17534)
-- Name: ordering_ord_no_seq; Type: SEQUENCE; Schema: public; Owner: detlef
--

CREATE SEQUENCE ordering_ord_no_seq
    START 1
    INCREMENT 1
    MAXVALUE 9223372036854775807
    MINVALUE 1
    CACHE 1;


--
-- TOC entry 11 (OID 17536)
-- Name: ordering; Type: TABLE; Schema: public; Owner: detlef
--

CREATE TABLE ordering (
    ord_no integer DEFAULT nextval('"ordering_ord_no_seq"'::text) NOT NULL,
    cust_no integer NOT NULL,
    "comment" text,
    termin date,
    titel character varying(50)
);


--
-- TOC entry 6 (OID 17544)
-- Name: order_position_ord_pos_seq; Type: SEQUENCE; Schema: public; Owner: detlef
--

CREATE SEQUENCE order_position_ord_pos_seq
    START 1
    INCREMENT 1
    MAXVALUE 9223372036854775807
    MINVALUE 1
    CACHE 1;


--
-- TOC entry 12 (OID 17546)
-- Name: order_position; Type: TABLE; Schema: public; Owner: detlef
--

CREATE TABLE order_position (
    ord_pos integer DEFAULT nextval('"order_position_ord_pos_seq"'::text) NOT NULL,
    ord_no integer NOT NULL,
    part_no integer NOT NULL,
    account integer,
    price numeric(6,2)
);


--
-- Data for TOC entry 18 (OID 17519)
-- Name: suppliers; Type: TABLE DATA; Schema: public; Owner: detlef
--

INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (1, 'IBM', 'Bblingen');
INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (2, 'Hewlett Packard', 'Bblingen');
INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (3, 'Seagate', NULL);
INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (4, 'Microsoft', 'Mnchen');
INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (5, 'SuSE', 'Frth');
INSERT INTO suppliers (suppl_no, suppl_name, city) VALUES (6, 'Intel', NULL);


--
-- Data for TOC entry 19 (OID 17523)
-- Name: parts; Type: TABLE DATA; Schema: public; Owner: detlef
--

INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (1, 'Computer Mini', 1, 1200.00, 'A', NULL);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (2, 'Computer Maxi', 2, 2200.00, 'A', NULL);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (4, 'Gehaeuse Maxi', 3, 39.00, 'B', 2);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (5, 'Festplatte 30 GB', 3, 299.00, 'A', 3);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (6, 'Festplatte 50 GB', 3, 349.00, 'A', 4);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (7, 'Mainboard 2.0 GHz', 3, 399.00, 'B', 3);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (8, 'Mainboard 2.4 GHz', 3, 499.00, 'B', 4);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (9, 'CD-ROM-Laufwerk', 3, 39.00, 'A', 3);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (10, 'DVD-ROM-Laufwerk', 3, 59.00, 'A', 4);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (14, 'Prozessor 2.0 GHz', 3, 199.00, 'B', 7);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (15, 'Prozessor 2.4 GHz', 3, 299.00, 'B', 8);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (16, 'Grafikkarte Mini', 3, 149.00, 'C', 7);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (17, 'Grafikkarte Maxi', 3, 189.00, 'C', 8);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (18, 'Grafikspeicher 32MB', 3, 49.00, 'C', 16);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (19, 'Grafikspeicher 64MB', 3, 89.00, 'C', 17);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (11, 'Speicherchip 128MB', 6, 99.00, 'B', NULL);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (12, 'Speicherchip 256MB', 6, 159.00, 'B', 7);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (13, 'Speicherchip 512MB', 6, 199.00, 'B', 8);
INSERT INTO parts (part_no, description, suppl_no, price, category, contained_in) VALUES (3, 'Gehaeuse Mini', 3, 29.50, 'B', 1);


--
-- Data for TOC entry 20 (OID 17529)
-- Name: customer; Type: TABLE DATA; Schema: public; Owner: detlef
--

INSERT INTO customer (cust_no, cust_name, city) VALUES (1, 'Musterbesteller', 'Konstanz');
INSERT INTO customer (cust_no, cust_name, city) VALUES (2, 'Anderer', 'Stuttgart');
INSERT INTO customer (cust_no, cust_name, city) VALUES (3, 'Roquefort', 'Paris');


--
-- Data for TOC entry 21 (OID 17536)
-- Name: ordering; Type: TABLE DATA; Schema: public; Owner: detlef
--

INSERT INTO ordering (ord_no, cust_no, "comment", termin, titel) VALUES (1, 1, 'Dies ist eine Bestellung just for fun', '2003-09-28', 'Musterorder');
INSERT INTO ordering (ord_no, cust_no, "comment", termin, titel) VALUES (2, 2, 'Dies ist eine zweite Bestellung just for fun
Sie soll auch bleiben', '2003-11-28', 'Nchste Order');


--
-- Data for TOC entry 22 (OID 17546)
-- Name: order_position; Type: TABLE DATA; Schema: public; Owner: detlef
--

INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (2, 1, 12, 2, 318.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (3, 1, 9, 1, 39.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (4, 1, 17, 1, 189.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (6, 2, 6, 2, 698.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (7, 2, 8, 1, 499.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (5, 2, 4, 1, 39.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (8, 1, 1, 1, 1200.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (9, 2, 2, 1, 2200.00);
INSERT INTO order_position (ord_pos, ord_no, part_no, account, price) VALUES (1, 1, 3, 1, 29.50);


--
-- TOC entry 13 (OID 17521)
-- Name: suppliers_pkey; Type: CONSTRAINT; Schema: public; Owner: detlef
--

ALTER TABLE ONLY suppliers
    ADD CONSTRAINT suppliers_pkey PRIMARY KEY (suppl_no);


--
-- TOC entry 14 (OID 17525)
-- Name: parts_pkey; Type: CONSTRAINT; Schema: public; Owner: detlef
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_pkey PRIMARY KEY (part_no);


--
-- TOC entry 15 (OID 17532)
-- Name: customer_pkey; Type: CONSTRAINT; Schema: public; Owner: detlef
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_pkey PRIMARY KEY (cust_no);


--
-- TOC entry 16 (OID 17542)
-- Name: ordering_pkey; Type: CONSTRAINT; Schema: public; Owner: detlef
--

ALTER TABLE ONLY ordering
    ADD CONSTRAINT ordering_pkey PRIMARY KEY (ord_no);


--
-- TOC entry 17 (OID 17549)
-- Name: order_position_pkey; Type: CONSTRAINT; Schema: public; Owner: detlef
--

ALTER TABLE ONLY order_position
    ADD CONSTRAINT order_position_pkey PRIMARY KEY (ord_pos);


--
-- TOC entry 25 (OID 17590)
-- Name: RI_ConstraintTrigger_17590; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER INSERT OR UPDATE ON parts
    FROM suppliers
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'parts', 'suppliers', 'UNSPECIFIED', 'suppl_no', 'suppl_no');


--
-- TOC entry 23 (OID 17591)
-- Name: RI_ConstraintTrigger_17591; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER DELETE ON suppliers
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_noaction_del" ('<unnamed>', 'parts', 'suppliers', 'UNSPECIFIED', 'suppl_no', 'suppl_no');


--
-- TOC entry 24 (OID 17592)
-- Name: RI_ConstraintTrigger_17592; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER UPDATE ON suppliers
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('<unnamed>', 'parts', 'suppliers', 'UNSPECIFIED', 'suppl_no', 'suppl_no');


--
-- TOC entry 26 (OID 17593)
-- Name: RI_ConstraintTrigger_17593; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER INSERT OR UPDATE ON parts
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'parts', 'parts', 'UNSPECIFIED', 'contained_in', 'part_no');


--
-- TOC entry 27 (OID 17594)
-- Name: RI_ConstraintTrigger_17594; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER DELETE ON parts
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_noaction_del" ('<unnamed>', 'parts', 'parts', 'UNSPECIFIED', 'contained_in', 'part_no');


--
-- TOC entry 28 (OID 17595)
-- Name: RI_ConstraintTrigger_17595; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER UPDATE ON parts
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('<unnamed>', 'parts', 'parts', 'UNSPECIFIED', 'contained_in', 'part_no');


--
-- TOC entry 33 (OID 17596)
-- Name: RI_ConstraintTrigger_17596; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER INSERT OR UPDATE ON ordering
    FROM customer
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'ordering', 'customer', 'UNSPECIFIED', 'cust_no', 'cust_no');


--
-- TOC entry 31 (OID 17597)
-- Name: RI_ConstraintTrigger_17597; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER DELETE ON customer
    FROM ordering
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'ordering', 'customer', 'UNSPECIFIED', 'cust_no', 'cust_no');


--
-- TOC entry 32 (OID 17598)
-- Name: RI_ConstraintTrigger_17598; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER UPDATE ON customer
    FROM ordering
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'ordering', 'customer', 'UNSPECIFIED', 'cust_no', 'cust_no');


--
-- TOC entry 36 (OID 17599)
-- Name: RI_ConstraintTrigger_17599; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER INSERT OR UPDATE ON order_position
    FROM ordering
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'order_position', 'ordering', 'UNSPECIFIED', 'ord_no', 'ord_no');


--
-- TOC entry 34 (OID 17600)
-- Name: RI_ConstraintTrigger_17600; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER DELETE ON ordering
    FROM order_position
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'order_position', 'ordering', 'UNSPECIFIED', 'ord_no', 'ord_no');


--
-- TOC entry 35 (OID 17601)
-- Name: RI_ConstraintTrigger_17601; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER UPDATE ON ordering
    FROM order_position
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'order_position', 'ordering', 'UNSPECIFIED', 'ord_no', 'ord_no');


--
-- TOC entry 37 (OID 17602)
-- Name: RI_ConstraintTrigger_17602; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER INSERT OR UPDATE ON order_position
    FROM parts
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'order_position', 'parts', 'UNSPECIFIED', 'part_no', 'part_no');


--
-- TOC entry 29 (OID 17603)
-- Name: RI_ConstraintTrigger_17603; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER DELETE ON parts
    FROM order_position
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'order_position', 'parts', 'UNSPECIFIED', 'part_no', 'part_no');


--
-- TOC entry 30 (OID 17604)
-- Name: RI_ConstraintTrigger_17604; Type: TRIGGER; Schema: public; Owner: detlef
--

CREATE CONSTRAINT TRIGGER "<unnamed>"
    AFTER UPDATE ON parts
    FROM order_position
    NOT DEFERRABLE INITIALLY IMMEDIATE
    FOR EACH ROW
    EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'order_position', 'parts', 'UNSPECIFIED', 'part_no', 'part_no');


--
-- TOC entry 3 (OID 17527)
-- Name: customer_cust_no_seq; Type: SEQUENCE SET; Schema: public; Owner: detlef
--

SELECT pg_catalog.setval ('customer_cust_no_seq', 1, false);


--
-- TOC entry 5 (OID 17534)
-- Name: ordering_ord_no_seq; Type: SEQUENCE SET; Schema: public; Owner: detlef
--

SELECT pg_catalog.setval ('ordering_ord_no_seq', 3, true);


--
-- TOC entry 7 (OID 17544)
-- Name: order_position_ord_pos_seq; Type: SEQUENCE SET; Schema: public; Owner: detlef
--

SELECT pg_catalog.setval ('order_position_ord_pos_seq', 9, true);


