--
-- PostgreSQL database dump
--

SET client_encoding = 'SQL_ASCII';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: action; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE "action" (
    dbasename text NOT NULL,
    usernames text,
    actiontext text,
    actionorder smallint,
    report boolean DEFAULT false,
    ext_result boolean DEFAULT true,
    in_list boolean DEFAULT true,
    actionname text NOT NULL,
    displayname text,
    tmin timestamp with time zone
);


ALTER TABLE public."action" OWNER TO postgres;

--
-- Name: basedesign; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE basedesign (
    dbasename text NOT NULL,
    tablename text NOT NULL,
    displayname text,
    tableart text,
    tableorder smallint,
    username text,
    description text,
    tmin timestamp with time zone
);


ALTER TABLE public.basedesign OWNER TO postgres;

--
-- Name: configs; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE configs (
    "index" character varying(20) NOT NULL,
    "values" text,
    "comment" text,
    tmin timestamp with time zone
);


ALTER TABLE public.configs OWNER TO postgres;

--
-- Name: databaseconfigs; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE databaseconfigs (
    dbasename text NOT NULL,
    configname character varying(20) NOT NULL,
    configvalue text,
    tmin timestamp with time zone
);


ALTER TABLE public.databaseconfigs OWNER TO postgres;

--
-- Name: dbengine_user; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dbengine_user (
    username text,
    dbasename text NOT NULL,
    tmin timestamp with time zone
);


ALTER TABLE public.dbengine_user OWNER TO postgres;

--
-- Name: designinfo; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE designinfo (
    tablename text NOT NULL,
    fieldname text NOT NULL,
    displayinfo text,
    disptable text,
    dispvfield text,
    dispdfield text,
    displaystring text,
    displayorder integer,
    displaycolumn integer,
    xdefault text,
    xevaluation text,
    dbasename text NOT NULL,
    rowspan smallint,
    colspan smallint,
    tmin timestamp with time zone
);


ALTER TABLE public.designinfo OWNER TO postgres;

--
-- Name: equation; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE equation (
    eqname text NOT NULL,
    content text,
    dbasename text NOT NULL,
    tmin timestamp with time zone
);


ALTER TABLE public.equation OWNER TO postgres;

--
-- Name: helpfile; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE helpfile (
    dbasename text NOT NULL,
    actionname text NOT NULL,
    helpname text NOT NULL,
    languages character varying(4) NOT NULL,
    helptext text,
    tmin timestamp with time zone
);


ALTER TABLE public.helpfile OWNER TO postgres;

--
-- Name: langtexts; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE langtexts (
    "language" character varying(4) NOT NULL,
    indextext character varying(20) NOT NULL,
    translate_text text,
    button boolean DEFAULT false,
    tmin timestamp with time zone
);


ALTER TABLE public.langtexts OWNER TO postgres;

--
-- Name: relation; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE relation (
    parent text NOT NULL,
    parentfield text NOT NULL,
    child text NOT NULL,
    childfield text NOT NULL,
    childorder text,
    childcheck boolean DEFAULT true,
    dbasename text,
    tmin timestamp with time zone
);


ALTER TABLE public.relation OWNER TO postgres;

--
-- Name: tabledesign; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE tabledesign (
    tablename text NOT NULL,
    tablefields text,
    needsvirtuals boolean,
    modifyablelist boolean,
    xtablestart text,
    xtableitem text,
    xtableend text,
    xxquerystring text,
    dbasename text NOT NULL,
    tmin timestamp with time zone
);


ALTER TABLE public.tabledesign OWNER TO postgres;

--
-- Name: valuelist; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE valuelist (
    name text NOT NULL,
    display text NOT NULL,
    orderno integer DEFAULT 1,
    content text NOT NULL,
    dbasename text NOT NULL,
    tmin timestamp with time zone
);


ALTER TABLE public.valuelist OWNER TO postgres;

--
-- Name: virtual; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE virtual (
    tablename text NOT NULL,
    fieldname text NOT NULL,
    fieldtype text,
    "level" integer,
    xequation text,
    dbasename text NOT NULL,
    tmin timestamp with time zone
);


ALTER TABLE public.virtual OWNER TO postgres;

--
-- Data for Name: action; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_test_db', 'detlef', 'my $erg = "<PRE>" . `psql -l` . "</PRE>";
$_ = $erg;', 3, false, true, true, 'Possible_databases', NULL, '2003-07-24 12:02:43.639708+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_test_db', 'ALL', 'my @mis_parts = ();
my $erg;
my $orderpno = 0;
my $orderno;
my $acmd = q{SELECT ord_no,titel FROM ordering};
my $stdh = &db_db_get(''dbase'',$acmd);
my @orders;
while (my $rarray = &db_db_hashref($stdh) ) {
   push(@orders,"$$rarray{''ord_no''}:::$$rarray{''titel''}");
}
$orderno = @orders;
foreach my $ordert (@orders) {
   my($order,$title) = split(/:::/,$ordert,2);
   $acmd = q{SELECT part_no,ord_pos FROM order_position} .
           qq{ WHERE ord_no = $order};
   $stdh = &db_db_get(''dbase'',$acmd);
   my @orderpos;
   while(my $rarray = &db_db_hashref($stdh)) {
      push(@orderpos,"$$rarray{''part_no''}:::$$rarray{''ord_pos''}");
   }
   $orderpno += @orderpos;
   foreach my $part_ord (@orderpos) {
      my($part_no, $order_pos) = split(/:::/,$part_ord,2);
      $acmd = "SELECT a.part_no,a.description FROM parts a, parts b" .
              " where b.part_no = $part_no" .
              " AND a.part_no = b.contained_in";
      $stdh = &db_db_get(''dbase'',$acmd);
      while (my $rarray = &db_db_hashref($stdh)) {
         my $partn = $$rarray{''part_no''};
         my $found = 0;
         foreach my $partord (@orderpos) {
            if ($partord =~ /^${partn}:::/) {
               $found = 1;
               last;
            }
         }
         unless ($found) {
            push (@mis_parts,"$ordert;;;$part_ord;;;" .
                             "${partn}:::$$rarray{''description''}");
         }
      }
   }
}
if(@mis_parts) {
   print "<h2><center>Missing parts in orders</center></h2>\\n";
   print "<table border cellspacing=5 align=center>\\n<tr>" .
         "<th>Ord_no</th><th>title</th>" .
         "<th>Ord_pos</th><th>Ordered part_no</th>" .
         "<th>Missing part_no</th>" .
         "<th>Missing part description</th></tr>\\n";
   foreach my $mispart (@mis_parts) {
      my ($ordert, $part_ord, $partd) = split(/;;;/,$mispart,3);
      my ($ord_no, $titel) = split(/:::/,$ordert,2);
      my ($part_no, $ord_pos) = split(/:::/,$part_ord,2);
      my ($partn, $descr) = split(/:::/,$partd,2);
      print "<tr><td>$ord_no</td><td>$titel</td><td>$ord_pos</td>" .
            "<td>$part_no</td><td>$partn</td><td>$descr</td></tr>\\n";
   }
   print "</table><P>\\n";
   my $missorders = @mis_parts;
   $erg = "Not all orders ok:<BR>\\n$missorders of $orderpno orderpositions" .
          " in $orderno existent orders not satisfied";
} else {
   $erg = "No part in any of $orderno orders missed" .
          "All $orderno are satisfied";
}
print "<HR><P><H2><CENTER>$erg</CENTER></H2>\\n";
$_ = $erg;', 1, false, true, true, 'Check_Order', NULL, '2005-03-06 13:21:59.62975+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('ereignisse', 'ALL', 'my $cmd = "SELECT oid,* FROM ereignis WHERE oid=" . pr_get_parms(''oid'');
my $cmdt = "SELECT oid,* FROM teil_ereignis WHERE erg_no=";
my $cmdt1 = " ORDER BY t_erg_anf, erg_art_nam";
my $refer = "dbengine.cgi?dbase=dbi:Pg:dbname=ereignisse&mode=plain" .
            "&table=ereignis&kennz=" . &pr_get_parms(''kennz'') .
            "&oid=";
my $trefe = "dbengine.cgi?dbase=dbi:Pg:dbname=ereignisse&mode=plain" .
            "&table=" . &pr_quote("teil_ereignis") . "&kennz=" .
            &pr_get_parms(''kennz'') . "&oid=";
#
# Ereignisse suchen und listen
#
my $nrows = 0;
$result = &db_db_get(''dbase'',$cmd);
my $rarray = &db_db_hashref($result);
my $erg_no = $$rarray{''erg_no''};
my $t_ergeb = $$rarray{''erg_t_erg''};
print "<H2><CENTER>Liste der Suchergebnisse</CENTER></H2>\\n" .
      "<TABLE align=center cellspacing=0 " .
      "cellpadding=10 WIDTH=99% BORDER>\\n<TR>" .
      "<TH>Ereignisart<BR>Ereignis<BR>NR.</TH>" .  
      "<TH>Datum<BR>Teilnehmer</TH><TH>Beschreibung</TH>" .
      "</TR>\\n";

my $eln = qq{<a href="$refer} . $$rarray{''oid''} . qq{">} .
          $$rarray{''erg_no''} . qq{</a>};
my $datanf = $$rarray{''erg_anf''};
my $datend = $$rarray{''erg_end''};
$datanf = "$datanf<BR>&nbsp;&nbsp;-&nbsp;$datend"
          if ($datanf ne $datend);
my $teiln = join('', '',split(/:::/, $$rarray{''tn_nam''}));
my $erg_art = join('', '',split(/:::/,$$rarray{''erg_art_nam''}));
my $ereignis = $$rarray{''ereignis''};
$ereignis = &pr_textarea_bau($ereignis);
print "<TR><TD><CENTER><B>Ereignis $eln</B><BR>&nbsp;<BR>\\n" .
      "$erg_art<BR>----<BR>\\n" .
      $$rarray{''erg_titel''} . "</CENTER></TD>\\n<TD>$datanf" .
      "<BR>----<BR>" . $teiln . "</TD>\\n<TD>" . "$ereignis</TD></TR>\\n";
$result->finish;
if ($t_ergeb) {
   $cmdt .= $erg_no . $cmdt1;
   $result = db_db_get(''dbase'', $cmdt);
   while (my $rteil = &db_db_hashref($result)) {
      $nrows++;
      &dbprint_hash(7,"Ereignislist: erg_no=|$erg_no|, rteil",$rteil);
      $datanf = $$rteil{''t_erg_anf''};
      $datend = $$rteil{''t_erg_end''};
      $datanf = "$datanf<BR>&nbsp;&nbsp;-&nbsp;$datend"
             if ($datanf ne $datend);
      $teiln = join('', '',split(/:::/, $$rteil{''tn_nam''}));
      $erg_art = join('', '',split(/:::/,$$rteil{''erg_art_nam''}));
      $ereignis = $$rteil{''t_ereignis''};
      $ereignis = &pr_textarea_bau($ereignis);
      my $teln = qq{<a href="$trefe} . $$rteil{''oid''} . qq{">} .
             $$rteil{''t_erg_no''} . qq{</a>};
      print "<TR><TD><CENTER>" .
            "<B>Teilereignis $teln<BR>\\nzu Ereignis" .
            "$eln</B><BR>&nbsp;<BR>\\n" .
            "$erg_art<BR>----<BR>\\n" . $$rteil{''t_erg_titel''} .
            "</CENTER></TD>\\n<TD>$datanf<BR>----<BR>\\n$teiln" .
            "</TD>\\n<TD>$ereignis</TD></TR>\\n";
   }
   $result->finish;
  
}
print "</TABLE>\\n<P><B>" .
   (($nrows == 0) ? "Keine Teilereignisse" :
    ($nrows == 1) ? "Ein Teilereignis" : "$nrows Teilereignisse" ) .
   " zum Ereignis $erg_no gefunden</B><P>\\n";

$nrows;', 2, true, false, false, 'Ereignis komplett', NULL, '2006-03-12 15:28:43.349764+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_test_db', 'ALL', 'URL=/cgi-bin/print.pl', NULL, false, true, true, 'testaction', NULL, '2005-03-02 16:32:36.560946+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_test_db', 'ALL', 'my @mis_parts = ();
my $erg;
my $orderpno = 0;
my $orderno;
my $acmd = q{SELECT ord_no,titel FROM ordering};
my $stdh = &db_db_get(''dbase'',$acmd);
my @orders;
while (my $rarray = &db_db_hashref($stdh) ) {
   push(@orders,"$$rarray{''ord_no''}:::$$rarray{''titel''}");
}
$orderno = @orders;
foreach my $ordert (@orders) {
   my($order,$title) = split(/:::/,$ordert,2);
   $acmd = q{SELECT part_no,ord_pos FROM order_position} .
           qq{ WHERE ord_no = $order};
   $stdh = &db_db_get(''dbase'',$acmd);
   my @orderpos;
   while(my $rarray = &db_db_hashref($stdh)) {
      push(@orderpos,"$$rarray{''part_no''}:::$$rarray{''ord_pos''}");
   }
   $orderpno += @orderpos;
   foreach my $part_ord (@orderpos) {
      my($part_no, $order_pos) = split(/:::/,$part_ord,2);
      $acmd = "SELECT a.part_no,a.description FROM parts a, parts b" .
              " where b.part_no = $part_no" .
              " AND a.part_no = b.contained_in";
      $stdh = &db_db_get(''dbase'',$acmd);
      while (my $rarray = &db_db_hashref($stdh)) {
         my $partn = $$rarray{''part_no''};
         my $found = 0;
         foreach my $partord (@orderpos) {
            if ($partord =~ /^${partn}:::/) {
               $found = 1;
               last;
            }
         }
         unless ($found) {
            push (@mis_parts,"$ordert;;;$part_ord;;;" .
                             "${partn}:::$$rarray{''description''}");
         }
      }
   }
}
if(@mis_parts) {
   print "<h2><center>Missing parts in orders</center></h2>\\n";
   print "<table border cellspacing=5 align=center>\\n<tr>" .
         "<th>Ord_no</th><th>title</th>" .
         "<th>Ord_pos</th><th>Ordered part_no</th>" .
         "<th>Missing part_no</th>" .
         "<th>Missing part description</th></tr>\\n";
   foreach my $mispart (@mis_parts) {
      my ($ordert, $part_ord, $partd) = split(/;;;/,$mispart,3);
      my ($ord_no, $titel) = split(/:::/,$ordert,2);
      my ($part_no, $ord_pos) = split(/:::/,$part_ord,2);
      my ($partn, $descr) = split(/:::/,$partd,2);
      print "<tr><td>$ord_no</td><td>$titel</td><td>$ord_pos</td>" .
            "<td>$part_no</td><td>$partn</td><td>$descr</td></tr>\\n";
   }
   print "</table><P>\\n";
   my $missorders = @mis_parts;
   $erg = "Not all orders ok:<BR>\\n$missorders of $orderpno" .
          " orderpositions" .
          " in $orderno existent orders not satisfied";
} else {
   $erg = "No part in any of $orderno orders missed" .
          "All $orderno are satisfied";
}
print "<HR><P><H2><CENTER>$erg</CENTER></H2>\\n";
$_ = $erg;', 1, true, false, true, 'orderlist', NULL, '2005-03-03 14:53:35.766354+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_test_db', 'detlef, duerr', 'my $ergline =
      "<H2><CENTER>List of parts needed by other parts</CENTER></H2>\\n";
$ergline   .= "<TABLE ALIGN=CENTER><TR><TD><PRE>\\n";
$ergline   .= &db_callSub(''parts_containing'',''NULL'',0);
$ergline   .= "</PRE></TD></TR></TABLE><P>\\n";', 2, true, true, true, 'Parts_level_list', NULL, '2005-03-03 15:25:37.60594+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_info_db', 'Admins, detlef', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
&pr_form_start('' '');
print $qu->hidden(-name=>''actionname'',-value=>''__STD_cr_del_db'') .
      "\\n";
print "<TABLE CELLSPACING=10 CELLPADDING=10 ALIGN=CENTER>\\n";
print "<TR><TD>" . &gtext(''dbasename'') . ":</TD><TD colspan=3>" .
      $qu->textfield(-name=>''__new_db_name'', -size=>32) .
      "</TD></TR>\\n";
print "<TR><TD colspan=4><P><HR><P><CENTER>" . &gtext(''db_db_cr'') .
      "</CENTER></TD></TR>\\n";
print "<TR><TD>" . &gtext(''db_description'') . ":</TD><TD colspan=3>" .
      $qu->textfield(-name=>''__db_description'', -size=>60) .
      "</TD></TR>\\n";
print "<TR><TD>" . &gtext(''db_owner'') . ":</TD><TD colspan=3>" .
         $qu->textfield(-name=>''__db_owner'', -size=>60) . "</TD></TR>";
print "<TR><TD colspan=4><P><HR><P></TD></TR>\\n" .
      "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>\\n" .
      "<tr><td>&nbsp;</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''db_create'')) .
      "</td><td>" .
      $qu->submit(-name=>''submit'', -value=>&sbutton(''db_delete'')) .
      "</td><td>\\n" .
      $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
   &pr_db_stop;
', 1100, false, false, true, '__STD_dbcreate', 'lang(ac_dbcreate)', '2004-10-17 15:32:57.256914+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'ALL', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
my $user = &pr_get_parms(''user'');
my $not_admin = !&db_is_admin($user);
my %plabels = (''t''=>&gtext(''true''), ''f''=>&gtext(''false''));
&pr_form_start('' '');
print $qu->hidden(-name=>''actionname'',
                  -value=>''__STD_create_delete_user'') . "\\n";
print "<TABLE CELLSPACING=5 CELLPADDING=5 ALIGN=CENTER>\\n";
print "<TR><TD>" . &gtext(''user'') . ":</TD><TD colspan=3>" .
      "<INPUT TYPE=text name=''__new_user_name'' size=32 " .                        
      "value=$user" . ($not_admin ? " readonly>" : ">") .
      "</TD></TR>\\n";
print "<TR><TD colspan=4><P><HR><P><CENTER>" . &gtext(''db_user_cr'') .
      "</CENTER></TD></TR>\\n";
print "<TR><TD COLSPAN=4>" . &gtext(''db_passwd'') . "</TD></TR>\\n";
print "<TR><TD>" . &gtext(''passwd'') . ":</TD><TD colspan=3>" .
      $qu->password_field(-name=>''__db_passwd'', -size=>20) .
      "</TD></TR>\\n<TR><TD>" . &gtext(''db_passwd2'') . ":</TD><TD>" .
      $qu->password_field(-name=>''__db_passwd2'', -size=>20) .
      "</TD><TD>" . &gtext(''db_encrypt'') . "</TD><TD>" .
      $qu->radio_group(-name=>''__encrypt_pwd'', -values=>[''t'',''f''],
                       -default=>''f'', -force=>1, -labels=>\\%plabels
                      ) . "</TD></TR>\\n";
unless ($not_admin ) {
   print "<TR><TD COLSPAN=4>" . &gtext(''db_rights'') . "</TD></TR>\\n";
   print "<TR><TD>" . &gtext(''db_can_createdb'') . ":</TD><TD>" .
         $qu->radio_group(-name=>''__db_can_createdb'',                       
                          -values=>[''t'',''f''], -default=>''f'', -force=>1,
                          -labels=>\\%plabels) . "</TD><TD>" .
         &gtext(''db_can_createuser'') . ":</TD><TD>" .
         $qu->radio_group(-name=>''__db_can_createuser'',
                          -values=>[''t'',''f''], -default=>''f'', -force=>1,
                          -labels=>\\%plabels) . "</TD></TR>\\n";
}
print "<TR><TD COLSPAN=4>" . &gtext(''db_variables'') . "</TD></TR>\\n";
print "<TR><TD>DateStyle</TD><TD>" .
      $qu->popup_menu(
             -name=>''__DateStyle'',
             -values=>['''',''German'',''US'',''ISO'',''SQL'',
                       ''SQL,European'',''SQL,NonEuropean'',''Postgres'',                             
                       ''Postgres,European'',''Postgres,NonEuropean'']) .
      "</TD><TD>" . &gtext(''var_reset'') . "</TD><TD>" .
      $qu->radio_group(-name=>''__db_dat_reset'', -values=>[''t'',''f''],
                       -default=>''f'', -force=>1, -labels=>\\%plabels) .
      "</TD></TR>\\n";
my @timezones = ('''');
&db_get_timezones(\\@timezones);
print "<TR><TD>TimeZone</TD><TD>" .
      $qu->popup_menu(-name=>''__TimeZone'', -values=>\\@timezones) .
      "</TD><TD>" . &gtext(''var_reset'') . "</TD><TD>" .
      $qu->radio_group(-name=>''__db_time_reset'', -values=>[''t'',''f''],
                       -default=>''f'', -force=>1, -labels=>\\%plabels) .
      "</TD></TR>\\n";
print "<TR><TD colspan=4><P><HR><P></TD></TR>\\n" .
      "<tr><td><INPUT TYPE=submit name=submit value=''" .
      &sbutton(''user_create'') . ($not_admin ? "'' disabled>" : "''>") .
      "</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''user_change'')) .
      "</td><td>" . "<INPUT TYPE=submit value=''" .
      &sbutton(''user_delete'') . ($not_admin ? "'' disabled>" : "''>") .
      "</td><td>\\n";
print $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
&pr_db_stop;
', 2000, false, false, true, '__STD_manage_user', 'lang(ac_manage_user)', '2004-10-17 15:27:23.592502+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('dbengine_info_db', 'Admins,detlef', 'my $subm_button = &pr_get_parms(''submit'');
$subm_button = &gbutton($subm_button) if $subm_button;
$subm_button = "" unless $subm_button;
my $result;
if ( $subm_button eq ''db_create'') {
   my $new_db_name = &pr_get_parms(''__new_db_name'');
   my $db_owner = &pr_get_parms(''__db_owner'');
   my $db_desc  = &pr_get_parms(''__db_description'');
   my $cmd = "create database $new_db_name";
   $cmd .= " WITH OWNER $db_owner" if $db_owner;
   &dbprint(7,"database creation: cmd=|$cmd|");
   &db_do_cmd(''dbase'',$cmd);
   $result = &gtext(''db_create_ok'',$new_db_name);
   if ( $db_desc ) {
      my $conns = &db_db_aconn(''third'',1,$new_db_name);
      my @dbbinds = ($db_desc);
      &db_do_cmd(''third'',
          "REVOKE ALL ON DATABASE $new_db_name FROM PUBLIC");
      &db_do_cmd(''third'',
          "COMMENT ON DATABASE $new_db_name IS ?",\\@dbbinds);
      $conns->disconnect;
      &db_do_cmd(''dbase'',"INSERT INTO databaseconfigs " . 
              "(dbasename,configname,configvalue,tmin) " .
              "values ( ''$new_db_name'', ''comment'', ?, ''now'' )",
              \\@dbbinds); 
      $result .= "<BR>\\n" .&gtext(''db_comment_ok'',$new_db_name);
   } 
} else {
   my $new_db_name = &pr_get_parms(''__new_db_name'');
   my $cmd = "drop database $new_db_name";
   &dbprint(7,"database deletion: name=|$cmd|");
   my $erg = &db_do_cmd(''dbase'',$cmd);
   $result = &gtext(''db_delete_ok'',$new_db_name, "<BR>\\n$erg<BR>\\n");
}
$result;
', 1101, false, true, false, '__STD_cr_del_db', 'lang(ac_dbcreate)', '2004-10-17 15:33:36.066464+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('ereignisse', 'ALL', 'my $cmd   = "SELECT a.oid,a.* FROM ereignis a WHERE (";
my $cmdt  = "SELECT a.oid,a.* FROM teil_ereignis a WHERE";
my $kennz = &pr_get_parms(''kennz'');
my $refli = "dbengine.cgi?dbase=dbi:Pg:dbname=ereignisse&mode=action" .
            "&table=ereignis&kennz=$kennz&actionname=" .
            &pr_quote("Ereignis komplett") . "&oid=";
my $refer = "dbengine.cgi?dbase=dbi:Pg:dbname=ereignisse&mode=plain" .
            "&table=ereignis&kennz=$kennz&oid=";
my $trefe = "dbengine.cgi?dbase=dbi:Pg:dbname=ereignisse&mode=plain" .
            "&table=" . &pr_quote("teil_ereignis") . "&kennz=" .
            "$kennz&oid=";
my $weiter = "";
my $weiter_nxt = "OR";
my @binds = ();
my @t_binds = ();

# suchbefehle bauen
#
sub def_suc {
   my ($woher, $ewas, $twas,$foptype,$dispname,$vglop) = @_;
   $vglop = "" unless $vglop;
   if (my $was = &pr_get_parmfields($woher,$dispname,$foptype)) {
      if ($foptype eq ''date'') {
         &dbError(&gtext(''illeg_date'',$was))
           unless ($was =~ /^\\s*(\\d\\d?(\\.|-|\\/)){2}\\d\\d?\\d?\\d?\\s*$/);
      }
      $was = $vglop . $was if $vglop;
      $cmd .= " $weiter ";
      $cmd .= "( " if ($weiter_nxt eq "OR");
      &db_ValueToSQL(\\$cmd, \\@binds, $ewas, $was,
                     $dispname, $foptype, 0);
      $cmd .= " )" if ( $weiter eq "OR" && $weiter_nxt eq "AND" );
      $cmdt .= " $weiter ";
      $cmdt .= "( " if ($weiter_nxt eq "OR");
      &db_ValueToSQL(\\$cmdt, \\@t_binds, $twas, $was,
                     $dispname, $foptype, 0);
      $cmdt .= " )" if ( $weiter eq "OR" && $weiter_nxt eq "AND" );
      $weiter = $weiter_nxt;
   }
}

&def_suc(''__erg_such'',''erg_titel'',''t_erg_titel'',''text'',''text'');
$weiter_nxt = "AND";
&def_suc(''__erg_such'',''ereignis'',''t_ereignis'',''text'',''text'');
&def_suc(''__tn_nam'',''tn_nam'',''tn_nam'',''text'',''multiplepopup'');
&def_suc(''__erg_art_nam'',''erg_art_nam'',''erg_art_nam'',''text'',''multiplepopup'');
&def_suc(''__anf_dat'',''erg_end'',''t_erg_end'',''date'',''date'',''>='');
my $woher = ''__end_dat'';
$woher = __anf_dat
     unless (&pr_get_parmfields(''__end_dat'',''date'',''date''));
&def_suc($woher,''erg_anf'',''t_erg_anf'',''date'',''date'',''<='');

#
# Teilereignisse suchen in sichern
#
$cmdt .= " ORDER BY t_erg_anf, erg_art_nam";
my @ergnos = ();
my %t_ergnos = ();
my %teil_ereig = ();
&dbprint_cmd_binds(1,$cmdt,@t_binds);
my $result = &db_db_get(''dbase'',$cmdt,\\@t_binds);
while (my $rarray = &db_db_hashref($result)) {
   my $ergno = $$rarray{''erg_no''};
   my $tergno = $$rarray{''t_erg_no''};
   $teil_ereig{$tergno}{''erg_no''} = $ergno;
   my $rteil = $teil_ereig{$tergno};
   foreach my $name (xSort(keys %$rarray)) {
      $$rteil{$name} = $$rarray{$name};
   }
   if ($t_ergnos{$ergno}) {
      $t_ergnos{$ergno} .= ", ";
   } else {
      $t_ergnos{$ergno} = "";
      push(@ergnos,$ergno);
   }
   $t_ergnos{$ergno} .= $tergno;
}
$result->finish;
$cmd .= " ) OR erg_no IN (" .  join('', '',@ergnos) if (@ergnos);
#
# Ereignisse suchen und listen
#
my $nrows = 0;
my $tnrows = 0;
$cmd .= " ) ORDER BY erg_anf, erg_art_nam";
&dbprint_cmd_binds(1,$cmd,@binds);
$result = &db_db_get(''dbase'',$cmd,\\@binds);
while (my $rarray = &db_db_hashref($result)) {
   my $erg_no = $$rarray{''erg_no''};
   unless ($nrows) {
      print "<H2><CENTER>Liste der Suchergebnisse</CENTER></H2>\\n" .
            "<TABLE align=center cellspacing=0 " .
            "cellpadding=10 WIDTH=99% BORDER>\\n<TR>" .
            "<TH ALIGN=RIGHT>Satznr.</TH>" .
            "<TH>Ereignisart<BR>Ereignis</TH>" .  
            "<TH>Datum<BR>Teilnehmer</TH><TH>Beschreibung</TH>" .
            "</TR>\\n";
   }
   $nrows++;
   my $sln = qq{<a href="$refli} . $$rarray{''oid''} . qq{">$nrows</a>};
   my $eln = qq{<a href="$refer} . $$rarray{''oid''} . qq{">} .
          $$rarray{''erg_no''} . qq{</a>};
   my $datanf = $$rarray{''erg_anf''};
   my $datend = $$rarray{''erg_end''};
   $datanf = "$datanf<BR>&nbsp;-&nbsp;&nbsp;$datend"
        if ($datanf ne $datend);
   my $teiln = join('', '',split(/:::/, $$rarray{''tn_nam''}));
   my $erg_art = join('', '',split(/:::/,$$rarray{''erg_art_nam''}));
   my $ereignis = $$rarray{''ereignis''};
   $ereignis = &pr_textarea_bau($ereignis);
   print "<TR><TD align=right>$sln</TD>\\n" .
      "<TD><center><B>Ereignis&nbsp;$eln</B><BR>&nbsp;<BR>\\n" .
      "$erg_art<BR>----<BR>\\n" .
      $$rarray{''erg_titel''} . "</center></TD>\\n" .
      "<TD>$datanf<BR>----<BR>\\n$teiln</TD>\\n" .
      "<TD>$ereignis</TD></TR>\\n";
   if (my $tergnos = $t_ergnos{$erg_no}) {
     my @tergno = split(/, /,$tergnos);
     for (my $i = 0; $i < @tergno; $i++) { 
      my $rteil = $teil_ereig{$tergno[$i]};
      $tnrows++;
      &dbprint_hash(7,"Ereignislist: erg_no=|$erg_no|, rteil",$rteil);
      $datanf = $$rteil{''t_erg_anf''};
      $datend = $$rteil{''t_erg_end''};
      $datanf = "$datanf<BR>&nbsp;-&nbsp;&nbsp;$datend"
             if ($datanf ne $datend);
      $teiln = join('', '',split(/:::/, $$rteil{''tn_nam''}));
      $erg_art = join('', '',split(/:::/,$$rteil{''erg_art_nam''}));
      $ereignis = pr_textarea_bau($$rteil{''t_ereignis''});
      if ($ereignis =~ /\\012/) {
         my @ereignis = split(/\\012/,$ereignis);
         $ereignis = "";
         foreach my $ereign1 (@ereignis) {
            if (length($ereign1) <= 50) {
               $ereign1 =~ s/ /&nbsp;/g;
            } else {
               $ereign1 =~ s/  /&nbsp;&nbsp;/g;
            }
            $ereignis .= "<BR>\\n" if $ereignis;
            $ereignis .= $ereign1;
         }
      }
      my $teln = qq{<a href="$trefe} . $$rteil{''oid''} . qq{">} .
             $$rteil{''t_erg_no''} . qq{</a>};
      print "<TR><TD>&nbsp;</TD>\\n<TD>" . 
            "<CENTER><B>Teilereignis&nbsp;$teln<BR>\\n" .
            "zu Ereignis&nbsp;$eln" .
            "</B><BR>&nbsp;<BR>\\n$erg_art<BR>----<BR>\\n" .
            $$rteil{''t_erg_titel''} .
            "</CENTER></TD>\\n" .
            "<TD>$datanf<BR>----<BR>\\n$teiln</TD>\\n" .
            "<TD>$ereignis</TD></TR>\\n";
     }
   }
}
$result->finish;
if($nrows) {
   print "</TABLE>\\n<P><B>\\n" .
         (($nrows == 1) ? "Ein Ereignis " : "$nrows Ereignisse ") .
         (($tnrows == 0) ? "ohne Teilergnisse" : "mit " .
          (($tnrows == 1) ? "einem Teilereignis" :
                            "insgesamt $tnrows Teilereignissen" )
          ) . " gefunden</B><P>\\n";
} else {
   die("Keine Ergebnisse gefunden, bitte neue Suche starten\\n");
}
$nrows;', 2, true, false, false, 'Ereignis auflisten', NULL, '2006-03-12 15:32:03.615629+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'ALL', 'my $subm_button = &pr_get_parms(''submit'');
my $result;
$subm_button = &gbutton($subm_button) if $subm_button;
$subm_button = "" unless $subm_button;
my $not_admin = !&db_is_admin($user);
my $new_user_name = &pr_get_parms(''__new_user_name'');

if ( $subm_button ne ''user_delete'') {
   my $psql_opts = "";
   if (my $db_passwd = &pr_get_parms(''__db_passwd'')) {
      die(&gtext(''passwd_check_nok''))
          unless ($db_passwd eq &pr_get_parms(''__db_passwd2''));
      $psql_opts .= "UN"
           if (&pr_get_parms(''__encrypt_pwd'') eq ''f'');
      $psql_opts .= "ENCRYPTED PASSWORD ''$db_passwd'' ";
   }
   unless($not_admin) {
      $psql_opts .= "NO"
         if (&pr_get_parms(''__db_can_createdb'') eq '''');
      $psql_opts .= "CREATEDB ";
      $psql_opts .= "NO"
         if (&pr_get_parms(''__db_can_createuser'') eq ''f'');
      $psql_opts .= "CREATEUSER ";
   }
   if ($psql_opts) {
      my $cmd = ($subm_button eq "user_create") ? "CREATE" : "ALTER";
      $cmd .= qq{ USER "$new_user_name"};
      $cmd .= " WITH $psql_opts" if $psql_opts;
      &dbprint(7,"User creation: cmd=|$cmd|");
      my $erg = &db_do_cmd(''dbase'',$cmd);
   }
   if (my $datereset = (&pr_get_parms(''__db_dat_reset'') eq ''t'')) {
      my $erg = &db_do_cmd(''dbase'',
        qq{ALTER USER $new_user_name RESET DateSTyle});
   } elsif ( my $datest = &pr_get_parms(''__DateStyle'' )) {
      my $erg = &db_do_cmd(''dbase'',
        qq{ALTER USER $new_user_name SET DateStyle TO ''$datest''});
   }
   if (my $timereset = (&pr_get_parms(''__db_time_reset'') eq ''t'')) {
      my $erg = &db_do_cmd(''dbase'',
        qq{ALTER USER $new_user_name RESET TimeZone});
   } elsif ( my $timez = &pr_get_parms(''__TimeZone'' )) {
      my $erg = &db_do_cmd(''dbase'',
        qq{ALTER USER $new_user_name SET TimeZone TO ''$timez''});
   }
   $result = &gtext(''user_create_ok'', $new_user_name);
} else {
   my $cmd = "DROP USER $new_user_name";
   &dbprint(7,"user deletion: name=|$cmd|");
   my $erg = &db_do_cmd(''dbase'',$cmd);
   $result = &gtext(''user_delete_ok'', $new_user_name);
}
$result;', 2001, false, true, false, '__STD_create_delete_user', 'lang(ac_manage_user)', '2004-11-15 16:34:55.7159+01');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'DB_OWNER,Admins', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
&pr_form_start('' '');
print $qu->hidden(-name=>''actionname'', -value=>''__STD_cr_del_schema'');
print "<TABLE CELLSPACING=10 CELLPADDING=10 ALIGN=CENTER>";
print "<TR><TD>" . &gtext(''schemaname'') . ":</TD><TD colspan=3>" .
      $qu->textfield(-name=>''__new_schema_name'', -size=>32) .
      "</TD></TR>\\n";
print "<TR><TD colspan=4><P><HR><P><CENTER>" . &gtext(''db_schema_cr'') .
      "</CENTER></TD></TR>\\n";
print "<TR><TD>" . &gtext(''schem_owner'') . ":</TD><TD colspan=3>" .
      $qu->textfield(-name=>''__schem_owner'', -size=>60) .
      "</TD></TR>\\n";
print "<TR><TD>" . &gtext(''schema_grant_name'') .
      ":</TD><TD colspan=3>" .
      $qu->textfield(-name=>''__schem_users'', -size=>32) .
      "</TD></TR>\\n";
print "<TR><TD>" . &gtext(''schema_grant_mode'') .
      ":</TD><TD colspan = 3><SELECT name=__new_sch_grants>" .
      ''<OPTION selected value="">'' .
      ''<OPTION value="CREATE">CREATE'' .
      ''<OPTION value="USAGE">USAGE'' .
      ''<OPTION value="ALL">ALL</SELECT></TD></TR>'';
print "<TR><TD colspan=4><P><HR><P></TD></TR>\\n" .
      "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>\\n" .
      "<tr><td>&nbsp;</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''schema_create'')) .
      "</td><td>" .
      $qu->submit(-name=>''submit'', -value=>&sbutton(''schema_delete'')) .
      "</td><td>\\n" .
      $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
   &pr_db_stop;', 3000, false, false, true, '__STD_schema_manage', 'lang(schema_manage)', '2004-10-17 15:29:21.018917+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'DB_OWNER,Admins', 'my $dbasen = &pr_get_parms(''dbasen'');
my $schema = &pr_get_parms(''__new_schema_name'');
$schema    = &pr_get_parms(''user'') unless $schema;
die(&gtext(''sch_no_name'',$schema))
    unless($schema =~ /^[A-Za-z][A-Za-z0-9_]*$/ );
my $qu     = &db_get_configs(''qu_cgi'');
my $was    = &gbutton(&pr_get_parms(''submit''));
my $erg    = "";
$qu->delete_all;
&dbprint(7,"__STD_cr_del_schema: schema=|$schema|,was=|$was|");

if ( $was eq ''schema_create'') { # Schema erzeugen
   my $grants = &pr_get_parms(''__new_sch_grants'');
   my $owner  = &pr_get_parms(''__schem_owner'');
   die(&gtext(''sch_no_name'',$owner))
      unless($owner =~ /^[A-Za-z][A-Za-z0-9_]*$/ );
   my $users  = &pr_get_parms(''__schem_users'');
   
   my $cmd = qq{create schema "$schema" };
   if($owner) {
      $cmd .= qq{ AUTHORIZATION "$owner" };
   }
   if ($users && $grants) {
      foreach my $user (split (/,\\s*/,$users)) {
         &dbprint(7,"action___STD_cr_del_schema: user=|$user|");     
         die(&gtext(''sch_no_name'',$user))
            unless($user =~ /^([A-Za-z]\\w*)(\\s*,\\s*[A-Za-z]\\w*)*\\s*$/ );
         $cmd .= qq{\\n   GRANT $grants ON SCHEMA "$schema" TO "$user" };
      }
   }
   &dbprint(7,"__STD_cr_del_schema: cmd=|$cmd|");
   die(&gtext(''sch_no_cr'',$schema)) unless &db_do_cmd(''dbase'',$cmd);
   $erg = "sch_cr";
} else {  # Schema lschen
   my @binds = ($schema);
   die(&gtext(''sch_no_del'',$schema))
        unless &db_do_cmd(''dbase'',qq{DROP SCHEMA "$schema" });
   $erg = "sch_del";
}

&gtext($erg,$schema);', 3001, false, true, false, '__STD_cr_del_schema', 'lang(schema_manage)', '2004-10-17 15:29:42.033104+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'DB_OWNER,Admins,detlef', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
&pr_form_start('' '');
print $qu->hidden(-name=>''actionname'', -value=>''__STD_global_SQL_do'');
print "<TABLE CELLSPACING=10 CELLPADDING=10 ALIGN=CENTER>";
print "<TR><TD>" . &gtext(''SQL_sel'') . ":</TD><TD colspan=3>" .
      $qu->radio_group(
         -name   => ''__SQL_cmd'',
         -values => [''ALTER GROUP'', ''ALTER TABLE'', ''ALTER TRIGGER'',
                     ''ANALYZE'', ''CLUSTER'', ''COMMENT'', ''CREATE DOMAIN'',
                     ''CREATE GROUP'', ''CREATE INDEX'', ''CREATE RULE'',
                     ''CREATE SEQUENCE'', ''CREATE TABLE'',
                     ''CREATE TABLE AS'', ''CREATE TRIGGER'',
                     ''CREATE VIEW'', ''DELETE'', ''DROP DOMAIN'',
                     ''DROP GROUP'', ''DROP INDEX'', ''DROP RULE'',
                     ''DROP SEQUENCE'', ''DROP TABLE'', ''DROP TRIGGER'',
                     ''DROP VIEW'', ''GRANT'', ''INSERT'',
                     ''REINDEX'', ''RESET'', ''REVOKE'', ''SELECT'',
                     ''SELECT INTO'', ''SET'',''SHOW'',
                     ''TRUNCATE'', ''UPDATE'', ''VACUUM''],
         -default=> ''SELECT'',
         -columns=> 3
      ) ."</TD></TR>\\n";
print "<TR><TD colspan=4><P><HR><P></TD></TR>\\n" .
      "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>\\n" .
      "<tr><td>&nbsp;</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''SQL_do_button'')) .
      "</td><td>" . $qu->submit(-name=>''submit'',
                                -value=>&sbutton(''SQL_help_button'')) .
      "</td><td>\\n" .
      $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
   &pr_db_stop;

', 1000, false, false, true, '__STD_global_SQL', 'lang(global_SQL)', '2004-10-19 15:01:49.923476+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'DB_OWNER,Admins,detlef', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
my $actionname  = &pr_get_parms(''actionname'');
my $subm_button = &pr_get_parms(''submit'');
$subm_button = &gbutton($subm_button) if $subm_button;
$subm_button = "" unless $subm_button;
my $not_admin = !&db_is_admin($user);
my $sql = &pr_get_parms(''__SQL_cmd'');
print "<CENTER><B>" . &gtext(''SQL_command'') .
      ": $sql</B></CENTER><BR>\\n";

if ($subm_button eq ''SQL_help_button'') {
   &dbprint(7,"action_SQL_do: actionname=|$actionname|, sql=|$sql|");
   my $helpstr = &action_get_help($actionname,$sql);
   
   print "<TABLE align=CENTER><TR><TD width=20%>&nbsp;</TD><TD>";
   print "<PRE>$helpstr</PRE></TD></TR></TABLE><BR>\\n";

}
&pr_form_start('' '');
print $qu->hidden(-name=>''actionname'',
                  -value=>''__STD_global_SQL_execute'');
print $qu->hidden(-name=>''__SQL_cmd'',
                  -value=>$sql);
print "<TABLE CELLSPACING=10 CELLPADDING=10 ALIGN=CENTER>";

if ( $sql =~ /^SELECT/ ) {
   print "<TR><TD>" . &gtext(''selectp'') . "</TD><TD colspan=3>" .
         $qu->textarea(''__selparm'',''SELECT *'',3,80) . "</TD></TR>\\n";
   print "<TR><TD>" . &gtext(''intop'') . "</TD><TD colspan=3>" .
         $qu->textfield(''__intoparm'',''INTO '',80,80) . "</TD></TR>\\n"
      if ($sql =~ /INTO/ );
   print "<TR><TD>" . &gtext(''fromp'') . "</TD><TD colspan=3>" .
         $qu->textarea(''__fromparm'',''FROM '',6,80) . "</TD></TR>\\n";
   print "<TR><TD>" . &gtext(''wherep'') . "</TD><TD colspan=3>" .
         $qu->textarea(''__condition'',''WHERE '',15,80) . "</TD></TR>\\n";
} else {
   print "<TR><TD>" . &gtext(''compl_cmd'') . "</TD><TD colspan=3>" .
         $qu->textarea(''__cmdparm'', "$sql ",30,80) . "</TD></TR>\\n";
}

print "<TR><TD colspan=4><P><HR><P></TD></TR>\\n" .
      "<tr><td>&nbsp;</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''SQL_exe_button'')) .
      "</td><td>" .
      "</td><td>\\n" .
      $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
   &pr_db_stop;
', 1001, false, false, false, '__STD_global_SQL_do', 'lang(global_SQL_do)', '2004-10-20 11:00:39.421291+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('__ALL', 'DB_OWNER,Admins,detlef', 'my $qu = &db_get_configs(''qu_cgi'');
$qu->delete_all;
$subm_button = &gbutton($subm_button) if $subm_button;
$subm_button = "" unless $subm_button;
my $not_admin = !&db_is_admin($user);
my $sql = &pr_get_parms(''__SQL_cmd'');
my $ergebnis = "";
my $cmd;

if ( $sql =~ /^SELECT/ ) {
   my $cond = &pr_get_parms(''__condition'');
   $cmd  = &pr_get_parms(''__selparm'');
   $cmd .= " " . &pr_get_parms(''__intoparm'') if ($sql =~ / INTO/);
   $cmd .= " " . &pr_get_parms(''__fromparm'');
   $cmd .=  " $cond" if ( $cond && $cond =~ /^\\s*WHERE\\s+.+/i );
} else {
   $cmd = &pr_get_parms(''__cmdparm'');
}
   &dbprint(7,"action_SQL_execute: cmd=|$cmd|");
my $sth = &db_db_get(''dbase'',$cmd);
my $rows = $sth->rows;
if ($rows > -1 ) {
   $ext_result = 0;
   print "<CENTER><B>$cmd</B></CENTER><BR>\\n";
   my @fnames;
   my $rname = $sth->{NAME};
   print "<TABLE BORDER=1 ALIGN=CENTER WIDTH=100%><TR>";
   foreach my $name (@$rname) {
      push(@fnames,$name);
      print "<TH>$name</TH>";
   }
   &dbprint_array(7,"action_SQL_execute: fnames",\\@fnames);
   print "</TR>\\n";
   while (my $rarray = &db_db_hashref($sth)) {
      print "<TR>";
      foreach my $name (@fnames) {
        my $wert = $$rarray{$name};
        print qq{<TD>$wert</TD>};
        &dbprint(7,"action_SQL_execute: name=|$name|, wert=|$wert|");
      }
      print "</TR>\\n";
   }
   print "</TABLE><BR><HR>" . &gtext(''nombrecs'') . " = $rows<BR>\\n";
} else {
   $ergebnis = $cmd;
}

&dbprint(7,"action_SQL_execute: ergebnis=|$ergebnis|, ext_result=|$ext_result|");
$ergebnis
', 1001, false, true, false, '__STD_global_SQL_execute', 'lang(global_SQL_execute)', '2004-10-21 11:18:11.31088+02');
INSERT INTO "action" (dbasename, usernames, actiontext, actionorder, report, ext_result, in_list, actionname, displayname, tmin) VALUES ('ereignisse', 'ALL', 'my $qu = &db_get_configs(''qu_cgi'');
&pr_form_start("Eingabe der Suchwerte");
$qu->delete_all();
print $qu->hidden(-name=>''actionname'',
                  -value=>''Ereignis auflisten'') . "\\n";
print "<table align=center cellspacing=10 cellpadding=10>" .
    "<tr><td>&nbsp;</td><td>Ereignisart:</td><td colspan=4>";
print &relationPopup(''multiplepopup'',''erg_art_nam'',
      ''ereignisart'',''erg_art_nam'');
print "</td></tr>\\n" .
    "<tr><td>&nbsp;</td><td>Teilnehmer:</td><td colspan=4>";
print &relationPopup(''multiplepopup'',''tn_nam'',
      ''teilnehmer'',''tn_nam'');
print "</td></tr>\\n" .
    "<tr><td>Suchwert:</td>\\n<td colspan=5>" .
      "<input type=text size=60 name=__erg_such></td></tr>\\n" .
    "<tr><td>Datumsbereich: </td><td>Von:</td>\\n" .
      "<td><input type=text name=__anf_dat size=10 maxlength=10" .
      "</td>\\n<td align=right>Bis:</td>\\n" .
      "<td><input type=text name=__end_dat size=10 maxlength=10" .
      "</td></tr>\\n" .
    "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>\\n" .
    "<tr><td>&nbsp;</td><td>";
print $qu->submit(-name=>''submit'', -value=>&sbutton(''OK'')) .
      "</td><td>&nbsp;\\n</td><td>\\n";
print $qu->reset(&sbutton(''reset'')) . "</td></tr></table>\\n";
&pr_db_stop;
', 1, false, false, true, 'Ereignis suchen', NULL, '2006-03-07 08:37:22.656844+01');


--
-- Data for Name: basedesign; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('gaeste', 'essen', NULL, 'maintables', 1, NULL, NULL, '2003-07-30 17:58:20.707536+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('gaeste', 'essen_art', NULL, 'valueranges', 1, NULL, NULL, '2003-07-30 17:58:37.607636+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('gaeste', 'namen', NULL, 'valueranges', 2, NULL, NULL, '2003-07-30 17:58:46.971566+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('gaeste', 'hauptgerichte', NULL, 'valueranges', 4, NULL, NULL, '2003-07-30 17:58:55.418657+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('gaeste', 'nachspeisen', NULL, 'valueranges', 5, NULL, NULL, '2003-07-30 17:59:03.064533+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('disketten', 'inhalt', NULL, 'maintables', 1, NULL, NULL, '2003-07-30 17:59:25.7061+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('disketten', 'medien', NULL, 'valueranges', 1, NULL, NULL, '2003-07-30 18:00:40.616631+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dokumentation', 'inhalt', NULL, 'maintables', 1, NULL, NULL, '2003-07-30 18:00:49.807678+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dokumentation', 'standort', NULL, 'valueranges', 1, NULL, NULL, '2003-07-30 18:01:06.507449+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('bibliothek', 'systemstelle', NULL, 'detailtables', 3, NULL, NULL, '2003-07-30 18:01:17.624621+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('bibliothek', 'sw_syst', NULL, 'maintables', 1, NULL, NULL, '2003-07-30 18:01:39.146113+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test_db', 'parts', NULL, 'maintables', 1, NULL, NULL, '2003-07-30 18:03:12.651471+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test_db', 'order_position', NULL, 'detailtables', 1, NULL, NULL, '2003-07-30 18:03:20.418185+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test_db', 'ordering', NULL, 'maintables', 2, NULL, NULL, '2003-07-30 18:03:29.556696+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test_db', 'suppliers', NULL, 'valueranges', 2, NULL, NULL, '2003-07-30 18:03:47.785086+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test_db', 'customer', NULL, 'valueranges', 1, NULL, NULL, '2003-07-30 18:04:09.113551+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('bibliothek', 'schlagwort', NULL, 'detailtables', 2, NULL, NULL, '2003-09-10 16:35:47.013667+02');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'relation', 'lang(r_relation)', 'detailtables', 1, NULL, NULL, '2004-03-09 10:03:22.343016+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'virtual', 'lang(r_virtual)', 'detailtables', 2, NULL, NULL, '2004-03-09 10:03:41.44387+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'dbengine_user', 'lang(r_dbengine_user)', 'detailtables', 3, NULL, NULL, '2004-03-09 10:04:09.576764+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'equation', 'lang(r_equation)', 'detailtables', 4, NULL, NULL, '2004-03-09 10:04:29.917151+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'basedesign', 'lang(r_basedesign)', 'maintables', 1, NULL, NULL, '2004-03-09 10:04:53.503278+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'designinfo', 'lang(r_designinfo)', 'maintables', 2, NULL, NULL, '2004-03-09 10:05:20.44502+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'tabledesign', 'lang(r_tabledesign)', 'maintables', 3, NULL, NULL, '2004-03-09 10:05:39.888488+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'action', 'lang(r_action)', 'maintables', 4, NULL, NULL, '2004-03-09 10:06:12.069947+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'databaseconfigs', 'lang(r_databaseconfigs)', 'valueranges', 1, NULL, NULL, '2004-03-09 10:06:53.031435+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'valuelist', 'lang(r_valuelist)', 'valueranges', 2, NULL, NULL, '2004-03-09 10:07:15.264156+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'configs', 'lang(r_configs)', 'valueranges', 3, NULL, NULL, '2004-03-09 10:07:33.943698+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'langtexts', 'lang(r_langtexts)', 'valueranges', 4, NULL, NULL, '2004-03-09 10:08:01.872563+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('ereignisse', 'teil_ereignis', 'Teilereignis', 'detailtables', 1, NULL, NULL, '2004-03-12 13:45:51.525259+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('ereignisse', 'ereignis', 'Ereignis', 'maintables', 1, NULL, NULL, '2004-03-12 13:46:08.60847+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('ereignisse', 'teilnehmer', 'Teilnehmer', 'valueranges', 2, 'detlef', 'Festlegung der Hauptteilnehmer von Ereignissen', '2004-03-15 17:20:47.714441+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('ereignisse', 'ereignisart', 'Art des Ereignisses', 'valueranges', 1, 'detlef', 'Festlegung der Ereignisklassen', '2004-03-15 17:25:46.04601+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_test2_db', 'alt.erst', 'Altes Erst', 'maintables', 1, 'detlef', 'Datei aus Schema ''alt''', '2005-03-01 17:00:59.270322+01');
INSERT INTO basedesign (dbasename, tablename, displayname, tableart, tableorder, username, description, tmin) VALUES ('dbengine_info_db', 'helpfile', 'lang(helpfile)', 'valueranges', 5, NULL, 'Table for helptexts for actions.', '2005-03-03 16:19:01.84945+01');


--
-- Data for Name: configs; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('allowed_dbs', '()', 'names of only allowed databases to choose for using with dbengine', '2003-08-02 15:30:25.242626+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('keypart', 'Pampelmuse', 'part of the serverspecific key for encryption', '2003-08-02 15:32:10.423949+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('bgmcol', '#C4DDFF', 'background color for our generated pages', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('bgcol', '#FFFFFF', 'background color for our generated pages', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('currency', 'EUR', 'Monetory-Symbol for currencies possible are: EUR, USD, GBP, JPY for', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('upfirst', '1', 'a true value means first character of word-parts in uppercase mode', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('reltupleanz', '25', 'More than these tuples for a relationPopup gives a field of reltuplelines', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('reltuplelines', '2', 'Lines of a great Selectfield', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('mreltuplelines', '4', 'Lines of a multipleselectfield', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('maxrecno', '20', 'Maximum number of records shown in a table-listing', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('undefbool', 'f', 'if boolean value from reading the table undefined, set boolean to false(f) or undef(u)', NULL);
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('exclude_dbs', '"template0", "template1"', 'names of databases not allowed to choose for using with dbengine separated by commas', '2003-08-02 18:47:24.691376+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('shortenings', '"pc","hw","sw","atm","IGM"', 'list of shorts to give all characters in uppercase separated by comma', '2003-08-02 18:47:58.874563+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('maxinpwidth', '75', 'Maximum chars in an Inputfield', '2003-09-29 09:48:29.889395+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('templ', '/usr/local/dbengine/src/templates', 'Directory for predefined formulas for tablemasks', '2003-11-08 17:07:34.945151+01');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('single_sentence', 'true', 'If Tablelisting for ntuples==1 should be done: set true.
If for ntuples==1 a designed form should be displayd set false.', '2004-02-19 16:03:21.777954+01');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('debug', '7', 'Debuglevel for all Databases', '2004-03-25 10:39:23.084929+01');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('admins', 'postgres', 'List of usernames of people working as dbengine-admins separated by commas', '2003-08-02 18:46:55.985182+02');
INSERT INTO configs ("index", "values", "comment", tmin) VALUES ('std_actions', 'Admins:ALL;DB_OWNER:__STD_global_SQL.*,__STD_.*user.*,__STD_.*sch.*', 'Definition of global actions for specific user. This global action defines for every database some standard actions for every user, who is a member of the Admins-group or the owner of the actual database. The action gives the user the possibility to define SQL-Statements which are allowed in the PostgreSQL - DBMS.', '2004-10-21 12:13:50.390449+02');


--
-- Data for Name: databaseconfigs; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_info_db', 'single_sentence', 'false', '2004-02-19 17:59:08.421037+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_test_db', 'single_sentence', 'false', '2004-02-19 17:59:44.186565+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'single_sentence', 'true', '2004-02-19 18:00:23.907774+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_test2_db', 'comment', 'Test Datenbank zu Behandlung von Schemata', '2004-03-23 14:53:39.840346+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'start_mode', 'plain', '2004-03-08 09:31:18.372692+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'start_fname', 'table', '2004-03-08 09:31:46.843249+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'start_fvalue', 'ereignis', '2004-03-08 09:32:21.63599+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'std_actions', 'detlef:__STD_global_SQL', '2004-03-18 14:42:19.48436+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_test2_db', 'std_actions', 'detlef:__STD_global_SQL,__STD_global_SQL_do,__STD_global_SQL_execute', '2004-10-18 17:34:13.736239+02');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('ereignisse', 'debug', '0', '2006-03-06 16:09:27.271834+01');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_test_db', 'search_pathes', 'Admins:ALL;ALL:public', '2004-07-01 12:39:46.060559+02');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('dbengine_test2_db', 'search_pathes', 'Admins:ALL;ALL:public;greta:neu;detlef:alt', '2004-07-01 12:41:22.170489+02');
INSERT INTO databaseconfigs (dbasename, configname, configvalue, tmin) VALUES ('disketten', 'debug', '0', '2005-10-11 16:36:21.412832+02');


--
-- Data for Name: dbengine_user; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('ALL', 'dbengine_test_db', '2003-07-07 16:03:17.923525+02');
INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('detlef, greta', 'gaeste', '2003-07-08 09:27:35.452514+02');
INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('detlef', 'disketten', '2003-07-08 09:28:39.326851+02');
INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('detlef', 'dokumentation', '2003-07-08 09:29:40.71965+02');
INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('Admins', 'dbengine_info_db', '2003-07-07 16:02:29.902989+02');
INSERT INTO dbengine_user (username, dbasename, tmin) VALUES ('detlef,greta,wwwrun', 'ereignisse', '2004-03-31 16:41:03.677218+02');


--
-- Data for Name: designinfo; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'datum', NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, 'gaeste', 1, 1, '2003-05-29 12:39:32.660029+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'anzahl', NULL, NULL, NULL, NULL, NULL, 2, 0, NULL, NULL, 'disketten', 1, 1, '2003-05-29 13:09:49.363343+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'box', NULL, NULL, NULL, NULL, NULL, 4, 0, NULL, NULL, 'disketten', 1, 1, '2003-05-29 13:10:04.388323+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'ordner', NULL, NULL, NULL, NULL, NULL, 2, 0, NULL, NULL, 'dokumentation', 1, 1, '2003-05-29 13:10:36.021691+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'hauptgericht', 'multiplepopup', 'hauptgerichte', 'hauptgericht', NULL, NULL, 4, 1, NULL, NULL, 'gaeste', 1, 2, '2003-07-14 15:23:17.96468+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'nachspeise', 'multiplepopup', 'nachspeisen', 'nachspeise', NULL, NULL, 5, 1, NULL, NULL, 'gaeste', 1, 2, '2003-07-14 15:23:46.588546+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'vorspeise', 'multiplepopup', 'vorspeisen', 'vorspeise', NULL, NULL, 3, 1, NULL, NULL, 'gaeste', 1, 2, '2003-07-14 15:24:13.56457+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'suppl_no', 'relationpopup', 'suppliers', 'suppl_no', 'suppl_name', 'Supplier', 2, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 11:04:36.342395+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'description', NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 11:07:44.684843+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ordering', 'ord_no', 'SERIAL', NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 11:18:18.739364+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'part_no', NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 12:27:25.090175+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'price', NULL, NULL, NULL, NULL, NULL, 3, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 12:30:18.679393+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'category', NULL, NULL, NULL, NULL, NULL, 4, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 12:30:48.39884+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('parts', 'contained_in', NULL, NULL, NULL, NULL, NULL, 4, 2, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-15 12:31:21.2045+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'gaeste_namen', 'multiplepopup', 'namen', 'name', NULL, NULL, 2, 1, NULL, NULL, 'gaeste', 1, 2, '2003-07-17 15:44:20.80816+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('essen', 'art', 'relationpopup', 'essen_art', 'art', 'art', NULL, 1, 1, NULL, NULL, 'gaeste', 1, 1, '2003-07-17 16:06:43.877277+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'ort', 'relationpopup', 'standort', 'ort', NULL, NULL, 3, NULL, NULL, NULL, 'dokumentation', 1, 1, '2003-07-17 18:02:13.988721+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'typ', 'relationpopup', 'medien', 'name', NULL, NULL, 3, NULL, NULL, NULL, 'disketten', 1, 1, '2003-07-17 18:02:59.83241+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('order_position', 'ord_pos', 'SERIAL', NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 12:43:48.879075+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ordering', 'cust_no', 'relationpopup', 'customer', 'cust_no', 'cust_name', 'Customer', 3, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 12:47:22.494874+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ordering', 'termin', NULL, NULL, NULL, NULL, NULL, 4, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 12:47:44.543743+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ordering', 'titel', NULL, NULL, NULL, NULL, NULL, 2, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 12:48:31.792584+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('order_position', 'account', NULL, NULL, NULL, NULL, NULL, 3, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 13:57:55.679673+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('order_position', 'ord_no', 'relationpopup', 'ordering', 'ord_no', 'titel', 'Order', 2, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 14:01:37.001922+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('order_position', 'part_no', 'relationpopup', 'parts', 'part_no', 'description', 'Part', 2, 2, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-19 14:03:43.615351+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ordering', 'comment', 'textarea', '3', '50', NULL, NULL, 5, 1, NULL, NULL, 'dbengine_test_db', 1, 1, '2003-07-31 13:37:45.436268+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('order_position', 'price', 'COMPUTATION', NULL, NULL, NULL, NULL, 3, 2, NULL, 'my $part;
my $cmdev = "SELECT $$rvalues{''account''} * " .
            "price as price " .
            "from parts where " .    
            "part_no = ''$$rvalues{''part_no''}''";
my $erg = &db_db_get(''dbase'',$cmdev);
my $rpart = &db_db_hashref($erg);
$part = $$rpart{''price''};
$erg->finish;
$_ = $part;', 'dbengine_test_db', 1, 1, '2003-07-19 17:13:56.063448+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'dokument', 'textarea', '5', '60', NULL, NULL, 1, NULL, NULL, NULL, 'dokumentation', 1, 1, '2003-07-31 13:36:40.986476+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('inhalt', 'pakete', 'textarea', '2', '60', NULL, NULL, 1, NULL, NULL, NULL, 'disketten', 1, 1, '2003-07-31 13:37:01.037562+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'xevaluation', 'textarea', '10', '45', 'pre', NULL, 6, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2003-07-31 13:34:57.350872+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('reports', 'reportorder', NULL, NULL, NULL, NULL, NULL, 2, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-07-01 17:26:22.508054+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('reports', 'security', NULL, NULL, NULL, NULL, NULL, 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-07-01 17:26:48.504807+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'level', 'popup', NULL, NULL, NULL, NULL, 2, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-07-01 17:45:16.212302+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('langtexts', 'button', NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-07-08 10:24:59.143319+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'xtableitem', 'textarea', '10', '45', 'pre', NULL, 6, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-07-31 13:39:12.636675+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'actionorder', 'text', '4', '7', NULL, 'lang(actionorder)', 2, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-03-08 13:06:07.032772+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'xxquerystring', 'textarea', '10', '45', 'pre', NULL, 5, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-07-31 13:35:24.067194+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'xequation', 'textarea', '25', '100', 'pre', NULL, 4, 1, NULL, NULL, 'dbengine_info_db', 1, 5, '2003-07-31 13:34:00.755282+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'displaycolumn', 'text', '4', '7', NULL, 'lang(displaycolumn)', 5, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-10 17:43:56.782589+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'displayinfo', 'popup', NULL, NULL, NULL, 'lang(displayinfo)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2003-09-10 17:44:18.920397+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'displayorder', 'text', '4', '7', NULL, 'lang(displayorder)', 5, 1, NULL, 'my ($wert) = @_;
if ($wert > 999) {
   $_ = "A maximum value of ''999'' allowed";
   $wert = 0;
}
$wert;', 'dbengine_info_db', 1, 1, '2003-09-10 17:44:36.548487+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'childorder', 'text', '4', '7', NULL, 'lang(childorder)', 4, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-10 18:07:47.386025+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('langtexts', 'language', 'text', '4', '6', NULL, 'lang(language)', 1, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-08 08:45:07.12332+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_t_erg', NULL, NULL, NULL, NULL, 'Teilereignisse vorhanden', 4, 3, '$_ = ''u''', 'my $eing = shift @_;
$eing = ''f'' if ($eing eq ''u'');
$_ = $eing', 'ereignisse', 1, 1, '2005-03-27 11:19:37.98436+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('valuelist', 'orderno', NULL, NULL, NULL, NULL, 'lang(orderno)', 2, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 08:59:32.588265+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'rowspan', 'text', '4', '7', NULL, 'lang(rowspan)', 5, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 10:00:58.773497+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'colspan', 'text', '4', '7', NULL, 'lang(colspan)', 5, 4, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 10:03:46.300707+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'tableorder', 'text', '4', '7', NULL, 'lang(orderno)', 3, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 10:12:22.362604+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'modifyablelist', NULL, NULL, NULL, NULL, 'lang(modifyablelist)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-09-11 12:05:37.971181+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'actiontext', 'textarea', '20', '72', 'pre', 'lang(actiontext)', 5, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2005-03-14 13:16:51.914985+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('configs', 'comment', 'textarea', '5', '80', 'pre', 'lang(comment)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2005-03-14 13:17:38.658901+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'xdefault', 'textarea', '10', '45', 'pre', NULL, 6, 3, NULL, NULL, 'dbengine_info_db', 1, 2, '2003-12-10 17:57:00.729914+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'childcheck', NULL, NULL, NULL, NULL, 'lang(childcheck)', 4, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 13:19:15.826548+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'fieldtype', 'popup', NULL, NULL, NULL, 'lang(fieldtype)', 2, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 13:24:57.816382+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('equation', 'content', 'textarea', '40', '100', 'pre', 'lang(content)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2003-12-10 18:03:48.412371+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'tablefields', 'textarea', '5', '45', 'pre', 'lang(fieldlist)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-09-11 12:06:31.694385+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'xtableend', 'textarea', '10', '45', 'pre', NULL, 6, 4, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-12-10 18:00:38.484287+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('langtexts', 'translate_text', 'text', '80', '256', NULL, 'lang(translation)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-09-11 13:34:49.43512+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('configs', 'values', 'text', '80', '256', NULL, 'lang(value)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-09-11 13:39:31.1495+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'xtablestart', 'textarea', '10', '45', 'pre', NULL, 5, 4, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-12-10 18:00:57.361532+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'needsvirtuals', NULL, NULL, NULL, NULL, 'lang(needsvirtuals)', 3, 4, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-12-10 18:00:04.89158+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'tn_nam', 'multiplepopup', 'teilnehmer', 'tn_nam', NULL, 'Teilnehmer', 2, 1, NULL, NULL, 'ereignisse', 1, 2, '2003-12-10 12:11:08.032688+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_art_nam', 'multiplepopup', 'ereignisart', 'erg_art_nam', NULL, 'Ereignisart', 2, 3, NULL, NULL, 'ereignisse', 1, 1, '2003-12-10 12:12:12.385747+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_no', 'SERIAL', NULL, NULL, NULL, 'Ereignis_Nr.', 1, 3, NULL, NULL, 'ereignisse', 1, 1, '2003-12-10 12:12:36.00819+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 't_ereignis', 'textarea', '20', '60', NULL, 'Beschreibung', 5, 1, NULL, NULL, 'ereignisse', 1, 3, '2003-12-12 11:43:10.884112+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'ext_result', NULL, NULL, NULL, NULL, 'lang(ext_result)', 4, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-03-08 13:00:07.592224+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 't_erg_no', 'SERIAL', NULL, NULL, NULL, 'Teilereignis Nr.', 1, 3, NULL, NULL, 'ereignisse', 1, 1, '2003-12-11 11:46:24.176671+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 'tn_nam', 'multiplepopup', 'teilnehmer', 'tn_nam', NULL, 'Teilnehmer', 3, 1, NULL, NULL, 'ereignisse', 1, 2, '2003-12-11 11:50:46.502186+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 'erg_art_nam', 'multiplepopup', 'ereignisart', 'erg_art_nam', NULL, 'Teilereignisart', 3, 3, NULL, NULL, 'ereignisse', 1, 1, '2003-12-11 20:38:11.744373+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 't_erg_titel', NULL, NULL, NULL, NULL, 'Teilereignis', 1, 1, NULL, NULL, 'ereignisse', 1, 2, '2003-12-11 20:39:24.278077+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_titel', NULL, NULL, NULL, NULL, 'Ereignis', 1, 1, NULL, NULL, 'ereignisse', 1, 2, '2003-12-11 20:40:45.640615+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_anf', NULL, NULL, NULL, NULL, 'Anfangsdatum', 4, 1, NULL, NULL, 'ereignisse', 1, 1, '2003-12-07 13:00:10.365064+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 'erg_no', 'relationpopup', 'ereignis', 'erg_no erg_t_erg ''t''', 'erg_titel', 'Nr. (Ereignis)', 4, 3, NULL, NULL, 'ereignisse', 1, 1, '2003-12-11 20:42:59.43401+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'erg_end', NULL, NULL, NULL, NULL, 'Endedatum (optional)', 4, 2, NULL, 'my $eing = shift @_;
$eing = $$rvalues{''erg_anf''} unless ($eing);
$_ = $eing', 'ereignisse', 1, 1, '2003-12-12 12:10:54.809839+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 't_erg_end', NULL, NULL, NULL, NULL, 'Endedatum (optional)', 4, 2, NULL, 'my $eing = shift @_;
$eing = $$rvalues{''t_erg_anf''} unless ($eing);
$_ = $eing', 'ereignisse', 1, 1, '2003-12-12 12:11:15.24279+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teil_ereignis', 't_erg_anf', NULL, NULL, NULL, NULL, 'Anfangsdatum', 4, 1, NULL, NULL, 'ereignisse', 1, 1, '2003-12-07 13:18:38.176076+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'report', NULL, NULL, NULL, NULL, 'lang(report)', 1, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-02-13 12:11:17.632767+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'tableart', 'popup', 'modenames', 'modname', NULL, 'lang(tableart)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-02-19 14:29:59.594269+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'in_list', NULL, NULL, NULL, NULL, 'lang(in_list)', 3, 3, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-03-08 13:04:33.716563+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('databaseconfigs', 'dbasename', 'text', '20', NULL, NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-02-19 17:48:16.763078+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('databaseconfigs', 'configname', 'text', '20', NULL, NULL, 'lang(configname)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-02-19 17:49:13.939819+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:28:18.221071+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('helpfile', 'helptext', 'textarea', '30', '80', 'pre', 'lang(helptext)', 5, 1, NULL, NULL, 'dbengine_info_db', 1, 4, '2004-10-20 11:46:42.57415+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('teilnehmer', 'tn_nam', 'text', '32', NULL, NULL, 'Teilnehmer', 1, 1, NULL, NULL, 'ereignisse', 1, 1, '2004-03-15 17:28:02.499269+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('databaseconfigs', 'configvalue', 'text', '80', '256', NULL, 'lang(configvalue)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-10-19 07:52:31.215287+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'tablename', 'text', '32', '128', NULL, 'lang(tablename)', 1, 3, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:28:57.192991+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'fieldname', 'text', '32', '128', NULL, 'lang(fieldname)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:29:58.875505+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'displaystring', 'text', '32', '128', NULL, 'lang(displaystring)', 2, 3, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:32:01.708745+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'dispdfield', 'text', '32', '128', NULL, 'lang(dispdfield)', 4, 3, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:37:08.403714+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'disptable', 'text', '32', '128', NULL, 'lang(disptable)', 3, 3, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:37:48.968991+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('designinfo', 'dispvfield', 'text', '32', '128', NULL, 'lang(dispvfield)', 4, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:38:45.153841+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:40:02.424723+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'fieldname', 'text', '32', '128', NULL, 'lang(fieldname)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:40:36.707675+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('virtual', 'tablename', 'text', '32', '128', NULL, 'lang(tablename)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 3, '2005-03-07 10:40:58.903914+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('dbengine_user', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:46:20.727386+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('equation', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:46:40.289699+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('reports', 'reportname', 'text', '32', '128', NULL, NULL, 2, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:46:58.168813+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('configs', 'index', 'text', '32', '128', NULL, NULL, 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:47:39.619626+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('helpfile', 'dbasename', 'text', '32', NULL, NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-10-20 11:25:12.959757+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('helpfile', 'helpname', 'text', '32', NULL, NULL, 'lang(helpname)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-10-20 11:29:35.764878+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:48:00.726058+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('reports', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:48:21.678241+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 3, '2005-03-07 10:48:40.744545+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('helpfile', 'languages', 'text', '8', NULL, NULL, 'lang(language)', 3, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2004-10-20 11:43:57.568655+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('valuelist', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:49:54.680276+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('reports', 'tablename', 'text', '32', '128', NULL, 'lang(tablename)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:50:17.986714+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('valuelist', 'name', 'text', '32', '128', NULL, 'lang(fieldname)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 10:50:40.419258+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('valuelist', 'display', 'text', '32', NULL, NULL, 'lang(display)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 08:56:18.228437+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('valuelist', 'content', 'text', '32', NULL, NULL, 'lang(content)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 08:56:33.505409+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'child', 'text', '32', NULL, NULL, 'lang(child)', 2, 2, NULL, NULL, 'dbengine_info_db', 2, 1, '2003-09-11 12:33:24.6301+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'childfield', 'text', '32', NULL, NULL, 'lang(childfield)', 3, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 12:34:54.01571+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'parent', 'text', '32', NULL, NULL, 'lang(parent)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 12:36:58.199219+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('relation', 'parentfield', 'text', '32', NULL, NULL, 'lang(parentfield)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 12:37:58.724099+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('langtexts', 'indextext', 'text', '32', NULL, NULL, 'Index', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2003-09-11 13:34:26.32872+02');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('tabledesign', 'tablename', 'text', '32', NULL, NULL, 'lang(tablename)', 1, 4, NULL, NULL, 'dbengine_info_db', 1, 3, '2003-12-10 17:59:42.314925+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'description', 'text', '75', '256', NULL, 'lang(description)', 6, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:54:48.692455+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'username', 'text', '75', '256', NULL, 'lang(userlist)', 7, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 10:55:14.502458+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'actionname', 'text', '32', '128', NULL, 'lang(actionname)', 2, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 11:05:15.116944+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 11:05:33.56166+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'displayname', 'text', '32', '128', NULL, 'lang(displaystring)', 3, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 11:05:47.92691+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('action', 'usernames', 'text', '32', '128', NULL, 'lang(userlist)', 4, 1, NULL, NULL, 'dbengine_info_db', 1, 2, '2005-03-07 11:06:00.675137+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'dbasename', 'text', '32', '128', NULL, 'lang(dbasename)', 1, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:06:13.464076+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'displayname', 'text', '32', '128', NULL, 'lang(displaystring)', 5, 1, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:06:26.238031+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('basedesign', 'tablename', 'text', '32', '128', NULL, 'lang(tablename)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:06:38.514273+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('dbengine_user', 'username', 'text', '32', '128', NULL, 'lang(userlist)', 2, 1, '$_ = "Admins";', NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:06:52.875482+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('equation', 'eqname', 'text', '32', '128', NULL, 'lang(name)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:07:04.994234+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('helpfile', 'actionname', 'text', '32', '128', NULL, 'lang(actionname)', 1, 2, NULL, NULL, 'dbengine_info_db', 1, 1, '2005-03-07 11:07:18.915741+01');
INSERT INTO designinfo (tablename, fieldname, displayinfo, disptable, dispvfield, dispdfield, displaystring, displayorder, displaycolumn, xdefault, xevaluation, dbasename, rowspan, colspan, tmin) VALUES ('ereignis', 'ereignis', 'textarea', '20', '60', NULL, 'Beschreibung', 5, 1, NULL, NULL, 'ereignisse', 1, 3, '2005-03-13 16:29:49.263354+01');


--
-- Data for Name: equation; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO equation (eqname, content, dbasename, tmin) VALUES ('parts_containing', 'my ($part_no, $level) = @_;
my $ergline = "";

my $cmd;
if($level == 0 ) {
   $cmd = "SELECT * FROM parts where contained_in is NULL ORDER BY part_no";
} else {
   $cmd = "SELECT * FROM parts where contained_in = ''$part_no'' ORDER BY part_no";
}

my %parts_rows;

my $stdh = &db_db_get(''dbase'',$cmd);
while( my $rarray = &db_db_hashref($stdh) ) {
   my $npart_no = $$rarray{''part_no''};
   foreach my $key (keys %$rarray) {
      $parts_rows{$npart_no}{$key} = $$rarray{$key};
   }
}

$stdh->finish;

foreach my $npart_no (keys %parts_rows) {
   my $rpart_row = $parts_rows{$npart_no};
   my $description = $$rpart_row{''description''};
   my $suppl_no = $$rpart_row{''suppl_no''};
   my $price = $$rpart_row{''price''};
   my $category = $$rpart_row{''category''};
   my $contained_in = $$rpart_row{''contained_in''};

   my $form = "\\%3d: \\%" . ((3*$level)+1) . "s\\%4d  \\%s \\%4d \\%6.2f \\%3s \\%4d\\n";
   $ergline .= sprintf $form, $level, " ",
                      $npart_no, $description, $suppl_no, $price, $category, $contained_in;
   $ergline .= &db_callSub(''parts_containing'',$npart_no,$level + 1);
}

return($ergline);', 'dbengine_test_db', '2003-07-28 18:55:07.375317+02');


--
-- Data for Name: helpfile; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ALTER DATABASE', 'ALL', 'ALTER DATABASE name SET variable { TO | = } { value | DEFAULT }
ALTER DATABASE name RESET variable
', '2004-10-20 17:04:29.031242+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ALTER GROUP', 'ALL', 'ALTER GROUP name ADD USER username [, ... ]
ALTER GROUP name DROP USER username [, ... ]
', '2004-10-20 17:04:29.131926+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ALTER TABLE', 'ALL', 'ALTER TABLE [ ONLY ] table [ * ]
    ADD [ COLUMN ] column type [ column_constraint [ ... ] ]
ALTER TABLE [ ONLY ] table [ * ] DROP [ COLUMN ] column [ RESTRICT | CASCADE ]
ALTER TABLE [ ONLY ] table [ * ]
    ALTER [ COLUMN ] column { SET DEFAULT value | DROP DEFAULT }
ALTER TABLE [ ONLY ] table [ * ]
    ALTER [ COLUMN ] column { SET | DROP } NOT NULL
ALTER TABLE [ ONLY ] table [ * ] ALTER [ COLUMN ] column SET STATISTICS integer
ALTER TABLE [ ONLY ] table [ * ]
    ALTER [ COLUMN ] column SET STORAGE { PLAIN | EXTERNAL | EXTENDED | MAIN }
ALTER TABLE [ ONLY ] table [ * ]RENAME [ COLUMN ] column TO new_column
ALTER TABLE table  RENAME TO new_table
ALTER TABLE [ ONLY ] table [ * ] ADD table_constraint
ALTER TABLE [ ONLY ] table [ * ]
    DROP CONSTRAINT constraint_name [ RESTRICT | CASCADE ]
ALTER TABLE table OWNER TO new_owner
', '2004-10-20 17:04:29.175124+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ALTER TRIGGER', 'ALL', 'ALTER TRIGGER trigger ON table
    RENAME TO newname
', '2004-10-20 17:04:29.217691+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ALTER USER', 'ALL', 'ALTER USER username [ [ WITH ] option [ ... ] ]

where option can be:
      [ ENCRYPTED | UNENCRYPTED ] PASSWORD ''password'' 
    | CREATEDB | NOCREATEDB
    | CREATEUSER | NOCREATEUSER 
    | VALID UNTIL ''abstime''

ALTER USER username SET variable { TO | = } { value | DEFAULT }
ALTER USER username RESET variable
', '2004-10-20 17:04:29.261169+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'ANALYZE', 'ALL', 'ANALYZE [ VERBOSE ] [ table [ (column [, ...] ) ] ]
', '2004-10-20 17:04:29.304125+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'COMMENT', 'ALL', 'COMMENT ON
[
  TABLE object_name | COLUMN table_name.column_name |
  AGGREGATE agg_name (agg_type) | CONSTRAINT constraint_name ON table_name |
  DATABASE object_name | DOMAIN object_name |
  FUNCTION func_name (arg1_type, arg2_type, ...) |
  INDEX object_name | OPERATOR op (leftoperand_type, rightoperand_type) |
  RULE rule_name ON table_name | SCHEMA object_name | SEQUENCE object_name |
  TRIGGER trigger_name ON table_name | TYPE object_name | VIEW object_name
] IS ''text''
', '2004-10-20 17:04:29.35644+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE DOMAIN', 'ALL', 'CREATE DOMAIN domainname [AS] data_type
    [ DEFAULT default_expr ]
    [ constraint [ ... ] ]

where constraint is:
[ CONSTRAINT constraint_name ]
{ NOT NULL | NULL }
', '2004-10-20 17:04:29.381032+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE GROUP', 'ALL', 'CREATE GROUP name [ [ WITH ] option [ ... ] ]

where option can be:
     SYSID gid  | USER  username [, ...]
', '2004-10-20 17:04:29.453181+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE INDEX', 'ALL', 'CREATE [ UNIQUE ] INDEX index_name ON table
    [ USING acc_method ] ( column [ ops_name ] [, ...] )
    [ WHERE predicate ]
CREATE [ UNIQUE ] INDEX index_name ON table
    [ USING acc_method ] ( func_name( column [, ... ]) [ ops_name ] )
    [ WHERE predicate ]
', '2004-10-20 17:04:29.481765+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE RULE', 'ALL', 'CREATE [ OR REPLACE ] RULE name AS ON event
    TO table [ WHERE condition ]
    DO [ INSTEAD ] action

where action can be:
NOTHING
| query
| ( query ; query ... )

', '2004-10-20 17:04:29.537485+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE SEQUENCE', 'ALL', 'CREATE [ TEMPORARY | TEMP ] SEQUENCE seqname [ INCREMENT increment ]
    [ MINVALUE minvalue ] [ MAXVALUE maxvalue ]
    [ START start ] [ CACHE cache ] [ CYCLE ]
', '2004-10-20 17:04:29.567193+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE TABLE', 'ALL', 'CREATE [ [ LOCAL ] { TEMPORARY | TEMP } ] TABLE table_name (
    { column_name data_type [ DEFAULT default_expr ] [ column_constraint [, ... ] ]
    | table_constraint }  [, ... ]
)
[ INHERITS ( parent_table [, ... ] ) ]
[ WITH OIDS | WITHOUT OIDS ]

where column_constraint is:
[ CONSTRAINT constraint_name ]
{ NOT NULL | NULL | UNIQUE | PRIMARY KEY |
  CHECK (expression) |
  REFERENCES reftable [ ( refcolumn ) ] [ MATCH FULL | MATCH PARTIAL ]
    [ ON DELETE action ] [ ON UPDATE action ] }
[ DEFERRABLE | NOT DEFERRABLE ] [ INITIALLY DEFERRED | INITIALLY IMMEDIATE ]

and table_constraint is:

[ CONSTRAINT constraint_name ]
{ UNIQUE ( column_name [, ... ] ) |
  PRIMARY KEY ( column_name [, ... ] ) |
  CHECK ( expression ) |
  FOREIGN KEY ( column_name [, ... ] ) REFERENCES reftable [ ( refcolumn [, ... ] ) ]
    [ MATCH FULL | MATCH PARTIAL ] [ ON DELETE action ] [ ON UPDATE action ] }
[ DEFERRABLE | NOT DEFERRABLE ] [ INITIALLY DEFERRED | INITIALLY IMMEDIATE ]
', '2004-10-20 17:04:29.596529+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE TABLE AS', 'ALL', 'CREATE [ [ LOCAL ] { TEMPORARY | TEMP } ] TABLE table_name [ (column_name [, ...] ) ]
    AS query
', '2004-10-20 17:04:29.624182+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE TRIGGER', 'ALL', 'CREATE TRIGGER name { BEFORE | AFTER } { event [OR ...] }
    ON table FOR EACH { ROW | STATEMENT }
    EXECUTE PROCEDURE func ( arguments )
', '2004-10-20 17:04:29.652658+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'CREATE VIEW', 'ALL', 'CREATE [ OR REPLACE ] VIEW view [ ( column name list ) ] AS SELECT query
', '2004-10-20 17:04:29.681115+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DELETE', 'ALL', 'DELETE FROM [ ONLY ] table [ WHERE condition ]
', '2004-10-20 17:04:29.709904+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP DOMAIN', 'ALL', 'DROP DOMAIN domainname [, ...]  [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.73845+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP GROUP', 'ALL', 'DROP GROUP name
', '2004-10-20 17:04:29.766907+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP INDEX', 'ALL', 'DROP INDEX index_name [, ...] [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.79541+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP RULE', 'ALL', 'DROP RULE name ON relation [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.823886+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP SEQUENCE', 'ALL', 'DROP SEQUENCE name [, ...] [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.852391+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP TABLE', 'ALL', 'DROP TABLE name [, ...] [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.88089+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP TRIGGER', 'ALL', 'DROP TRIGGER name ON table [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.909377+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'DROP VIEW', 'ALL', 'DROP VIEW name [, ...] [ CASCADE | RESTRICT ]
', '2004-10-20 17:04:29.937909+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'GRANT', 'ALL', 'GRANT { { SELECT | INSERT | UPDATE | DELETE | RULE | REFERENCES | TRIGGER }
    [,...] | ALL [ PRIVILEGES ] }
    ON [ TABLE ] tablename [, ...]
    TO { username | GROUP groupname | PUBLIC } [, ...]

GRANT { { CREATE | TEMPORARY | TEMP } [,...] | ALL [ PRIVILEGES ] }
    ON DATABASE dbname [, ...]
    TO { username | GROUP groupname | PUBLIC } [, ...]

GRANT { EXECUTE | ALL [ PRIVILEGES ] }
    ON FUNCTION funcname ([type, ...]) [, ...]
    TO { username | GROUP groupname | PUBLIC } [, ...]

GRANT { USAGE | ALL [ PRIVILEGES ] }
    ON LANGUAGE langname [, ...]
    TO { username | GROUP groupname | PUBLIC } [, ...]

GRANT { { CREATE | USAGE } [,...] | ALL [ PRIVILEGES ] }
    ON SCHEMA schemaname [, ...]
    TO { username | GROUP groupname | PUBLIC } [, ...]
', '2004-10-20 17:04:29.966664+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'INSERT', 'ALL', 'INSERT INTO table [ ( column [, ...] ) ]
    { DEFAULT VALUES | VALUES ( { expression | DEFAULT } [, ...] ) | SELECT query }
', '2004-10-20 17:04:29.994894+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'REINDEX', 'ALL', 'REINDEX { TABLE | DATABASE | INDEX } name [ FORCE ]
', '2004-10-20 17:04:30.054177+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'RESET', 'ALL', 'RESET variable
', '2004-10-20 17:04:30.097555+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'REVOKE', 'ALL', 'REVOKE { { SELECT | INSERT | UPDATE | DELETE | RULE | REFERENCES | TRIGGER }
    [,...] | ALL [ PRIVILEGES ] }
    ON [ TABLE ] tablename [, ...]
    FROM { username | GROUP groupname | PUBLIC } [, ...]

REVOKE { { CREATE | TEMPORARY | TEMP } [,...] | ALL [ PRIVILEGES ] }
    ON DATABASE dbname [, ...]
    FROM { username | GROUP groupname | PUBLIC } [, ...]

REVOKE { EXECUTE | ALL [ PRIVILEGES ] }
    ON FUNCTION funcname ([type, ...]) [, ...]
    FROM { username | GROUP groupname | PUBLIC } [, ...]

REVOKE { USAGE | ALL [ PRIVILEGES ] }
    ON LANGUAGE langname [, ...]
    FROM { username | GROUP groupname | PUBLIC } [, ...]

REVOKE { { CREATE | USAGE } [,...] | ALL [ PRIVILEGES ] }
    ON SCHEMA schemaname [, ...]
    FROM { username | GROUP groupname | PUBLIC } [, ...]
', '2004-10-20 17:04:30.12283+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'SELECT', 'ALL', 'SELECT [ ALL | DISTINCT [ ON ( expression [, ...] ) ] ]
    * | expression [ AS output_name ] [, ...]
    [ FROM from_item [, ...] ]
    [ WHERE condition ]
    [ GROUP BY expression [, ...] ]
    [ HAVING condition [, ...] ]
    [ { UNION | INTERSECT | EXCEPT } [ ALL ] select ]
    [ ORDER BY expression [ ASC | DESC | USING operator ] [, ...] ]
    [ LIMIT { count | ALL } ]
    [ OFFSET start ]
    [ FOR UPDATE [ OF tablename [, ...] ] ]

where from_item can be:
[ ONLY ] table_name [ * ] [ [ AS ] alias [ ( column_alias_list ) ] ]
|
( select ) [ AS ] alias [ ( column_alias_list ) ]
|
table_function_name ( [ argument [, ...] ] )
    [ AS ] alias [ ( column_alias_list | column_definition_list ) ]
|
table_function_name ( [ argument [, ...] ] ) AS ( column_definition_list )
|
from_item [ NATURAL ] join_type from_item
    [ ON join_condition | USING ( join_column_list ) ]
', '2004-10-20 17:04:30.151378+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'SELECT INTO', 'ALL', 'SELECT [ ALL | DISTINCT [ ON ( expression [, ...] ) ] ]
    * | expression [ AS output_name ] [, ...]
    INTO [ TEMPORARY | TEMP ] [ TABLE ] new_table
    [ FROM from_item [, ...] ]
    [ WHERE condition ]
    [ GROUP BY expression [, ...] ]
    [ HAVING condition [, ...] ]
    [ { UNION | INTERSECT | EXCEPT } [ ALL ] select ]
    [ ORDER BY expression [ ASC | DESC | USING operator ] [, ...] ]
    [ LIMIT { count | ALL } ]
    [ OFFSET start ]
    [ FOR UPDATE [ OF tablename [, ...] ] ]
', '2004-10-20 17:04:30.179807+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'SET', 'ALL', 'SET [ SESSION | LOCAL ] variable { TO | = } { value | ''value'' | DEFAULT }
SET [ SESSION | LOCAL ] TIME ZONE { timezone | LOCAL | DEFAULT }
', '2004-10-20 17:04:30.208537+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'SHOW', 'ALL', 'SHOW name
', '2004-10-20 17:04:30.237013+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'TRUNCATE', 'ALL', 'TRUNCATE [ TABLE ] name
', '2004-10-20 17:04:30.265473+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'UPDATE', 'ALL', 'UPDATE [ ONLY ] table SET col = expression [, ...]
    [ FROM fromlist ]
    [ WHERE condition ]
', '2004-10-20 17:04:30.294029+02');
INSERT INTO helpfile (dbasename, actionname, helpname, languages, helptext, tmin) VALUES ('__ALL', '__STD_global_SQL_do', 'VACUUM', 'ALL', 'VACUUM [ FULL ] [ FREEZE ] [ VERBOSE ] [ table ]
VACUUM [ FULL ] [ FREEZE ] [ VERBOSE ] ANALYZE [ table [ (column [, ...] ) ] ]

', '2004-10-20 17:04:30.322525+02');


--
-- Data for Name: langtexts; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'utitle', 'Benutzer - Angaben', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dtitle', 'Datenbank', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'ttitle', 'Tabelle', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tables', 'Tabellen', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actions', 'Aktionen', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'reports', 'Berichte', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbase', 'Auswahl der Datenbank', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbsyst', 'Datenbanksystems', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'database', 'Datenbank', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'crerror', 'crypt-Fehler', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dberror', 'Datenbankfehler', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'noconnect', 'Keine Datenbankverbindung herstellbar', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'bcmd', ' Bei dem Kommando', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'preperror', 'Fehler bei prepare-Aufruf fr Datenbank %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'getfetchr', 'Fehler bei ''fetch''-Zugriff auf Daten der Datenbank', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'specialselect', 'Extra Suchbefehl', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nrowerror', 'Falsches Kommando fr Ermittlung der Anzahl der Tupel: %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'virterror', 'Fehler im ''virtual'' Feld %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'eingerr', '<TABLE><TR><TD>Fehler bei Eingabe in Feld:</TD><TD>%s.</TD><TR><TD>Meldung:</TD><TD>%s</TD></TR><TR><TD>Eingabewert:</TD><TD>%s</TD></TR></TABLE>', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'eingmuss', 'Eingabe fehlt in Feld: %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'inperr', 'Fehler bei der Eingabe in der Maske. Entweder fehlen Eingaben oder sie sind unzulssig in der angegebenen Weise.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'childexist', 'Der alte Wert ''%s'' im Feld %s wird in der vom Feld abhngigen Tabelle %s genutzt. Bitte erst dort korrigieren.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nfields', '+++Achtung: Nicht alle Felder sind belegt!!', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'newread', 'erneut einlesen ...', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'eexpr', 'Fehler im eingebetteten Ausdruck %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'delconfirm', 'Datensatz Wirklich lschen ??', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'delrerr', 'Datensatz kann nicht gelscht werden: Entweder sind noch Datenstze in anderen Dateien vorhanden, die sich auf diesen beziehen, oder dieser Datensatz wurde nach dem letzten Ansehen noch verndert.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'reallydel', 'Wenn Sie den Datensatz wirklich entfernen wollen, dann besttigen Sie bitte hier: ', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nodelrec', 'Sie knnen sich auch die &Uuml;bersicht wieder anzeigen lassen:', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'unbekdb', 'Unbekannte Datenbank %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'cmd', 'Befehl', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'binds', 'Bindungen', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'newrec', 'Neuanlage', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'true', 'Ja', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'false', 'Nein', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'bundef', 'Undefiniert', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbsyserror', 'Keine Datenbank - Schnittstelle (Treiber) vorhanden', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'Error', 'Fehler', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'Message', 'Meldung', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'fieldname', 'Feldname', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'fieldvalue', 'Neuer Wert', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'allrecords', 'Alle Stze', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'mupdateerror', 'Fehler beim Multiple-Update', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbsuberr', 'Subroutine %s in der Tabelle ''equation'' von ''dbengine_info_db'' nicht gefunden.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbsubouterr', 'Subroutine %s in der Tabelle ''equation'' von ''dbengine_info_db'' fehlerhaft.:<BR>
 ', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actionerg', 'Ergebnis der Aktion', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'acterg', 'Die Aktion %s erfolgreich veranlasst oder durchgefhrt.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actnoerg', 'Die Aktion %s erfolglos veranlasst oder durchgefhrt.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actionforbidden', 'Die Aktion %s ist fr den Benutzer %s nicht erlaubt.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'recno', 'Satznr.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nextrecs', 'Nchste Stze', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'lastrecs', 'Letzte Stze', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'allrecs', 'Alle Stze', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'usermust', 'Angabe fr Benutzer oder Passwort fehlt', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'usererror', 'Unzulssige Zeichen im Benutzernamen %s. Zulssig nur die Zeichen ''A-z'', ''a-z'' und ''_''', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'usedbnot', 'Zugriff auf Datenbank ''%s'' fr diesen Benutzer nicht erlaubt', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'unzben', 'Benutzungsdaten nicht vorhanden', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'unznot', 'Benutzungsdaten nicht sicherbar', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sysfehl', 'Systemfehler: %s fr %s %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'function', 'Funktion', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'undef', ' nicht definiert', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'search', 'Suchen', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'update', 'ndern', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'mupdate', 'M_ndern', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'delete', 'Lschen', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'confdel', 'Wirklich Lschen', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'add', 'Anlegen', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'reset', 'Rcksetzen', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'print', 'Druckbild', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'back', 'Zurck', true, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'multpopntext', '''multiplepopup'' nur fr Felder vom Typ ''char'' oder ''text'' erlaubt und daher fr das Feld ''%s'' mit dem Typ ''%s'' verboten.', false, '2003-07-10 11:36:08.586212+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'atitle', 'Aktion oder Bericht', false, '2003-09-12 14:41:31.165652+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'multpopntext', '''multiplepopup'' only for fields of type ''char'' or ''text'' allowed. Therefore it is forbidden for field ''%s'' with type ''%s''.', false, '2003-07-10 11:38:37.051967+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'connec', 'Verknpfungen zu Feld(Tabelle)[%s]', false, '2003-07-22 10:33:24.793248+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'connec', 'Connections to Field(Table)[%s]', false, '2003-07-22 10:33:41.684851+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'reporterg', 'Ergebnis des Berichtes', false, '2003-07-28 12:16:14.558587+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'repoerg', 'Bericht erfolgreich durchgefhrt oder veranlasst', false, '2003-07-28 12:17:05.084787+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'reponoerg', 'Bericht nicht erfolgreich durchgefhrt', false, '2003-07-28 12:17:42.885891+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'Error', 'Error', false, '2003-07-30 15:26:50.646165+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'Message', 'Message', false, '2003-07-30 15:27:14.535979+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'utitle', 'User - Information', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dtitle', 'Database', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'atitle', 'Action', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'ttitle', 'Table', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbsyst', 'Choose a databasesystem', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbase', 'Choose a database', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbsyserror', 'No Databasesystem (Driver) for DBI found', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'eingmuss', 'There have to be an input in field: %s', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'inperr', 'Input-error in the mask. Some inputs are missing or not correct.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'childexist', 'The old value ''%s'' in field %s is used from the table %s. Please, correct the dependent table first.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nfields', '+++Attention: Some fields are NULL!!', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'newread', 'reload record ...', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'delconfirm', 'Really delete the record??', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'reallydel', 'In case you really want to remove this record please confirm here:', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nodelrec', 'You can also go back to the record list:', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'cmd', 'Command', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'binds', 'Bindings', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'true', 'yes', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'false', 'no', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'bundef', 'undefined', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'fieldname', 'Fieldname', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'fieldvalue', 'New Value', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'allrecords', 'All Records?', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'mupdateerror', 'Error in Multiple-Update', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbsuberr', 'Subroutine %s in table ''equation'' of ''dbengine_info_db'' not found.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbsubouterr', 'Subroutine %s in table ''equation'' of ''dbengine_info_db'' failed.:<BR>
', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actionerg', 'Action result', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'extrableitem', 'Fehler im Feld xtableitem', false, '2005-03-13 18:02:02.754499+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'acterg', 'The action %s successfully started or done.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actnoerg', 'The action %s not successfully started or done.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actionforbidden', 'The action %s is forbidden for the user %s.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'recno', 'Recordno.', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'lastrecs', 'Last Records', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nextrecs', 'Next Records', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'allrecs', 'All Records', false, NULL);
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actions', 'Actions', false, '2003-07-30 15:35:42.691767+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'crerror', 'crypt-error', false, '2003-07-30 15:36:48.906561+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'back', 'Back', true, '2003-07-30 15:45:07.392581+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dberror', 'database-error', false, '2003-07-30 15:46:22.376306+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'bcmd', ' executing the command', false, '2003-07-30 15:47:20.650699+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'confdel', 'Really delete', true, '2003-07-30 15:48:17.276603+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'add', 'Add', true, '2003-07-30 15:49:59.534018+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'datsatznew', '<H3>Der Datensatz mu&szlig; zun&auml;chst neu geladen werden, da ein anderer Benutzer ihn bereits bearbeitet hat.</H3>', false, '2003-07-30 15:51:21.747832+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'datsatznew', '<H3>You first have to reload the record, because someone else already modified it.</H3>', false, '2003-07-30 15:52:29.247306+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'delrerr', 'This record cannot deleted: May be there is an childrecord belonging to values of this record or this record has been changed just before you want to delete it', false, '2003-07-30 15:59:08.738085+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'eexpr', 'Error int the embedded expression %s', false, '2003-07-30 16:00:15.519608+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'eingerr', '<TABLE><TR><TD>Inputerror in field:</TD><TD>%s.</TD><TR><TD>Message:</TD><TD>%s</TD></TR><TR><TD>Inputvalue:</TD><TD>%s</TD></TR></TABLE>', false, '2003-07-30 16:05:58.802791+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'erxtableend', 'Error in field ''xtableend'' of ''tabledesign'' for table %s', false, '2003-07-30 16:07:15.992372+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'erxtableend', 'Fehler im Feld ''xtableend'' von ''tabledesign'' fr die Tabelle %s', false, '2003-07-30 16:07:46.126663+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'function', 'function', false, '2003-07-30 16:13:09.226994+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'getfetchr', 'Error in ''fetch'' of data for the database', false, '2003-07-30 16:15:04.717067+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'mupdate', 'M_update', true, '2003-07-30 16:16:10.048165+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'newrec', 'New record', false, '2003-07-30 16:17:07.177061+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'noconnect', 'No database connection possible', false, '2003-07-30 16:18:00.908902+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nrowerror', 'Error in command for getting the number of rows: %s', false, '2003-07-30 16:19:25.877577+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'preperror', 'Error in the prepare-command for database %s', false, '2003-07-30 16:20:26.127537+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'print', 'Printview', true, '2003-07-30 16:21:26.401264+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'delete', 'Delete', true, '2003-07-30 16:23:36.316258+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'repoerg', 'Report succesfully started or done', false, '2003-07-30 16:25:32.086696+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'reponoerg', 'Report not succesfully done', false, '2003-07-30 16:26:17.765712+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'reporterg', 'Report result', false, '2003-07-30 16:27:33.848591+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'reports', 'Reports', false, '2003-07-30 16:29:08.388557+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'reset', 'Reset', true, '2003-07-30 16:29:55.84733+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'search', 'Search', true, '2003-07-30 16:31:02.401278+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'specialselect', 'Special search', false, '2003-07-30 16:32:50.89648+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sysfehl', 'Systemerror: %s for %s %s', false, '2003-07-30 16:33:48.908763+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tables', 'Tables', false, '2003-07-30 16:36:42.762733+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'unbekdb', 'Unknown database %s', false, '2003-07-30 16:37:40.886135+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'undef', 'undefined', false, '2003-07-30 16:38:07.186205+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'unznot', 'Unable to save the userinformations', false, '2003-07-30 16:40:09.847734+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'unzben', 'Userinformations not existent', false, '2003-07-30 16:40:29.936562+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'unzuser', 'Unlssige Angaben fr die Benutzung', false, '2003-07-30 16:40:53.238001+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'unzuser', 'Incorrect userinformations', false, '2003-07-30 16:41:30.663801+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'update', 'Update', true, '2003-07-30 16:42:08.206328+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'usedbnot', 'Using datenbase ''%s'' for this user not allowed', false, '2003-07-30 16:43:40.295251+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'usererror', 'Uncorrect character in the username %s. Possible are only the following character: ''A-z'', ''a-z'' and ''_''', false, '2003-07-30 16:45:16.721533+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'usermust', 'Username or password missing', false, '2003-07-30 16:46:12.69647+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'virterror', 'Error in ''virtual''-field %s', false, '2003-07-30 16:47:16.737303+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'xtableerror', 'Error in field ''xtablestart'' of ''tabledesign'' for Table %s', false, '2003-07-30 16:48:06.66557+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'xtableerror', 'Fehler im Feld ''xtablestart'' von ''tabledesign'' fr die Tabelle %s', false, '2003-07-30 16:48:40.157833+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user', 'Benutzername', false, '2003-07-30 17:41:42.272615+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user', 'Username', false, '2003-07-30 17:42:02.430167+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'passwd', 'Passwort', false, '2003-07-30 17:43:58.184303+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'passwd', 'Password', false, '2003-07-30 17:44:13.822415+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'database', 'Database', false, '2003-07-30 17:45:43.58414+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'valueranges', 'Wertebereiche', false, '2003-07-30 18:06:52.64691+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nombrecs', 'Anzahl der gefundenen Eintrge', false, '2003-07-30 18:10:29.047184+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nombrecs', 'Quantity of found records', false, '2003-07-30 18:12:16.126566+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'valueranges', 'Datadictionaries', false, '2003-07-31 14:10:32.784843+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbasename', 'Datenbank', false, '2003-09-10 17:26:04.099537+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbasename', 'Database', false, '2003-09-10 17:26:23.833148+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tablename', 'Tabelle', false, '2003-09-10 17:37:44.812769+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tablename', 'Table', false, '2003-09-10 17:38:16.51029+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'displaycolumn', 'Anzeigespalte', false, '2003-09-10 17:46:50.719964+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'displaycolumn', 'Displaycolumn', false, '2003-09-10 17:54:17.420772+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'displayinfo', 'Anzeigetyp', false, '2003-09-10 17:55:43.410046+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'displayinfo', 'Displaytype', false, '2003-09-10 17:56:02.045143+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'displayorder', 'Anzeigenummer', false, '2003-09-10 17:57:42.011115+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'displayorder', 'Displayorder', false, '2003-09-10 17:58:02.978236+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'displaystring', 'Anzeigename', false, '2003-09-10 17:58:59.300189+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'displaystring', 'Displaystring', false, '2003-09-10 17:59:18.536773+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dispdfield', 'Zusatz 3', false, '2003-09-10 18:05:00.911259+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dispvfield', 'Zusatz 2', false, '2003-09-10 18:05:50.297291+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'disptable', 'Zusatz 1', false, '2003-09-10 18:09:23.399393+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dispdfield', 'Additional 3', false, '2003-09-10 18:10:24.702239+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'disptable', 'Additional 1', false, '2003-09-10 18:11:33.622645+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dispvfield', 'Additional 2', false, '2003-09-10 18:11:58.35945+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actionname', 'Aktion', false, '2003-09-10 18:21:49.339849+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actionorder', 'Reihenfolge', false, '2003-09-10 18:24:01.509367+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actionorder', 'Order', false, '2003-09-10 18:24:26.174991+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'actiontext', 'Anweisungen', false, '2003-09-10 18:25:48.754443+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actiontext', 'Statements', false, '2003-09-10 18:26:26.300338+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'report', 'Bericht', false, '2003-09-10 18:30:45.418248+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'report', 'Report', false, '2003-09-10 18:31:00.004227+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'display', 'Anzeige', false, '2003-09-11 09:00:42.899572+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'display', 'Display', false, '2003-09-11 09:01:29.01995+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'content', 'Inhalt', false, '2003-09-11 09:02:02.659481+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'content', 'Contents', false, '2003-09-11 09:02:28.349438+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'orderno', 'Reihenfolge', false, '2003-09-11 09:02:59.213215+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'orderno', 'Ordering', false, '2003-09-11 09:03:27.4613+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'rowspan', 'Zeilenzahl', false, '2003-09-11 10:02:16.329545+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'rowspan', 'Rowspan', false, '2003-09-11 10:02:33.649809+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'colspan', 'Spaltenzahl', false, '2003-09-11 10:02:54.939514+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'colspan', 'Colspan', false, '2003-09-11 10:03:13.499776+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tableart', 'Tabellenart', false, '2003-09-11 10:16:17.332434+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tableart', 'Tableart', false, '2003-09-11 10:16:31.861439+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'needsvirtuals', 'Virtuelle Felder', false, '2003-09-11 12:10:58.774801+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'needsvirtuals', 'Virtual fields', false, '2003-09-11 12:11:21.669645+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'fieldlist', 'Feldliste', false, '2003-09-11 12:14:58.740227+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'fieldlist', 'Fieldlist', false, '2003-09-11 12:16:00.850487+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'modifyablelist', 'Liste modifizierbar', false, '2003-09-11 12:24:09.98698+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'modifyablelist', 'List modifyable', false, '2003-09-11 12:24:33.058748+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'userlist', 'Zulssige  Benutzer', false, '2003-09-11 12:27:14.179715+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'userlist', 'Allowed user', false, '2003-09-11 12:27:38.790583+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'childorder', 'Reihenfolge', false, '2003-09-11 12:32:00.960669+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'childorder', 'Ordering', false, '2003-09-11 12:32:21.498068+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'child', 'Kindtabelle', false, '2003-09-11 12:34:11.509367+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'child', 'Childtable', false, '2003-09-11 12:34:27.629597+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'childfield', 'Field of the childtable', false, '2003-09-11 12:36:15.979789+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'childfield', 'Feld der Kindtabelle', false, '2003-09-11 12:36:22.838988+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'parent', 'Elterntabelle', false, '2003-09-11 12:37:17.139469+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'parent', 'Parenttable', false, '2003-09-11 12:37:35.050183+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'parentfield', 'Feld der Elterntabelle', false, '2003-09-11 12:38:42.588716+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'parentfield', 'Field of the parenttable', false, '2003-09-11 12:38:59.904265+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'childcheck', 'Kindtabelle prfen', false, '2003-09-11 13:22:30.846888+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'childcheck', 'Check of the Childtable', false, '2003-09-11 13:22:55.108748+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'fieldtype', 'Typ', false, '2003-09-11 13:25:41.309743+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'fieldtype', 'Type', false, '2003-09-11 13:25:52.79739+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'name', 'Bezeichner', false, '2003-09-11 13:31:39.406795+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'name', 'Name', false, '2003-09-11 13:32:01.962675+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'language', 'Sprache', false, '2003-09-11 13:35:22.878449+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'language', 'Language', false, '2003-09-11 13:35:35.99906+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'translation', 'Outputtext', false, '2003-09-11 13:36:48.385088+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'translation', 'Ausgabetext', false, '2003-09-11 13:36:59.318514+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'comment', 'Bemerkung', false, '2003-09-11 13:38:43.518749+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'comment', 'Comment', false, '2003-09-11 13:38:54.584641+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'value', 'Wert', false, '2003-09-11 13:39:46.619148+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'value', 'Value', false, '2003-09-11 13:40:13.348563+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'actionname', 'Action or Report', false, '2003-09-12 14:41:49.271475+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'selectonly', 'Als ''Extra Suchbefehl'' ist nur ein SELECT erlaubt', false, '2003-09-26 11:33:51.465248+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'selectonly', 'Only a SELECT-Statement is for the ''Extra Searchcommand'' allowed', false, '2003-09-26 11:34:56.254483+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'nosubsel', 'Im ''Extra Suchbefehl'' sind keine Subselects erlaubt', false, '2003-09-29 08:42:28.871754+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'nosubsel', 'In ''Extra searchcommand'' there is no subselect allowed', false, '2003-09-29 08:43:18.476265+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tabmustfirst', 'Im ''Extra Suchbefehl'' muss nach dem ''FROM'' als erste Tabelle die Tabelle der Maske stehen', false, '2003-09-29 08:44:42.583114+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tabmustfirst', 'In ''Extra searchcommand'' may be after the ''FROM'' as first table only the table of the mask', false, '2003-09-29 08:47:15.343829+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'detailtables', 'Details', false, '2004-03-09 10:35:10.82726+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'ext_result', 'Ergebnis extern', false, '2004-02-13 08:57:45.025393+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'ext_result', 'External result', false, '2004-02-13 08:58:18.684125+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'in_list', 'Anzeigen', false, '2004-02-13 12:14:45.547217+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'in_list', 'Show', false, '2004-02-13 12:15:09.641321+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'ac_manage_user', 'Benutzerverwaltung', false, '2004-03-22 14:32:06.960013+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_langtexts', 'Sprachspezifische Texte', false, '2004-03-22 14:52:29.977551+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_description', 'Beschreibung', false, '2004-03-05 18:35:18.217766+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'configname', 'Name', false, '2004-02-19 17:54:19.357961+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'configname', 'Name', false, '2004-02-19 17:54:39.428522+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_description', 'Description', false, '2004-03-05 18:35:35.296639+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'configvalue', 'Value', false, '2004-02-19 17:56:23.130445+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'configvalue', 'Wert', false, '2004-02-19 17:57:23.54608+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_owner', 'Eigentmer der Datenbank', false, '2004-03-05 18:41:14.648246+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_owner', 'Database owner', false, '2004-03-05 18:41:38.817676+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_basedesign', 'Tabellendefinition', false, '2004-03-09 10:09:09.142522+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_basedesign', 'Tabledefinition', false, '2004-03-09 10:09:30.108304+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_tabledesign', 'Listingdesign', false, '2004-03-09 10:16:04.383032+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_tabledesign', 'Listingdesign', false, '2004-03-09 10:16:31.102005+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_action', 'Aktions-/Berichtsdefinition', false, '2004-03-09 10:17:25.344265+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_action', 'Actions-/reports-definition', false, '2004-03-09 10:17:57.618945+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_relation', 'Definition von Tabellenbeziehungen', false, '2004-03-09 10:18:37.555293+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_relation', 'Definition of tablerelations', false, '2004-03-09 10:19:32.590233+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_virtual', 'Definition berechneter Felder', false, '2004-03-09 10:20:17.416684+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_virtual', 'Definition of computed fields', false, '2004-03-09 10:21:05.559543+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_dbengine_user', 'Definition of database-users', false, '2004-03-09 10:22:29.272783+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_dbengine_user', 'Definition zulssiger Datenbanknutzer', false, '2004-03-09 10:23:23.860417+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_equation', 'Definition von Unterprogrammen', false, '2004-03-09 10:24:04.558925+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_equation', 'Subroutinedefinitions', false, '2004-03-09 10:24:33.428105+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_databaseconfigs', 'Datenbankspez. Konfigurationen', false, '2004-03-09 10:25:15.533967+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_databaseconfigs', 'Databasespec. konfigurations', false, '2004-03-09 10:25:49.669504+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_configs', 'Konfigurationswerte', false, '2004-03-09 10:28:24.5188+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_configs', 'Konfigurationtable', false, '2004-03-09 10:28:52.635997+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_langtexts', 'Languagespec. texts', false, '2004-03-09 10:30:10.567823+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_valuelist', 'Wertbereichsdefinitionen', false, '2004-03-09 10:31:15.873076+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_valuelist', 'Definitionen of Valueranges', false, '2004-03-09 10:31:29.892402+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'maintables', 'Grundformulare', false, '2004-03-09 10:33:29.92348+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'maintables', 'Mainforms', false, '2004-03-09 10:33:49.810865+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'detailtables', 'Details', false, '2004-03-09 10:36:08.366834+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'r_designinfo', 'Maskendefinition', false, '2004-03-09 10:42:25.615083+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'r_designinfo', 'Definition of Masks', false, '2004-03-09 10:42:46.556245+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_create', 'Datenbank erzeugen', true, '2004-03-09 12:43:38.138816+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_create', 'Create database', true, '2004-03-09 12:43:56.509788+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_delete', 'Datenbank lschen', true, '2004-03-09 12:44:14.939347+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_delete', 'Delete database', true, '2004-03-09 12:44:46.309655+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'ac_manage_user', 'User-management', false, '2004-03-11 13:47:27.6419+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_passwd2', 'Passwort besttigen', false, '2004-03-11 16:48:49.881572+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_passwd2', 'Verify password', false, '2004-03-11 16:49:11.449961+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'global_SQL', 'SQL - Schnittstelle', false, '2004-10-17 16:35:57.349073+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'global_SQL', 'SQL-commands', false, '2004-10-18 16:26:21.258647+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_can_createdb', 'Darf Datenbanken erzeugen', false, '2004-03-11 16:52:55.468289+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_can_createdb', 'Can create databases', false, '2004-03-11 16:53:20.391574+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_can_createuser', 'Darf Benutzer erzeugen', false, '2004-03-11 17:26:29.217717+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_can_createuser', 'Can create user', false, '2004-03-11 17:26:52.958867+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user_delete', 'Benutzer lschen', true, '2004-03-11 17:28:43.691778+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user_delete', 'Delete user', true, '2004-03-11 17:29:08.442128+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user_create', 'Benutzer erzeugen', true, '2004-03-11 17:29:35.36279+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'description', 'Beschreibung', false, '2004-03-15 16:23:36.423095+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'description', 'Description', false, '2004-03-15 16:24:21.273092+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema', 'Benutzte Schemata', false, '2004-03-16 14:22:05.257576+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema', 'Used schemas', false, '2004-03-16 14:22:27.926735+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'def_schema', 'Wenn kein Schema angekreuzt wird, gilt der Standardwert zur Tabellensuche.', false, '2004-03-22 09:47:37.339285+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'def_schema', 'If there is none of the schemas choosed the system will take the default value for searching tables.', false, '2004-03-22 09:58:20.464543+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'only_public', 'Nur ffentliche', false, '2004-03-16 15:10:42.662346+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'only_public', 'Public only', false, '2004-03-16 15:11:24.948623+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema_manage', 'Schemaverwaltung', false, '2004-03-22 14:30:16.637861+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_db_cr', '<H3>Die folgenden Daten nur eintragen beim Erzeugen einer neuen Datenbank.</H3>', false, '2004-03-12 12:39:07.399683+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'stitle', 'Auswahl der Schemata fr die Datenbank %s', false, '2004-03-19 11:03:03.334753+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_db_cr', '<H3>The following data are only needed for the creation of new databases.</H3>', false, '2004-03-12 12:40:04.589516+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'stitle', 'Choose the schemas for the database %s', false, '2004-03-19 11:03:46.575017+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'pschemas', 'Mgliche Schemata', false, '2004-03-19 11:27:05.649915+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'ac_dbcreate', 'Database-management', false, '2004-03-12 13:35:07.782917+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'table_management', 'Table-management', false, '2004-03-12 13:35:42.463883+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'pschemas', 'Possible schemas', false, '2004-03-19 11:27:35.135471+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'ac_dbcreate', 'Datenbankverwaltung', false, '2004-03-22 14:31:52.980572+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'table_management', 'Tabellenverwaltung', false, '2004-03-22 14:32:19.52108+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema_manage', 'Schema-management', false, '2004-03-22 14:33:52.937578+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'noschemas', 'Fehler beim Lesen der Schemata aus der Datenbankl', false, '2004-03-22 15:00:51.4801+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tableprint', 'Einzelsatz von<BR>%s', false, '2004-03-12 14:41:02.694454+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tableprint', 'Single record of<BR>%s', false, '2004-03-12 14:41:43.366438+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'tablemask', 'Eingabemaske<BR>%s', false, '2004-03-12 14:42:49.125595+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'tablemask', 'Mask<BR>%s', false, '2004-03-12 14:43:24.547109+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'records', 'Ergebnisliste<BR>%s', false, '2004-03-12 14:45:34.308142+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'records', 'Resultlisting<BR>%s', false, '2004-03-12 14:46:05.813458+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_create_ok', 'Datenbank %s erfolgreich erzeugt.', false, '2004-03-15 10:39:07.668202+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_create_ok', 'Database %s successfully created.', false, '2004-03-15 10:39:25.362742+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_delete_ok', 'Datenbank %s erfolgreich gelscht.', false, '2004-03-15 10:39:49.959515+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_delete_ok', 'database %s succesfully deleted.', false, '2004-03-15 10:40:10.591767+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_comment_ok', 'Datenbankkommentar fr Datenbank %s erfolgreich eingetragen.', false, '2004-03-15 10:41:07.610674+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_comment_ok', 'Comment for database %s successfully included.', false, '2004-03-15 10:41:54.171587+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user_create', 'Create user', true, '2004-03-15 10:51:39.039975+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'no_allowed_schem', 'Fr die Datenbank %s und den user %s gibt es kein erlaubtes Datenbankschema', false, '2004-07-01 12:10:50.955342+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user_delete_ok', 'Benutzer %s erfolgreich gelscht.', false, '2004-03-15 10:53:25.332701+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user_delete_ok', 'User %s succesfully deleted.', false, '2004-03-15 10:53:42.176291+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'noschemas', 'Error searching the schemas in the database', false, '2004-03-22 15:01:49.458623+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schemaname', 'Name des Schemas', false, '2004-03-22 15:02:53.11277+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schemaname', 'Name of the schemas', false, '2004-03-22 15:03:33.149901+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_schema_cr', 'Folgende Daten sind nur beim Erzeugen eines Schemas erforderlich:', false, '2004-03-22 15:05:45.238013+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_schema_cr', 'The following datas are only necessary if creating a schema:', false, '2004-03-22 15:07:39.875526+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schem_owner', 'Eigentmer des Schemas', false, '2004-03-22 15:09:41.654618+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schem_owner', 'Owner of the schema', false, '2004-03-22 15:10:07.820869+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema_delete', 'Schema lschen', true, '2004-03-22 15:12:00.533834+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema_delete', 'Delete schema', true, '2004-03-22 15:12:23.310385+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema_create', 'Create schema', true, '2004-03-22 15:12:36.111437+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema_create', 'Schema erzeugen', true, '2004-03-22 15:12:55.90671+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'illeg_date', 'Unzulssige Datumseingabe: ''%s''', false, '2005-01-28 11:54:00.901643+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'SQL_sel', 'Choose a SQL-command:', false, '2004-10-17 15:40:20.087335+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'SQL_do_button', 'SQL Auswahl', true, '2004-10-17 16:29:43.439276+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_user_cr', '<H3>Die folgenden Daten nur eintragen beim Erzeugen oder ndern eines Benutzers.</H3>', false, '2004-04-05 17:52:24.321613+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_user_cr', '<H3>The following data are only needed for changing or creating of users.</H3>', false, '2004-04-05 17:53:11.151114+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'no_found_schem', 'Fr die Datenbank %s und den user %s wurde kein Datenbankschema gefunden', false, '2004-07-01 12:16:05.249194+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'no_found_schem', 'For database %s and user %s no schema found', false, '2004-07-01 12:17:31.283448+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user_change', 'Benutzer ndern', true, '2004-04-06 12:16:52.525825+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user_change', 'Change user', true, '2004-04-06 12:17:10.868213+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'var_reset', 'Variable rcksetzen?', false, '2004-04-06 12:33:25.612619+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'var_reset', 'Reset variable?', false, '2004-04-06 12:33:47.558242+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'f_not_open', 'Datei ''%s'' nicht zu ffnen.', false, '2004-04-06 13:51:29.132358+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'f_not_open', 'Unable to open file ''%s''.', false, '2004-04-06 13:52:14.729815+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_encrypt', 'Passwort verschlsseln?', false, '2004-04-06 14:23:57.737044+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_encrypt', 'Encrypt password?', false, '2004-04-06 14:24:20.037404+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'SQL_sel', 'Auswahl des SQL-Befehls', false, '2004-10-17 16:29:54.842487+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'SQL_do_button', 'Choose', true, '2004-10-17 16:30:23.60216+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_variables', '<H4>Setting/resetting of variables:</H4>', false, '2004-04-06 14:28:15.919213+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_variables', '<H4>Variablen setzen/rcksetzen:</H4>', false, '2004-04-06 14:29:07.809631+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_passwd', '<H4>Passwort setzen/ndern:</H4>', false, '2004-04-06 14:30:08.674684+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_passwd', '<H4>Passwort setting/changing:</H4>', false, '2004-04-06 14:30:35.409373+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'db_rights', '<H4>Userrights:</H4>', false, '2004-04-06 14:33:20.072795+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'db_rights', '<H4>Benutzerrechte:</H4>', false, '2004-04-06 14:33:45.662182+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'user_create_ok', 'Benutzer %s erfolgreich erzeugt bzw. gendert.', false, '2004-04-06 15:29:33.881857+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'user_create_ok', 'User %s succesfully created or changed.', false, '2004-04-06 15:29:55.820237+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'SQL_exe_button', 'SQL Ausfhren', true, '2004-10-18 14:50:37.028455+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'SQL_exe_button', 'Execute SQL', true, '2004-10-18 14:51:01.04609+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'global_SQL_do', 'SQL - Parametrierung', false, '2004-10-18 16:25:52.709986+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'global_SQL_do', 'Parameters for the SQL-command', false, '2004-10-18 16:27:32.388885+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'illeg_date', 'Illegal dateformat: ''%s''', false, '2005-01-28 11:54:11.250472+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema_grant_name', 'Liste zulssiger Benutzer des neuen Schemas', false, '2004-10-12 16:31:57.230408+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'schema_grant_mode', 'Liste zulssiger Privilegien fr Benuzer des neuen Schemas', false, '2004-10-12 16:47:44.901634+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema_grant_mode', 'List of possible privileges for the users of the new schema', false, '2004-10-12 16:48:17.933457+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'schema_grant_name', 'List of possible users for the new schema', false, '2004-10-12 16:48:52.352009+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'no_allowed_schem', 'For database %s and user %s exists no schema', false, '2004-10-12 17:53:00.01259+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sch_cr', 'Schema %s erfolgreich erzeugt.', false, '2004-10-12 18:24:51.224903+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sch_cr', 'Schema %s successfully created', false, '2004-10-12 18:25:30.112503+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sch_del', 'Schema %s erfolgreich gelscht.', false, '2004-10-12 18:25:51.931473+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sch_del', 'Schema %s successfully deleted', false, '2004-10-12 18:26:19.730898+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sch_no_cr', 'Schema %s konnte nicht erzeugt werden.', false, '2004-10-12 18:27:47.523351+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sch_no_cr', 'Impossible to create schema %s.', false, '2004-10-12 18:29:17.178852+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sch_no_del', 'Schema %s konnte nicht gelscht werden.', false, '2004-10-12 18:30:02.093467+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sch_no_del', 'Impossible to delete schema %s.', false, '2004-10-12 18:30:25.091637+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'sch_no_name', 'Unzulssige Zeichen in der Definition von Bezeichner ''%s''', false, '2004-10-14 17:16:35.459125+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'sch_no_name', 'forbidden character in string ''%s''', false, '2004-10-14 17:22:54.399237+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'wherep', 'WHERE, ... - Teil', false, '2004-10-18 16:32:21.022633+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'wherep', 'WHERE, ... - part', false, '2004-10-18 16:32:40.58676+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'fromp', 'FROM - Teil', false, '2004-10-18 16:32:57.135068+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'fromp', 'FROM - part', false, '2004-10-18 16:33:07.148727+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'intop', 'INTO - Wert', false, '2004-10-18 16:33:18.8665+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'intop', 'INTO - value', false, '2004-10-18 16:33:32.101647+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'selectp', 'SELECT - Werte', false, '2004-10-18 16:33:44.940054+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'selectp', 'SELECT - values', false, '2004-10-18 16:33:56.517399+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'SQL_command', 'SQL - Befehl', false, '2004-10-18 16:34:59.844202+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'SQL_command', 'SQL - command', false, '2004-10-18 16:35:16.619951+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'global_SQL_execute', 'Ergebnis des SQL - Befehls', false, '2004-10-19 09:02:37.253933+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'global_SQL_execute', 'Result of the SQL - command', false, '2004-10-19 09:03:06.729982+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'noaction', 'Keine Aktion mit Namen ''%s'' in ''%s'' gefunden.', false, '2004-10-19 10:07:41.755661+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'noaction', 'No action named ''%s'' in ''%s'' found.', false, '2004-10-19 10:08:07.993729+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'compl_cmd', 'Command:', false, '2004-10-19 10:35:05.46376+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'compl_cmd', 'Befehl:', false, '2004-10-19 10:35:13.858288+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'extrableitem', 'Error in field xtableitem', false, '2005-03-13 18:02:15.103113+01');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'SQL_help_button', 'Auswahl-Hilfe', true, '2004-10-19 15:03:24.045531+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'SQL_help_button', 'Choose-help', true, '2004-10-19 15:03:44.006633+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'no_hlp_fd', 'Keinen Hilfetext gefunden', false, '2004-10-20 10:50:48.25848+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'no_hlp_fd', 'No helptext found', false, '2004-10-20 10:51:12.024993+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'helpfile', 'Hilfetexte', false, '2004-10-20 11:50:54.11299+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'helpfile', 'Helptexts', false, '2004-10-20 11:51:09.98436+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'helpname', 'Hilfegruppe', false, '2004-10-20 11:52:01.851515+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'helpname', 'Helpgroup', false, '2004-10-20 11:52:31.469128+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'helptext', 'Hilfetext', false, '2004-10-20 11:52:52.066466+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'helptext', 'Helptext', false, '2004-10-20 11:53:11.027327+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'doerror', 'Fehler beim Datenbank-Aufruf "do" fr die Datenbank ''%s''', false, '2005-10-28 09:44:53.666774+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'doerror', 'Error dbs-calling "do" for database ''%s''', false, '2005-10-28 09:46:17.233586+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'commiterror', 'Fehler bei COMMIT fr die Datenbank ''%s''', false, '2005-10-28 09:46:34.224058+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'commiterror', 'Error according to COMMIT for database ''%s''', false, '2005-10-28 09:46:48.527755+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'dbserror', 'Keine Datenbank fr das Datenbanksystem ''%s'' vorhanden', false, '2005-10-28 09:47:50.057219+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'dbserror', 'No existing database for the databasesystem ''%s''', false, '2005-10-28 09:48:26.399223+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'execerror', 'Fehler bei exec-Aufruf fr Datenbank ''%s''', false, '2005-10-28 09:49:06.659825+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'execerror', 'Error in exec-call for database ''%s''', false, '2005-10-28 09:49:32.563491+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('de', 'ferror', 'Fehler im Feld ''xxquerystring'' der Tabelle ''tabledesign'' fr die Tabelle ''%s''', false, '2005-10-28 09:50:05.625793+02');
INSERT INTO langtexts ("language", indextext, translate_text, button, tmin) VALUES ('en', 'ferror', 'Error in field ''xxquerystring'' of table ''tabledesign'' for table ''%s''', false, '2005-10-28 09:50:21.838987+02');


--
-- Data for Name: relation; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO relation (parent, parentfield, child, childfield, childorder, childcheck, dbasename, tmin) VALUES ('parts', 'part_no', 'order_position', 'part_no', '2', false, 'dbengine_test_db', '2003-07-20 14:35:50.660385+02');
INSERT INTO relation (parent, parentfield, child, childfield, childorder, childcheck, dbasename, tmin) VALUES ('ordering', 'ord_no', 'order_position', 'ord_no', '1', false, 'dbengine_test_db', '2003-07-20 14:36:33.698122+02');
INSERT INTO relation (parent, parentfield, child, childfield, childorder, childcheck, dbasename, tmin) VALUES ('customer', 'cust_no', 'ordering', 'cust_no', '1', false, 'dbengine_test_db', '2003-07-20 14:38:19.431233+02');
INSERT INTO relation (parent, parentfield, child, childfield, childorder, childcheck, dbasename, tmin) VALUES ('suppliers', 'suppl_no', 'parts', 'suppl_no', NULL, false, 'dbengine_test_db', '2003-07-20 15:37:30.968894+02');
INSERT INTO relation (parent, parentfield, child, childfield, childorder, childcheck, dbasename, tmin) VALUES ('parts', 'part_no', 'parts', 'contained_in', '1', true, 'dbengine_test_db', '2003-07-22 10:04:51.006397+02');


--
-- Data for Name: tabledesign; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('essen', NULL, false, false, '"
<H1>Gefundene Stze in der Tabelle Essen:</H1>
"', NULL, NULL, '$_ .= " ORDER by Datum,Art";', 'gaeste', '2003-05-29 12:41:00.388336+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('hauptgerichte', NULL, false, false, '"
<H1>Gefundene Stze in der Tabelle Hauptgerichte:</H1>
"', NULL, NULL, '$_ .= " ORDER BY Hauptgericht";', 'gaeste', '2003-05-29 12:41:21.04752+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('nachspeisen', NULL, false, false, '"
<H1>Gefundene Stze in der Tabelle Nachspeisen:</H1>
"', NULL, NULL, '$_ .= " ORDER BY Nachspeise";', 'gaeste', '2003-05-29 12:41:45.18508+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('namen', NULL, false, false, '"
<H1>Gefundene Stze in der Tabelle Namen:</H1>
"', NULL, NULL, '$_ .= " ORDER by name";', 'gaeste', '2003-05-29 12:42:01.678108+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('vorspeisen', NULL, false, false, '"
<H1>Gefundene Stze in der Tabelle Vorspeisen:</H1>
"', NULL, NULL, '$_ .= " ORDER BY Vorspeise";', 'gaeste', '2003-05-29 12:42:17.037986+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('order_position', NULL, true, true, '$headerline = "<TH ALIGN=RIGHT>Ord_Pos</TH>" .  
              "<TH ALIGN=RIGHT>Ord_No</TH>" .
              "<TH>Order</TH>" .
              "<TH ALIGN=RIGHT>Part_No</TH>" .
              "<TH>Description</TH>" .
              "<TH ALIGN=RIGHT>Account" .
              "</TH><TH ALIGN=RIGHT>" .                  
              "Price</TH>";
$title;', '$line = "<TD ALIGN=RIGHT>" .
   $$rvalues{''ord_pos''} .
        "</TD><TD ALIGN=RIGHT>" . 
   $$rvalues{''ord_no''} . "</TD><TD>" . 
   $$rvalues{''order''} .
        "</TD><TD ALIGN=RIGHT>" . 
   $$rvalues{''part_no''} . "</TD><TD>" .
   $$rvalues{''partdescription''} .
        "</TD><TD ALIGN=RIGHT>" .
   $$rvalues{''account''} .
        "</TD><TD ALIGN=RIGHT>" .
   $$rvalues{''price''} . "</TD></TR>";
$line;
', NULL, '$_ . " ORDER BY ord_no,ord_pos"', 'dbengine_test_db', '2003-07-20 14:44:44.231066+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('ordering', NULL, true, true, '$headerline = "<TH>Ord_No</TH>" .  
              "<TH>Cust_No</TH>" .
              "<TH>Customer</TH>" .
              "<TH>Titel</TH>" .
              "<TH>Termin</TH>" .
              "<TH ALIGN=RIGHT>Total_Price" .
              "</TH><TH>Comment</TH>";
$title;', '$line = "<TD>" .
   $$rvalues{''ord_no''} ."</TD><TD>" . 
   $$rvalues{''cust_no''} . "</TD><TD>" . 
   $$rvalues{''cust_name''} . "</TD><TD>" . 
   $$rvalues{''titel''} . "</TD><TD>" .
   $$rvalues{''termin''} . "</TD>" .
        "<TD ALIGN=RIGHT>" .
   $$rvalues{''total_price''} . "</TD><TD>" .
   $$rvalues{''comment''} . "</TD></TR>";
$line;
', NULL, '$_ . " ORDER BY ord_no"', 'dbengine_test_db', '2003-07-20 14:44:59.842383+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('parts', NULL, true, true, '$headerline = "<TH ALIGN=RIGHT>Part_No</TH>" .  
              "<TH>Description</TH>" .
              "<TH ALIGN=RIGHT>Suppl_No</TH>" .
              "<TH>Supplier</TH>" .
              "<TH>Category</TH>" .
              "<TH ALIGN=RIGHT>Price</TH>" .
              "<TH ALIGN=RIGHT>Contained in</TH>";
$title;', '$line = "<TD ALIGN=RIGHT>" .
   $$rvalues{''part_no''} . "</TD><TD>" . 
   $$rvalues{''description''} .
   "</TD><TD ALIGN=RIGHT>" . 
   $$rvalues{''suppl_no''} . "</TD><TD>" . 
   $$rvalues{''suppliername''} . "</TD><TD>" .
   $$rvalues{''category''} .
   "</TD><TD ALIGN=RIGHT>" .
   $$rvalues{''price''} .
   "</TD><TD ALIGN=RIGHT>" .
   $$rvalues{''contained_in''} . "</TD></TR>";
$line;
', NULL, '$_ . " ORDER BY part_no"', 'dbengine_test_db', '2003-07-28 10:43:29.885135+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('langtexts', NULL, false, true, '$_;', NULL, NULL, '$_."ORDER BY indextext, language"', 'dbengine_info_db', '2003-07-30 15:53:08.258309+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('configs', NULL, false, true, '$_;', NULL, NULL, '$_."ORDER BY index"', 'dbengine_info_db', '2003-08-02 15:17:40.453111+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('dbengine_user', NULL, false, true, NULL, NULL, NULL, '$_."ORDER BY username"', 'dbengine_info_db', '2003-08-11 12:06:13.516493+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('basedesign', NULL, false, true, NULL, NULL, NULL, '$_."ORDER BY dbasename, tableart, tableorder"', 'dbengine_info_db', '2003-08-11 12:19:01.277896+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('equation', NULL, false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, eqname"', 'dbengine_info_db', '2003-08-11 12:22:58.079055+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('relation', NULL, false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, parent,child"', 'dbengine_info_db', '2003-08-11 12:23:37.557932+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('valuelist', NULL, false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, name,display"', 'dbengine_info_db', '2003-08-11 12:24:37.467965+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('inhalt', 'Pakete,Anzahl,Box,Typ', false, true, '"
<H1>Gefundene Stze in der Tabelle Inhalt:</H1>
"', NULL, NULL, '$_ .= " ORDER by Typ,Pakete";', 'disketten', '2003-09-11 11:25:17.17332+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('inhalt', 'Dokument,Ort,Ordner', false, false, '"
<H1>Gefundene Stze in der Tabelle Inhalt:</H1>
"', NULL, NULL, '$_ .= " ORDER by Ort,Ordner,Dokument";', 'dokumentation', '2003-09-11 11:26:08.124793+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('tabledesign', 'dbasename,tablename,tablefields,
modifyablelist,needsvirtuals,
xxquerystring,xtablestart,
xtableitem,xtableend', false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, tablename"', 'dbengine_info_db', '2003-09-11 11:57:43.401028+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('designinfo', 'dbasename,tablename,fieldname,
displaystring,
displayorder,displaycolumn,
displayinfo,
disptable,dispvfield,dispdfield,
rowspan,colspan,
xdefault,xevaluation
', false, true, NULL, NULL, NULL, '$_."ORDER BY dbasename, tablename,fieldname"', 'dbengine_info_db', '2003-09-11 12:03:49.54904+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('virtual', 'dbasename,tablename,
fieldname,fieldtype,
level,
xequation', false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, tablename, level, fieldname"', 'dbengine_info_db', '2003-10-19 14:10:04.559948+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('action', 'dbasename,
actionname,
report,
ext_result,
in_list,
actiontext,
displayname,
actionorder,
usernames
', false, true, NULL, NULL, NULL, '$_ . "ORDER BY dbasename, actionname', 'dbengine_info_db', '2004-10-12 14:01:28.268471+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('teil_ereignis', 'b.erg_no, b.erg_titel, b.erg_art_nam,
a.t_erg_anf, a.t_erg_end,
a.t_erg_no, a.t_erg_titel as t_erg_bes,
a.tn_nam,
a.erg_art_nam as t_erg_art,
a.t_ereignis', false, false, '$headerline = 
    "<TH>Ereignisart<BR>Ereignis<BR>Nr.</TH>" .
    "<TH>Teilereignisart<BR>Teilereignis<BR>" . 
         "Nr.</TH>" . 
    "<TH>Datum</TH>" .
    "<TH>Teilnehmer</TH>" .
    "<TH>Beschreibung</TH>";
$title;', 'my $datanf = $$rvalues{''t_erg_anf''};
my $datend = $$rvalues{''t_erg_end''};
$datanf = "$datanf<BR>&nbsp;-" .
          "&nbsp;&nbsp;$datend"
              if ($datanf ne $datend);
my $teiln = join('', '',split(/:::/,
           $$rvalues{''tn_nam''}));
my $erg_art = join('', '',split(/:::/,
           $$rvalues{''erg_art_nam''}));
my $t_erg_art = join('', '',split(/:::/,
           $$rvalues{''t_erg_art''}));
my $ereignis =
 &pr_textarea_bau($$rvalues{''t_ereignis''});
$line = "<TD>$erg_art<BR>----<BR>" .
        $$rvalues{''erg_titel''} .
        "<BR>----<BR>" .
        $$rvalues{''erg_no''} .
        "</TD><TD>$t_erg_art" .
        "<BR>----<BR>" .
        $$rvalues{''t_erg_bes''} .
        "<BR>----<BR>" .
        $$rvalues{''t_erg_no''} .
        "</TD><TD>" .  
   $datanf . "</TD><TD>" . 
   $teiln . "</TD><TD>" .
        "$ereignis</TD></TR>";
$line;', NULL, '$_ = ", ereignis b " . $_ .
   ($_ ? " AND " : " WHERE ") .
    "a.erg_no = b.erg_no " . 
    "ORDER BY b.erg_no, t_erg_anf, t_erg_end, t_erg_art"', 'ereignisse', '2005-07-03 12:50:51.985257+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('helpfile', 'dbasename,actionname,helpname,
languages,helptext
', false, true, '$_;', NULL, NULL, '$_."ORDER BY dbasename, actionname, languages"', 'dbengine_info_db', '2004-10-20 11:58:51.259548+02');
INSERT INTO tabledesign (tablename, tablefields, needsvirtuals, modifyablelist, xtablestart, xtableitem, xtableend, xxquerystring, dbasename, tmin) VALUES ('ereignis', 'erg_no, erg_titel,
erg_anf, erg_end,
tn_nam,
erg_art_nam,
ereignis', false, false, '$headerline = 
    "<TH>Ereignisart<BR>Ereignis<BR>NR.</TH>" .  
    "<TH>Datum<BR>Teilnehmer</TH>" .
    "<TH>Beschreibung</TH>";
$title;', 'my $datanf = $$rvalues{''erg_anf''};
my $datend = $$rvalues{''erg_end''};
$datanf = "$datanf<BR>&nbsp;-" .   
          "&nbsp;&nbsp;$datend"
             if ($datanf ne $datend);
my $teiln = join('', '',split(/:::/,
           $$rvalues{''tn_nam''}));
my $erg_art = join('', '',split(/:::/,
           $$rvalues{''erg_art_nam''}));
my $ereignis =
  &pr_textarea_bau($$rvalues{''ereignis''});
$line = "<TD>$erg_art<BR>----<BR>" .
        $$rvalues{''erg_titel''} .
        "<BR>----<BR>" .
        $$rvalues{''erg_no''} .
        "</TD><TD>" . 
   $datanf . "<BR>----<BR>" . 
   $teiln . "</TD><TD>" .
        "$ereignis</TD></TR>";
$line;', NULL, '$_ .= "ORDER BY erg_anf, erg_end, erg_art_nam"', 'ereignisse', '2006-03-12 15:24:54.317349+01');


--
-- Data for Name: valuelist; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'relationpopup', 1, 'relationpopup', 'dbengine_info_db', '1999-06-26 15:10:33+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'int', 1, 'int', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'float', 1, 'float', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'date', 1, 'date', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'text', 1, 'text', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '1', 1, '1', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '2', 1, '2', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '3', 1, '3', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '4', 1, '4', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '5', 1, '5', 'dbengine_info_db', '1999-06-26 15:10:34+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('level', '6', 1, '6', 'dbengine_info_db', '1999-06-26 15:17:12+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'serial', 1, 'serial', 'dbengine_info_db', '2003-01-02 14:06:10.47724+01');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('fieldtype', 'numeric', 1, 'numeric', 'dbengine_info_db', '2003-07-20 13:38:11.370549+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('tableart', 'lang(maintables)', 1, 'maintables', 'dbengine_info_db', '2003-09-11 08:52:12.980702+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('tableart', 'lang(valueranges)', 3, 'valueranges', 'dbengine_info_db', '2003-09-11 08:52:32.152697+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('tableart', 'lang(detailtables)', 2, 'detailtables', 'dbengine_info_db', '2003-09-11 08:52:52.670449+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'multiplepopup', 2, 'multiplepopup', 'dbengine_info_db', '2003-09-11 10:05:38.373533+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'popup', 3, 'popup', 'dbengine_info_db', '2003-09-11 10:05:54.346571+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'text', 6, 'text', 'dbengine_info_db', '2003-09-11 10:06:45.865344+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'textarea', 5, 'textarea', 'dbengine_info_db', '2003-09-11 10:06:59.040739+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'NONE', 11, 'NONE', 'dbengine_info_db', '2003-09-11 10:07:45.11709+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'VIRTUAL', 10, 'VIRTUAL', 'dbengine_info_db', '2003-09-11 10:09:32.305542+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'SERIAL', 20, 'SERIAL', 'dbengine_info_db', '2003-09-11 10:09:59.965912+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'COMPUTATION', 21, 'COMPUTATION', 'dbengine_info_db', '2003-09-11 10:10:09.940252+02');
INSERT INTO valuelist (name, display, orderno, content, dbasename, tmin) VALUES ('displayinfo', 'CURRENCY', 22, 'CURRENCY', 'dbengine_info_db', '2005-03-04 09:26:17.084867+01');


--
-- Data for Name: virtual; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO virtual (tablename, fieldname, fieldtype, "level", xequation, dbasename, tmin) VALUES ('order_position', 'partdescription', 'text', 2, 'my ($n, $stdh) = &db_db_get_nrows(''dbase'',
                    qq{select description from parts where part_no = $$rvalues{''part_no''}});
my $rarray = &db_db_hashref($stdh);
my $wert = $$rarray{''description''};
$stdh->finish;
&dbprint_hash(7,"eval virtual: name=part_no, rarray",$rarray);
if ( $n > 1) {
   die("Not a unique row in the table");
} 

$_ = $wert;', 'dbengine_test_db', '2003-07-20 14:01:43.225239+02');
INSERT INTO virtual (tablename, fieldname, fieldtype, "level", xequation, dbasename, tmin) VALUES ('parts', 'suppliername', 'text', 4, 'my ($n, $stdh) = &db_db_get_nrows(''dbase'',qq{select suppl_name from suppliers where suppl_no = $$rvalues{''suppl_no''}});

my $rarray = &db_db_hashref($stdh);
my $wert = $$rarray{''suppl_name''};
$stdh->finish;

if($n > 1) {
   die("Not a unique row in the table");
   $wert = 0;
}

return($_ = $wert);', 'dbengine_test_db', '2003-07-20 14:03:59.381371+02');
INSERT INTO virtual (tablename, fieldname, fieldtype, "level", xequation, dbasename, tmin) VALUES ('order_position', 'order', 'text', 2, 'my ($n, $stdh) = &db_db_get_nrows(''dbase'',
                    qq{select titel from ordering where ord_no = $$rvalues{''ord_no''}});
my $rarray = &db_db_hashref($stdh);
my $wert = $$rarray{''titel''};
$stdh->finish;
&dbprint_hash(7,"eval virtual: name=ord_no, rarray",$rarray);
if ( $n > 1) {
   die("Not a unique row in the table");
} 

$_ = $wert;', 'dbengine_test_db', '2003-07-20 14:30:28.140941+02');
INSERT INTO virtual (tablename, fieldname, fieldtype, "level", xequation, dbasename, tmin) VALUES ('ordering', 'cust_name', 'text', 2, 'my ($n, $stdh) = &db_db_get_nrows(''dbase'',
                    qq{select cust_name from customer where cust_no = $$rvalues{''cust_no''}});
my $rarray = &db_db_hashref($stdh);
my $wert = $$rarray{''cust_name''};
$stdh->finish;
&dbprint_hash(7,"eval virtual: name=|$wert|, anz=|$n|, rarray",$rarray);
if ( $n > 1) {
   die("Not a unique row in the table");
} 

$_ = $wert;', 'dbengine_test_db', '2004-07-02 09:42:21.581701+02');
INSERT INTO virtual (tablename, fieldname, fieldtype, "level", xequation, dbasename, tmin) VALUES ('ordering', 'total_price', 'numeric', 2, 'my $stdh = &db_db_get(''dbase'',
                      qq{select sum(price) as total_price from order_position } .
                      qq{where ord_no = $$rvalues{''ord_no''}});
my $rarray = &db_db_hashref($stdh);
my $wert = $$rarray{''total_price''};
$stdh->finish;
&dbprint_hash(7,"eval virtual: name=|total_price|, wert=|$wert|, rarray",$rarray);

$_ = $wert;', 'dbengine_test_db', '2004-07-02 09:46:34.391585+02');


--
-- Name: action_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY "action"
    ADD CONSTRAINT action_pkey PRIMARY KEY (dbasename, actionname);


ALTER INDEX public.action_pkey OWNER TO postgres;

--
-- Name: basedesign_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY basedesign
    ADD CONSTRAINT basedesign_pkey PRIMARY KEY (dbasename, tablename);


ALTER INDEX public.basedesign_pkey OWNER TO postgres;

--
-- Name: configs_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY configs
    ADD CONSTRAINT configs_pkey PRIMARY KEY ("index");


ALTER INDEX public.configs_pkey OWNER TO postgres;

--
-- Name: databaseconfigs_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY databaseconfigs
    ADD CONSTRAINT databaseconfigs_pkey PRIMARY KEY (dbasename, configname);


ALTER INDEX public.databaseconfigs_pkey OWNER TO postgres;

--
-- Name: dbengine_user_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dbengine_user
    ADD CONSTRAINT dbengine_user_pkey PRIMARY KEY (dbasename);


ALTER INDEX public.dbengine_user_pkey OWNER TO postgres;

--
-- Name: designinfo_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY designinfo
    ADD CONSTRAINT designinfo_pkey PRIMARY KEY (dbasename, tablename, fieldname);


ALTER INDEX public.designinfo_pkey OWNER TO postgres;

--
-- Name: equation_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY equation
    ADD CONSTRAINT equation_pkey PRIMARY KEY (dbasename, eqname);


ALTER INDEX public.equation_pkey OWNER TO postgres;

--
-- Name: helpfile_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY helpfile
    ADD CONSTRAINT helpfile_pkey PRIMARY KEY (dbasename, actionname, helpname, languages);


ALTER INDEX public.helpfile_pkey OWNER TO postgres;

--
-- Name: langtexts_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY langtexts
    ADD CONSTRAINT langtexts_pkey PRIMARY KEY ("language", indextext);


ALTER INDEX public.langtexts_pkey OWNER TO postgres;

--
-- Name: relation_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY relation
    ADD CONSTRAINT relation_pkey PRIMARY KEY (parent, parentfield, child, childfield);


ALTER INDEX public.relation_pkey OWNER TO postgres;

--
-- Name: tabledesign_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tabledesign
    ADD CONSTRAINT tabledesign_pkey PRIMARY KEY (dbasename, tablename);


ALTER INDEX public.tabledesign_pkey OWNER TO postgres;

--
-- Name: valuelist_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY valuelist
    ADD CONSTRAINT valuelist_pkey PRIMARY KEY (display, name, dbasename);


ALTER INDEX public.valuelist_pkey OWNER TO postgres;

--
-- Name: virtual_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY virtual
    ADD CONSTRAINT virtual_pkey PRIMARY KEY (dbasename, tablename, fieldname);


ALTER INDEX public.virtual_pkey OWNER TO postgres;

--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: action; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE "action" FROM PUBLIC;
REVOKE ALL ON TABLE "action" FROM postgres;
GRANT ALL ON TABLE "action" TO postgres;
GRANT SELECT ON TABLE "action" TO PUBLIC;


--
-- Name: basedesign; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE basedesign FROM PUBLIC;
REVOKE ALL ON TABLE basedesign FROM postgres;
GRANT ALL ON TABLE basedesign TO postgres;
GRANT SELECT ON TABLE basedesign TO PUBLIC;


--
-- Name: configs; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE configs FROM PUBLIC;
REVOKE ALL ON TABLE configs FROM postgres;
GRANT ALL ON TABLE configs TO postgres;
GRANT SELECT ON TABLE configs TO PUBLIC;


--
-- Name: databaseconfigs; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE databaseconfigs FROM PUBLIC;
REVOKE ALL ON TABLE databaseconfigs FROM postgres;
GRANT ALL ON TABLE databaseconfigs TO postgres;
GRANT SELECT ON TABLE databaseconfigs TO PUBLIC;


--
-- Name: dbengine_user; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE dbengine_user FROM PUBLIC;
REVOKE ALL ON TABLE dbengine_user FROM postgres;
GRANT ALL ON TABLE dbengine_user TO postgres;
GRANT SELECT ON TABLE dbengine_user TO PUBLIC;


--
-- Name: designinfo; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE designinfo FROM PUBLIC;
REVOKE ALL ON TABLE designinfo FROM postgres;
GRANT ALL ON TABLE designinfo TO postgres;
GRANT SELECT ON TABLE designinfo TO PUBLIC;


--
-- Name: equation; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE equation FROM PUBLIC;
REVOKE ALL ON TABLE equation FROM postgres;
GRANT ALL ON TABLE equation TO postgres;
GRANT SELECT ON TABLE equation TO PUBLIC;


--
-- Name: helpfile; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE helpfile FROM PUBLIC;
REVOKE ALL ON TABLE helpfile FROM postgres;
GRANT ALL ON TABLE helpfile TO postgres;
GRANT SELECT ON TABLE helpfile TO PUBLIC;


--
-- Name: langtexts; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE langtexts FROM PUBLIC;
REVOKE ALL ON TABLE langtexts FROM postgres;
GRANT ALL ON TABLE langtexts TO postgres;
GRANT SELECT ON TABLE langtexts TO PUBLIC;


--
-- Name: relation; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE relation FROM PUBLIC;
REVOKE ALL ON TABLE relation FROM postgres;
GRANT ALL ON TABLE relation TO postgres;
GRANT SELECT ON TABLE relation TO PUBLIC;


--
-- Name: tabledesign; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE tabledesign FROM PUBLIC;
REVOKE ALL ON TABLE tabledesign FROM postgres;
GRANT ALL ON TABLE tabledesign TO postgres;
GRANT SELECT ON TABLE tabledesign TO PUBLIC;


--
-- Name: valuelist; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE valuelist FROM PUBLIC;
REVOKE ALL ON TABLE valuelist FROM postgres;
GRANT ALL ON TABLE valuelist TO postgres;
GRANT SELECT ON TABLE valuelist TO PUBLIC;


--
-- Name: virtual; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE virtual FROM PUBLIC;
REVOKE ALL ON TABLE virtual FROM postgres;
GRANT ALL ON TABLE virtual TO postgres;
GRANT SELECT ON TABLE virtual TO PUBLIC;


--
-- PostgreSQL database dump complete
--

